#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin (), (x).end ()
#define fi first
#define se second
#define sz(x) (int)((x).size ())
#define sqr(x) (x)*(x)

typedef long long ll;
typedef unsigned long long ull;

typedef long double ld;

using namespace std;

ll pw[15];

ll l, r, res;

inline void add_mod (ll &a, ll b, ll mod){
    a += b;

    if (a < 0){
        a += mod;
    }

    if (mod <= a){
        a -= mod;
    }
}

inline ll bin_mult (ll a, ll b, ll mod){
    ll res = 0;

    if (a < b){
        swap (a, b);
    }

    for (; b; b >>= 1){
        if (b & 1){
            add_mod (res, a, mod);
        }

        add_mod (a, a, mod);
    }

    return res;
}

inline ll bin_pow (ll a, ll b, ll mod){
    ll res = 1;

    for (; b; b >>= 1){
        if (b & 1){
            res = bin_mult (res, a, mod);
        }

        a = bin_mult (a, a, mod);
    }

    return res;
}

inline bool isP (ll v){
    if (v == 2){
        return 1;
    }

    for (int step = 1, p; step <= 30; ++ step){
        p = rand () % (v - 1) + 1;

        if (bin_pow (p, v - 1, v) != 1){
            return 0;
        }
    }

    return 1;
}

void rec (ll v, int len){
    if (v > r){
        return;
    }

    if (!isP (v)){
        return;
    }

    if (l <= v){
        ++ res;
    }

    for (int t = 1; t <= 9; ++ t){
        rec (t * pw[len] + v, len + 1);
    }
}

int main (){
    srand (time (0));

    scanf ("%lld %lld", &l, &r);

    pw[0] = 1;

    for (int i = 1; i < 15; ++ i){
        pw[i] = pw[i - 1] * 10;
    }

    for (int i = 2; i <= 10; ++ i){
        rec (i, 1);
    }

    printf ("%lld", res);
    return 0;
}
