#include <iostream>
#include <unordered_map>
#include <map>
#include <vector>
#include <cstring>

using namespace std;

const int N = (int)1e5 + 7;
const int inf = (int)1e6 + 3;

#define pb push_back

vector < map < int, int > > vec;

int fun (string s) {
    int start = 0;
    if (s[start] == '-') start++;
    int res = 0;
    for (int i = start; i < s.size(); i++) {
        res *= 10;
        res += (s[i] - '0');
    }
    if (start == 1) res *= -1;
    return res;
}

int get (string s) {
    int h = 0, pr = 991, pw;
    pw = pr;
    for(int i = 0; i < s.size(); i ++)
    {
        h += s[i] * pw;
        pw *= pr;
        pw %= inf;
        h %= inf;
    }
    return h;
}

int main () {
    char s[30];
    int lvl = 0;
    vec.pb(map < int, int > ());
    while (scanf ("%s", s) != EOF) {
        string s1, s2;
        if (s[0] == '{') {
            lvl++;
            vec.pb(vec[lvl - 1]);
        } else if (s[0] == '}') {
            vec.pop_back();
            lvl--;
        } else {
            bool p = 0;
            int sz = strlen(s);
            for (int i = 0; i < sz; i++) {
                if (s[i] == '=') {
                    p = 1;
                    continue;
                }
                if (!p) {
                    s1.push_back(s[i]);
                } else {
                    s2.push_back(s[i]);
                }
            }
            int q;
            if (s2[0] == '-' || isdigit(s2[0])) {
                q = fun(s2);
                vec[lvl][get(s1)] = q;
            } else {
                if (vec[lvl].count(get(s2))) {
                    q = vec[lvl][get(s2)];
                    vec[lvl][get(s1)] = q;
                    printf ("%d\n", q);
                } else {
                    printf ("0\n");
                }
            }
        }
    }
}
