#include <bits/stdc++.h>
using namespace std;

const int N = (int) 1e6 + 7;
const int MOD = (int) 1e9 + 7;

#define ll long long
#define lld long double
#define elif else if
#define int64 long long
#define LLMAX LONG_LONG_MAX
#define F first
#define S second
#define pb push_back
#define mp make_pair
#define sz size
#define fastio ios_base::sync_with_stdio(0)
#define by(T, x) [](const T& a, const T& b) {return a.x < b.x;}
#define all(x) (x.begin(), x.end())

const int P = 10;

ll pw(int x) {
	ll res = 1;
	while (x) {
		res *= 10;
		x--;
	}
	return res;
}

void add(ll& a, ll b) {
	a += b;
	if (a >= (ll) MOD) a -= MOD;
}

ll mul(ll a, ll b) {
	return (a * 1ll * b) % MOD;
}

int cnt(ll x) {
	int c = 0;
	while (x) {
		c++;
		x /= 10;
	}
	return c;
}

bool prime(int x) {
	if (x == 1 || x == 2) return false;
	int k = sqrt(x);
	for (int i = 2; i <= k; i++)
		if (x % i == 0) return false;
	return true;
}

typedef long long nis;

bool good(int x) {
	int cur = 0;
	vector<int> d;
	while (x) {
		if (x % 10 == 0) return false;
		d.push_back(x % 10);
		x /= 10;	
	}
	reverse(d.begin(), d.end());
	int res = 0;
	for (int i = 0; i < (int) d.size(); i++) {
		res = 0;
		for (int j = i; j < (int) d.size(); j++) {
			res = res * 10 + d[j];
		}
		if (!prime(res)) return false;
	}
	return true;
}

vector<nis> d;
int n = 0;
nis global = 0, ans = 0;

void restore(nis cur) {
	if (cur > global) return;
	if (cur <= global) ans++;
	for (int i = 1; i <= 9; i++) {
		nis nxt = 1ll * i * pw(cnt(cur)) + cur;
		if (!prime(nxt)) continue;
		restore(nxt);
	}
}

nis calc(nis x) {
	if (x == 0) return 0;
	global = x;
	while (x) {
		d.push_back(x % 10);
		x /= 10;
	}	
	reverse(d.begin(), d.end());
	ans = 0;
	n = (int) d.size();
	restore(3), restore(5), restore(7);	
	return ans;
}

int main() {
	/*freopen("out.txt", "w", stdout);
	int prevv = 0;
	for (int i = 1; i < N; i++) {
		if (good(i)) {
			cout << i - prevv << endl;
			prevv = 0;
		}
	}
	cout << (int) powf(6, 11);
	*/
	nis l, r;
	cin >> l >> r;
	cout << calc(r) - calc(l - 1);
	return 0;
}
                             