#include <bits/stdc++.h>

#define ll long long

#define f first
#define s second

using namespace std;

const int N = 1e6 + 10;

ll a, b;

int used[N];

int cnt = 0;

bool prime (ll x) {
    if (x == 1) return false;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b;
    for (int i = 2; i * i < N; i++) {
        if (!used[i]) {
            for(int j = i * i; j < N; j += i){
                used[j] = 1;
            }
        }
    }
    queue <pair <ll, ll> > q;
    q.push({2, 10});
    q.push({3, 10});
    q.push({5, 10});
    q.push({7, 10});
    while (!q.empty()) {
        ll x = q.front().f;
        ll add = q.front().s;
        q.pop();
        if (x >= a) cnt++;
        if (x == 2) continue;
        for (int j = 1; j < 10; j++) {
            if (add * j + x > b) break;
            if (add * j + x < N * 1LL) {
                if (!used[add * j + x]) q.push({add * j + x, add * 10LL});
            } else {
                if (prime(add * j + x)) q.push({add * j + x, add * 10LL});
            }
        }
    }
    cout << cnt;
    return 0;
}
