#include <bits/stdc++.h>

#define ll long long
#define int ll
#define all(v) v.begin(), v.end()
#define sz(v) (v.size())
#define pb push_back
#define vec vector<int>
#define pii pair<int, int>
#define f first
#define s second
#define mp make_pair

using namespace std;

const int N = (int) 1e5 + 10;
const int INF = (int) 1e9 + 7;

int n;
int a[N];
int l[N], r[N];
ll d[N], d1[N], d2[N];
vector<pii> g[N];
vec ids[N];
vec gr[N];

ll calc(ll len) {
    return len * (len + 1) / 2;
}

vec A, B, C;

void norm(int &x) {
    x %= INF;
    if (x < 0) x += INF;
}

void add(int &x,int y) {
    norm(y);
    x += y;
    norm(x);
}

int mult(int x, int y) {
    norm(x);
    norm(y);
    return x * 1ll * y % INF;
}

const int inv2 = 500000004;

int F(int x) {
    return x * (x + 1);
}

int calc() {
    int cur = 0;
    int sum1 = 0, sumA = 0, sum3 = 0;
    for (int i = 0; i < sz(A); i++) {
        for (int j = i + 1; j < sz(A); j++) {
            add(cur, mult(mult(A[i], B[j]), F(C[j] - C[i])));
         }
    }
    /*
    for (int i = 0; i < sz(A); i++) {
        add(cur, mult(mult(sumA, B[i]), mult(C[i], C[i])));
        add(cur, -2 * mult(sum3, mult(B[i], C[i])));
        add(cur, mult(sumA, mult(B[i], C[i])));
        add(cur, mult(sum1, B[i]));
        add(cur, -mult(sum3, B[i]));
        add(sum1, mult(A[i], mult(C[i], C[i])));
        add(sumA, A[i]);
        add(sum3, mult(A[i], C[i]));
    }
    */
    cur = mult(cur, inv2);
    return cur;
}

int solve(vector<pii> v, vec id) {
    for (int i = 1; i < sz(v); i++) {
        assert(v[i] >= v[i - 1]);
    }
    for (int i = 0; i < sz(v); i++) {
        d1[i] = (id[i] - v[i].f + 1);
        d2[i] = (v[i].s - id[i] + 1);
        d[i] = (d1[i] * d2[i]) % INF;
    }
    int ans = 0;
    for (int i = 0; i < sz(v); ) {
        int j = i;
        A.clear();
        B.clear();
        C.clear();
        while (j < sz(v) && v[i] == v[j]) {
            A.pb(d1[j]);
            B.pb(d2[j]);
            C.pb(id[j]);
            j++;
        }
        int val = calc();
        add(ans, val);
        i = j;
    }
    int j = 0;
    for (int i = 0; i < sz(v); i++) {
        if (i && v[i] != v[i - 1]) j++;
        gr[j].pb(id[i]);
    }
    v.resize(unique(all(v)) - v.begin());
    for (int i = 0; i < sz(v); i++) {
        d[i] = calc(v[i].s - v[i].f + 1);
        d[i] -= calc(gr[i][0] - v[i].f);
        d[i] -= calc(v[i].s - gr[i].back());
        for (int j = 1; j < sz(gr[i]); j++) {
            d[i] -= calc(gr[i][j] - gr[i][j - 1] - 1);
        }
        d[i] %= INF;
    }
    int pref = 0;
    for (int i = 0; i < sz(v); i++) {
        add(ans, mult(pref, d[i]));
        add(pref, d[i]);
    }
    for (int i = 0; i < sz(v); i++) {
        gr[i].clear();
    }
   // cout << " this shit equals to " << ans << endl << endl;
    return ans;
}

 main() {
    #ifdef witch
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // sony
    cin >> n;
    vec v;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        v.pb(a[i]);
    }
    sort(all(v));
    for (int i = 1; i <= n; i++) {
        a[i] = lower_bound(all(v), a[i]) - v.begin();
    }
    stack<int> st;
    for (int i = 1; i <= n; i++) {
        while (!st.empty() && a[st.top()] <= a[i]) st.pop();
        if (st.empty()) l[i] = 1;
        else l[i] = st.top() + 1;
        st.push(i);
    }
    while (!st.empty()) st.pop();
    for (int i = n; i >= 1; i--) {
        while (!st.empty() && a[st.top()] <= a[i]) st.pop();
        if (st.empty()) r[i] = n;
        else r[i] = st.top() - 1;
        st.push(i);
    }
    for (int i = 1; i <= n; i++) {
        g[a[i]].pb(mp(l[i], r[i]));
        ids[a[i]].pb(i);
    }
    int ans = 0;
    for (int i = 0; i < sz(v); i++) {
        add(ans, solve(g[i], ids[i]));
    }
    cout << ans;
    return 0;
}
