#include <iostream>
#include <string>

using namespace std;

const int MAXN = 2e6;
int used[MAXN], pref_sum[MAXN], s1, s2, t1, t2;
pair <int, int> ans[MAXN];
string s;

bool check(int len)
{
    for (int i = 0; i <= s.size(); i++)
    {
        used[i] = 0;
        ans[i].first = -1;
        ans[i].second = -1;
    }
    for (int i = 0; i <= s.size() - len; i++)
    {
        int ms = i == 0 ? 0 : pref_sum[i - 1];
        int sum = pref_sum[i + len - 1] - ms;
        used[sum]++;
        if (ans[sum].first != -1)
        {
            ans[sum].second = i + 1;
        }
        else
        {
            ans[sum].first = i + 1;
        }
        if (used[sum] >= 2)
        {
            s1 = ans[sum].first;
            t1 = s1 + len - 1;
            s2 = ans[sum].second;
            t2 = s2 + len - 1;
            return true;
        }
    }
    return false;
}
int bin_search()
{
    int l = 0;
    int r = s.size();
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (check(m))
            l = m;
        else
            r = m;
    }
    return l;
}

int main()
{
    cin >> s;
    pref_sum[0] = s[0] - '0';
    for (int i = 1; i < s.size(); i++)
    {
        int c = (s[i] - '0');
        pref_sum[i] = pref_sum[i - 1] + c;
    }
    int l = bin_search();
    check(l);
    cout << s1 << " " << t1 << " " << s2 << " " << t2 << endl;

    return 0;
}
