#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e5+100;
const ll INF = 2e18;

int n,us[3],num[3],usnow[3],usnow2[3];
ll ans,p1[N],p2[N],s1[N],s2[N];
vector<int>v,ql,qr;

ll fnr(ll pos){
    ll ans = 0;
    for(int i = 0; i < 3; ++i)
        usnow2[i] = usnow[i];
    for(auto it: qr)
        if(it <= pos){
            bool fl = false;
            for(int i = 1; i >= 0; --i)
                if(usnow2[i]){
                    --usnow2[i];
                    ans += abs(it-num[i]);
                    fl = true;
                    break;
                }
            if(!fl)
                return INF;
        } else
            if(usnow2[2]){
                --usnow2[2];
                ans += abs(num[2]-it);
            } else
                return INF;
    return ans;
}

ll fnl(ll pos){
    ll ans = 0;
    for(int i = 0; i < 3; ++i)
        usnow[i] = us[i];
    for(auto it: ql)
    if(it >= pos){
        bool fl = false;
        for(int i = 1; i < 3; ++i)
            if(usnow[i]){
                --usnow[i];
                ans += abs(num[i]-it);
                fl = true;
                break;
            }
        if(!fl)
            return INF;
    } else
        if(!usnow[0])
            return INF;
        else {
            --usnow[0];
            ans += abs(it-num[0]);
        }
    int l = num[1], r = num[2];
    ll s = INF;
    while(r-l > 4){
        int cnt = (r-l)/3;
        int posl = l+cnt, posr = r-cnt;
        ll ansl = fnr(posl), ansr = fnr(posr);
        if(ansl < ansr)
            r = posr, s = min(s,ansl);
        else
            l = posl, s = min(s,ansr);
    }
    for(int i = l; i <= r; ++i)
        s = min(s,fnr(i));
    return ans+(s == INF ? 0 : s);
}

ll solve(){
    int l = num[0], r = num[1];
    ll ans = INF;
    while(r-l > 4){
        int cnt = (r-l)/3;
        int posl = l+cnt, posr = r-cnt;
        ll ansl = fnl(posl), ansr = fnl(posr);
        if(ansl <= ansr)
            r = posr, ans = min(ans,ansl);
        else
            l = posl, ans = min(ans,ansr);
    }
    for(int i = l; i <= r; ++i)
        ans = min(ans,fnl(i));
    return (ans == INF ? 0 : ans);
}

int main()
{
    //freopen("input.txt","r",stdin);
    vector<pair<int,int> >pr;
    for(int i = 0; i < 3; ++i){
        int a,b;
        scanf("%d%d",&a,&b);
        pr.push_back({a,b});
    }
    sort(pr.begin(),pr.end());
    for(int i = 0; i < 3; ++i){
        num[i] = pr[i].first;
        us[i] = pr[i].second;
    }
    scanf("%d",&n);
    for(int i = 0; i < n; ++i){
        int x;
        scanf("%d",&x);
        v.push_back(x);
    }
    sort(v.begin(),v.end());
    for(auto it: v)
        if(it < num[0]){
            for(int i = 0; i < 3; ++i)
                if(us[i]){
                    --us[i];
                    ans += abs(num[i]-it);
                    break;
                }
        } else if(it > num[2]){
            for(int i = 2; i >= 0; --i)
                if(us[i]){
                    --us[i];
                    ans += abs(it-num[i]);
                    break;
                }
        } else if(it <= num[1])
            ql.push_back(it);
        else
            qr.push_back(it);
    reverse(qr.begin(),qr.end());
    printf("%lld",solve()+ans);
    return 0;
}
