#include <iostream>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>
#include <list>

using namespace std;

bool cz(long long int a) {
    for (int i = 1; i <= a; i *= 10)
        if (a / i % 10 == 0)
            return true;
    return false;
}

int main() {
    long long int a, b;
    cin >> a >> b;

    long long int s = sqrt(b) + 1;

    vector<bool> z(s + 1, true);
    z[0] = z[1] = false;

    for (int i = 2; i * i <= s; i++) {
        if (!z[i])
            continue;

        for (int j = i << 1; j <= s; j += i) {
            z[j] = false;
        }
    }
    list<int> primes;
    for (int i = 2; i <= s; i++)
        if (z[i]) {
            primes.push_back(i);
        }

    int n = 0;
    for (long long int i = a; i <= b; i++) {
        if (cz(i))
            continue;

        for (long long int j = 10; j <= i * 10; j *= 10) {
            long long int t = i % j;
            if (t <= s) {
                if (!z[t])
                    goto br;
            } else {
                for (auto y : primes) {
                    if (t % y == 0)
                        goto br;
                }
            }
        }

        n++;
        br:;
    }

    cout << n << endl;
}