#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    cin.tie({0});
    cin.sync_with_stdio(false);

    int n, m;
    cin >> n >> m;

    if (n != m + 1) {
        cout << "No" << endl;
        return 0;
    }

    set<int> nums;

    int l = -1;
    for (int i = 0; i < m; i++) {
        int tmp;
        cin >> tmp;
        if (tmp <= l) {
            cout << "No" << endl;
            return 0;
        }
        l = tmp;
        nums.insert(tmp);
    }

    if (nums.size() != m) {
        cout << "No" << endl;
        return 0;
    }

    vector<bool> anums(n, false);
    for (auto i : nums) {
        if (i < 1 || i > n) {
            cout << "No" << endl;
            return 0;
        }
        anums[i - 1] = true;
    }

    cout << "Yes" << endl;
    for (int i = 0; i < n; i++) {
        if (!anums[i])
            cout << i + 1 << endl;
    }
}