#include <fstream>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>

using namespace std;

#define fori(i,a,b) for(int i = a; i < b; i++)
#define ifor(i,a,b) for(int i = b-1; i >= a; i++)

//ifstream in("input.txt");
//ofstream out("output.txt");
//#define in cin
//#define out cout

int mod = 1e9 + 7;



int slowsolve()
{
	ifstream in("input.txt");
	int n;
	in >> n;
	vector <int> a;
	for (int i = 0; i < n; i++)
	{
		int t;
		in >> t;
		a.push_back(t);
	}
	long long ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			int q = 1, t = a[j];
			while (t > 0)
			{
				q *= 10;
				t /= 10;
			}
			if (i != j)
			{
				long long da = long long(a[i]) * q + a[j];
				ans += da;
				ans %= mod;
			}
		}
	}
	return ans;
}

int solve()
{
	ifstream in("input.txt");
	int n;
	cin >> n;
	long long ans = 0;
	vector <pair <long long, int>> a;
	vector <int> s(10, 0);
	fori(i, 0, n)
	{
		int t;
		cin >> t;
		a.push_back(make_pair(t, 0));
		int q = 0;
		while (t > 0)
		{
			q++;
			t /= 10;
		}
		s[q]++;
		a[i].second = q;
	}
	for (int i = 0; i < n; i++)
	{
		ans += ((long long(n - 1))*a[i].first)%mod;
		ans %= mod;
		long long q = 10;
		for (int j = 1; j < 10; j++)
		{
			if (a[i].second == j)
			{
				ans += ((long long(s[j] - 1))*((a[i].first*q)%mod)%mod);
				ans %= mod;
			}
			else
			{
				ans += ((long long(s[j]))*((a[i].first*q)%mod)%mod);
				ans %= mod;
			}
			q *= 10;
		}
	}
	return int(ans);
}

bool Checker()
{
	srand(clock());
	int n = rand() % int(2e5-2);
	n += 2;
	ofstream out("input.txt");
	out << n << endl;
	for (int i = 0; i < n; i++)
	{
		out << rand() % int(1e8 - 1) + 1 << " ";
	}
	out.close();
	int ans1 = slowsolve();
	int ans2 = solve();
	if (ans1 != ans2)
	{
		cout << ans1 << " " << ans2 << endl;
		return 1;
	}
	return 0;
}


int main() {
	//for (int i = 0; !Checker(); i++)
	//{}
	cout << solve();
	return 0;
}