#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
ll k;
const ll MAXN = 2e5 + 69;
const ll INF = 1e16 + 7;

ll a1, b1;
ll a2, b2;
ll a3, b3;
ll n;
ll p1[MAXN], p2[MAXN], s[MAXN];

ll a[MAXN];

ll t[8 * MAXN];

void build(ll v, ll tl, ll tr)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

ll get(ll v, ll tl, ll tr, ll l, ll r)
{
    if (l > r)
        return INF;
    if (tl == l && r == tr)
        return t[v];
    ll tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, min(r, tm)), get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);
    cin >> a1 >> b1 >> a2 >> b2 >> a3 >> b3;
    cin >> n;
    for (ll i = 0; i < n; ++i)
        cin >> a[i];
    sort(a, a + n);
    for (ll i = 0; i < MAXN; ++i)
        p1[i] = INF;
    for (ll i = 0; i < min(n, b1); ++i)
    {
        if (i == 0)
            p1[i] = abs(a[i] - a1);
        else
            p1[i] = p1[i - 1] + abs(a[i] - a1);
    }

    for (ll i = 0; i < n; ++i)
    {
        if (i == 0)
            p2[i] = abs(a[i] - a2);
        else
            p2[i] = p2[i - 1] + abs(a[i] - a2);
    }

    for (ll i = n - 1; i >= 0; --i)
    {
        if (i == n - 1)
            s[i] = abs(a[i] - a3);
        else
            s[i] = s[i + 1] + abs(a[i] - a3);
    }

    for (ll i = 0; i < n; ++i)
        a[i] = p2[i] + s[i + 1];

    build(1, 0, n - 1);
    ll ans = INF;
    for (ll i = 1; i <= b1; ++i)
    {
        ll r = i + b2 - 1;

        ll cur = -p2[i - 1] + p1[i - 1];
        cur =cur + get(1, 0, n - 1, i , r);
        ans = min(ans, cur);
    }
    cout << ans;
    return 0;
}
