#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((ll)(x).size())
using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll;
const ll maxn = 1e6;
const ll mod = 1e9 + 7;

struct dsu
{
    ll n;
    vector<ll> p, l, r;
    dsu(ll n) : n(n), p(n), l(n), r(n) {iota(all(p), 0); iota(all(l), 0); iota(all(r), 1);}
    ll f(ll x) {return x == p[x] ? x : p[x] = f(p[x]);}
    void u(ll a, ll b)
    {
        a = f(a), b = f(b);
        if (a != b) {
            l[a] = min(l[a], l[b]);
            r[a] = max(r[a], r[b]);
            p[b] = a;
        }
    }
};

ll c2(ll x)
{
    return x*(x+1)/2%mod;
}

ll cs_[100002], *cs = cs_+1;

ll f(ll l, ll r)
{
    if (r < l) return 0;
    return (ll(cs[r])-cs[l-1]+mod)%mod;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    #ifndef PAUNSVOKNO
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    #endif // PAUNSVOKNO
    for(ll i = 1; i <= 100000; ++i) cs[i] = (cs[i-1] + c2(i))%mod;
    ll n; cin >> n;
    ll t = 0;
    vector<ll> a(n);
    map<ll, ll> mp;
    for(ll &x : a) cin >> x, mp[x];
    for(auto &p : mp) p.second = t++;
    vector<vector<ll>> ps(t);
    for(ll i = 0; i < n; ++i) a[i] = mp[a[i]], ps[a[i]].push_back(i);
    dsu ds(n);
    ll ans = 0;
    for(ll c = 0; c < t; ++c) {
        for(ll i : ps[c]) {
            if (i > 0 && a[i-1] <= c) ds.u(i-1, i);
            if (i < n-1 && a[i+1] <= c) ds.u(i, i+1);
        }
        vector<ll> seg;
        for(ll i = 0, j; i < sz(ps[c]); i = j) {
            ll s = 0;
            ll l = ds.l[ds.f(ps[c][i])], r = ds.r[ds.f(ps[c][i])];
            //cout << l << ' ' << r << endl;
            j = i+1;
            while(j < sz(ps[c]) && ps[c][j] < r) ++j;
            for(ll k = i+1; k < j-1; ++k) s = (s + c2(ps[c][k+1]-ps[c][k]-1))%mod;
            if (i != j-1) s = (s + c2(r-ps[c][j-1]-1))%mod;
            //cout << "i, l, r, s = " << i << ' ' << l << ' ' << r << ' ' << s << endl;
            for(ll k = i; k < j; ++k) {
                ll b = ps[c][k]-l, d0 = (k == j-1 ? r-ps[c][k]: ps[c][k+1]-ps[c][k]), len = r-ps[c][k];
                if (k == i) seg.push_back(((c2(r-l) - c2(b) - c2(d0-1) - s)%mod + mod)%mod);
                //cout << "b, d0, len = " << b << ' ' << d0 << ' ' << len << ' ' << s << ' ' << i << ' ' << k << endl;
                //cout << c2(r-l) << ' ' << c2(b) << ' ' << c2(d0-1) << ' ' << c2(s) << endl;
                ans = (ans + ((f(len-d0, len-1) - f(0, d0-1) - ll(d0)*s)%mod*(b+1)%mod + mod)%mod)%mod;
                if (k != j-1) {
                    ll m = k+1, d0m = (m == j-1 ? r-ps[c][m]: ps[c][m+1]-ps[c][m]);
                    s = (s-c2(d0m-1)+mod)%mod;
                }
            }
        }
        for(int i = 1; i < sz(seg); ++i) seg[i] = (seg[i-1] + seg[i])%mod;
        for(int i = sz(seg)-1; i >= 1; --i) {
            ll cur = seg[i] - seg[i-1];
            ans = (ans + cur*seg[i-1])%mod;
        }
        //cout << "seg: "; for(ll x : seg) cout << x << ' '; cout << endl;
       //cout << ans << endl;
    }
    cout << ans;
}
