#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll;
const int maxn = 1e5;
const int mod = 1e9 + 7;
const ll INF = 1e18;

int n;
pair<int, int> place[3];
int x[maxn];
ll pref[maxn][3], suff[maxn][3];
ll X[maxn], Y[maxn];
ll f[maxn];

struct segTree {
    int n; vector<ll> t;
    segTree(int _n) : n(_n), t(2 * _n, INF) {}
    void upd(int v, ll x) { t[v += n] = x; for(v >>= 1; v; v >>= 1) t[v] = min(t[v * 2], t[v * 2 + 1]); }
    ll get(int l, int r) {
        ll ret = INF;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l]);
            if(!(r & 1)) ret = min(ret, t[r]);
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //#ifndef PAUNSVOKNO
    //freopen("in.txt", "r", stdin);
    //#endif // PAUNSVOKNO
    for(int i = 0; i < 3; i++) cin >> place[i].first >> place[i].second;
    sort(place, place + 3);
    cin >> n;
    for(int i = 0; i < n; i++) cin >> x[i];
    sort(x, x + n);
    for(int i = 0; i < n; i++)
        for(int j = 0; j < 3; j++) {
            pref[i][j] = abs(x[i] - place[j].first);
            if(i) pref[i][j] += pref[i - 1][j];
        }
    for(int i = n - 1; i >= 0; i--)
        for(int j = 0; j < 3; j++) {
            suff[i][j] = abs(x[i] - place[j].first);
            if(i != n - 1) suff[i][j] += suff[i + 1][j];
        }
    ll ans = INF;
    for(int i = 0; i < 3; i++) if(n <= place[i].second) ans = min(ans, pref[n - 1][i]);
    for(int i = 0; i < n - 1; i++)
        for(int a = 0; a < 3; a++)
            for(int b = 0; b < 3; b++)
                if(a != b && i + 1 <= place[a].second && n - i - 1 <= place[b].second)
                    ans = min(ans, pref[i][a] + suff[i + 1][b]);
    for(int i = 0; i < n; i++) X[i] = pref[i][0];
    for(int i = n - 1; i >= 0; i--) Y[i] = suff[i][2];
    for(int i = 0; i < n; i++) f[i] = pref[i][1];
    // PRE
    segTree t(n);
    for(int i = 1; i < n - 1; i++) {
        if(i <= place[0].second) t.upd(i, X[i - 1] - f[i - 1]);
        if(n - i - 1 <= place[2].second) {
            ans = min(ans, Y[i + 1] + f[i] + t.get(max(1, i - place[1].second + 1), i));
        }
    }
    cout << ans;
}
