#include <iostream>
#include <stdio.h>
#include <vector>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

struct Home{
    int x, cap;
};

bool operator<(Home a, Home b) {
    return a.x < b.x;
}

int main()
{
    vector<Home> H(3);
    for(int i =  0; i < 3; i++)
        cin >> H[i].x >> H[i].cap;
    sort(H.begin(), H.end());
    int n;
    cin >> n;
    vector<int> mas(n);
    for (int i = 0; i < n; i++)
        cin >> mas[i];
    sort(mas.begin(), mas.end());
    int l = 0;
    long long res = 0;
    for (int c = 0; c < 3; c++)
        while (l < n && mas[l] <= H[0].x && H[c].cap) {
                H[c].cap--;
                res += abs(H[c].x-mas[l]);
                l++;
        }
    int r = n-1;
    for (int c = 2; c >= 0; c--)
        while (r >= 0 && mas[r] >= H[2].x && H[c].cap) {
            H[c].cap--;
            res += abs(mas[r]-H[c].x);
            r--;
        }
    int mid1 = (H[1].x+H[0].x)/2, mid2 = (H[2].x+H[1].x)/2;
    for (int c = 0; c < 3; c++)
        while (l < n && mas[l] <= mid1 && H[c].cap) {
            H[c].cap--;
            res += abs(H[c].x-mas[l]);
            l++;
        }
    for (int c = 2; c >= 0; c--)
        while (r >= 0 && mas[r] >= mid2 && H[c].cap) {
            H[c].cap--;
            res += abs(mas[r]-H[c].x);
            r--;
        }
    vector<int> itl = {1, 0, 2};
    vector<int> itr = {1, 2, 0};
    for (int c : itl)
        while (l < n && mas[l] <= H[1].x && H[c].cap) {
            H[c].cap--;
            res += abs(H[c].x-mas[l]);
            l++;
        }
    for (int c : itr)
        while (r >= 0 && mas[r] > H[1].x && H[c].cap) {
            H[c].cap--;
            res += abs(mas[r]-H[c].x);
            r--;
        }
    cout << res << endl;
}
/*
0 1
3 2
6 3
4
-2 1 3 2
*/
