#include<bits/stdc++.h>

#define x first
#define y second
#define sz(s) (int)(s).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define left left228
#define right right228
#define rank rank228
#define y1 y228
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
#define pb push_back
using namespace std;
template<typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}

const int MAXN = 2e4 + 1000, start = 2;
const int S = 2002;

struct fen {
    int way[S];
    long long a[S];

    fen() {
        for (int i = 0; i < S; ++i) {
            a[i] = 1e18;
        }
    }

    void change(int i, long long j) {
        int s = i;
        while (i < S) {
            if (a[i] > j) {
                way[i] = s;
                a[i] = j;
            }
            i |= (i + 1);
        }
    }

    pair<long long, int> get(int i) {
        long long ans = 1e18;
        int res = -1;
        while (i >= 0) {
            if (ans > a[i]) {
                ans = a[i];
                res = way[i];
            }
            i &= (i + 1);
            --i;
        }
        return {ans, res};
    }
};

int n, m;
int p[S], d[S], c[S];
fen dp[S];
long long wres[S];
vector<int> id;

pair<int, int> way[S][S];

bool cmp(int i, int j) {
    if (d[i] == d[j]) {
        return i < j;
    }
    return d[i] > d[j];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        cin >> d[i] >> c[i] >> p[i];
        id.pb(i);
    }
    sort(all(id), cmp);
    dp[m].change(0, 0);
    for (int i : id) {
        for (int j = 0; j <= m; ++j) {
            wres[j] = 1e18;
        }
        for (int j = 0; j <= m; ++j) {
            auto res = dp[j].get(i - 1);
            long long w = res.x + p[i];
            if (wres[max(0, j - c[i])] > w) {
                wres[max(0, j - c[i])] = w;
                way[max(0, j - c[i])][i] = {j, res.y};
            }
            dp[max(0, j - c[i])].change(i, w);
        }
    }
    long long ans1 = dp[0].get(n).x;
    if (ans1 > 1e15) {
        cout << -1 << endl;
        return 0;
    }
    pair<int, int> res = {0, dp[0].get(n).y};

    vector<int> ans;
    while (res.x != m) {
        if (res.y == 0) break;
        ans.pb(res.y);
        res = way[res.x][res.y];
    }
    sort(all(ans));
    cout << ans1 << ' ' << ans.size() << '\n';
    for (int i : ans) cout << i << ' '; cout << '\n';
}

