#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e6 + 10;

int cnt[maxn];
pair<int, int> last[maxn];

string s;

void get(int m) {
    int cur = 0;
    for (int i = 0; i < m; ++i) {
        if (s[i] == '1')
            cur++;
    }
    cnt[cur]++;
    last[cur] = {0, m - 1};
    bool ok = false;
    for (int i = m; i < s.size(); ++i) {
        if (s[i - m] == '1')
            cur--;
        if (s[i] == '1')
            cur++;
        cnt[cur]++;
        if (cnt[cur] == 2) {
            cout << last[cur].first + 1 << ' ' << last[cur].second + 1 << ' ';
            cout << i - m + 1 + 1 << ' ' << i + 1 << endl;
            break;
        } else {
            last[cur] = {i - m + 1, i};
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> s;
    int l = 1, r = s.size() + 1;
    while (l + 1 < r) {
        for (int i = 0; i < maxn; ++i)
            cnt[i] = 0;
        int m = (l + r) / 2;
        int cur = 0;
        for (int i = 0; i < m; ++i) {
            if (s[i] == '1')
                cur++;
        }
        cnt[cur]++;
        bool ok = false;
        for (int i = m; i < s.size(); ++i) {
            if (s[i - m] == '1')
                cur--;
            if (s[i] == '1')
                cur++;
            cnt[cur]++;
            if (cnt[cur] == 2) {
                ok = true;
                break;
            }
        }
        if (ok) {
            l = m;
        } else {
            r = m;
        }
    }
    //cout << l;
    get(l);
    return 0;
}
