
#include <vector>
#include <iostream>
#include <map>
#include <stack>

using namespace std;

const int md = 1e9 + 7;

const long long Inf = 1e14;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    vector < pair <map < string, pair< int, bool> >, vector <string> > > config(1);
    map <string, stack <int>> lastchange;
    string s; int i;
    while (cin >> s){
        string var1;
        string var2;
        long long int num = -Inf;
        int last;
        if (s == "{") {
            config.push_back({});
            continue;
        }
        if (s == "}"){
            for (i=0;i<config[config.size() - 1].second.size();++i){
                lastchange[config[config.size() - 1].second[i]].pop();
            }
            config.pop_back();
            continue;
        }
        int i = 0;
        while (s[i] != '=') {
            var1 += s[i];
            ++i;
        }
        ++i;
        //cout << "VAR1 >> " << var1 << endl;
        if(s[i] == '-' || (s[i] >= '0' && s[i] <= '9')){
            num = stoi(s.substr(i));
            //cout << "CHECKNUM >> " << num << endl;
        }
        else
            var2 = s.substr(i);
        //cout << "VAR2 >> " << var2 << endl;
        if (num == -Inf) {
            if (lastchange[var2].size() != 0)
            last = lastchange[var2].top();
            else
                last = 0;
            config[config.size() - 1].first[var1].first = last;
            config[config.size() - 1].first[var1].second = 1;
            config[config.size() - 1].second.push_back(var1);
            lastchange[var1].push(last);
            cout << last << endl;
        }
        else {
            config[config.size() - 1].first[var1].first = num;
            config[config.size() - 1].first[var1].second = 1;
            config[config.size() - 1].second.push_back(var1);
            lastchange[var1].push(num);
        }
        //cout << last << ' ' << num << endl;
    }
}