#include <bits/stdc++.h>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    map<string, vector<int>> vals;
    vector<set<string>> changed;

    changed.push_back(set<string>());
    string cmd;
    while (cin >> cmd) {
        if (cmd == "{") {
            changed.push_back(set<string>());
        } else if (cmd == "}") {
            for (string s : changed.back()) {
                vals[s].pop_back();
            }
            changed.pop_back();
        } else {
            string v1 = "", v2 = "";
            int i = 0;
            while (cmd[i] != '=') {
                v1.push_back(cmd[i]);
                i++;
            }
            i++;
            while (i < cmd.size()) {
                v2.push_back(cmd[i]);
                i++;
            }

            int vl;
            bool out = false;
            if (('0' <= v2[0] && v2[0] <= '9') || v2[0] == '-') {
                vl = 0;
                bool minus = false;
                if (v2[0] == '-') {
                    minus = true;
                }
                for (char c : v2) {
                    if (c != '-') {
                        vl *= 10;
                        vl += c - '0';
                    }
                }
                if (minus) {
                    vl *= -1;
                }
            } else {
                if (vals[v2].empty()) {
                    vl = 0;
                } else {
                    vl = vals[v2].back();
                }
                out = true;
            }

            if (changed.back().count(v1)) {
                vals[v1].back() = vl;
            } else {
                changed.back().insert(v1);
                vals[v1].push_back(vl);
            }

            if (out) {
                cout << vals[v1].back() << "\n";
            }
        }
    }

    return 0;
}