import java.io.*;
import java.util.*;

public class C {
	public void solve() throws IOException {
		LinkedList<HashMap<String, Integer>> map = new LinkedList<>();
		map.add(new HashMap<>());

		while (in.hasNext()) {
			String str = in.nextLine();

			if (str.charAt(0) == '{') {
				HashMap<String, Integer> newMap = (HashMap<String, Integer>) map.getLast().clone();
				map.add(newMap);
			} else if (str.charAt(0) == '}') {
				map.removeLast();
			} else {
				String[] var = str.split("=");

				try {
					int x = Integer.parseInt(var[1]);
					map.getLast().put(var[0], x);
				} catch (Exception e) {
					if (!map.getLast().containsKey(var[1])) {
						map.getLast().put(var[1], 0);
					}
					int x = map.getLast().get(var[1]);
					map.getLast().put(var[0], map.getLast().get(var[1]));
					out.println(x);
				}
				
			}
		}
	}

	public void run() {
		try {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	Scanner in;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C().run();
	}
}
