import java.io.*;
import java.util.*;

public class E {
	public void solve() throws IOException {
		int a = nextInt();
		int na = nextInt();
		int b = nextInt();
		int nb = nextInt();
		int c = nextInt();
		int nc = nextInt();

		if (a > b) {
			int t = a;
			a = b;
			b = t;
			int nt = na;
			na = nb;
			nb = nt;
		}
	    if (b > c) {
	    	int t = b;
			b = c;
			c = t;
			int nt = nb;
			nb = nc;
			nc = nt;
	    }
	    if (a > c) {
	    	int t = a;
			a = c;
			c = t;
			int nt = na;
			na = nc;
			nc = nt;
	    }
		
		int n = nextInt();
		int[] x = new int[n];
		for (int i = 0; i < x.length; i++) {
			x[i] = nextInt();
		}

		Arrays.sort(x);

		int s = 0;
		int fa = na, fb = nb, fc = nc;
		for (int t = 0; t < x.length; t++) {
			if (t <= (a + b) / 2) {
				if (fa > 0) {
					fa--;
					s += Math.abs(x[t] - a);
				} else {
					fb--;
					s += Math.abs(x[t] - b);
				}
			} else {
				if (n - t > fb + fc) {
					fa--;
					s += Math.abs(x[t] - a);
				} else {
					if (fb > 0) {
						fb--;
						s += Math.abs(x[t] - b);
					} else {
						fc--;
						s += Math.abs(x[t] - c);
					}
				}
			}
		}

		System.out.println(s);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new E().run();
	}

}
