#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>

using namespace std;

void run();

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const int N = 1005;

int n, m;
int a[N], b[N];

void run() {
	cin >> n >> m;
	rep(i, 0, m) {
		cin >> b[i];
	}
	if (m != n - 1) {
		cout << "No\n";
		return;
	}
	int st = 1;
	int cnt = 0;
	int bad = 0;
	rep(i, 0, m) {
		if (b[i] != st) {
			cnt++;
			bad = st;
		}
		st = b[i];
		st++;
	}
	if (cnt == 1) {
		cout << "Yes\n";
		cout << bad << "\n";
	}
	else {
		cout << "No\n";
	}
}