#include <bits/stdc++.h>

#define F first
#define S second
#define endl "\n"

using namespace std;

typedef long long ll;

int todig(string s)
{
    for (int i = (s[0] == '-'); i < s.size(); ++i)
        if (!isdigit(s[i]))
            return 1e9 + 1;
    if (s[s[0] == '-'] == '0' && (int)s.size() - (s[0] == '-') > 1)
        return 1e9 + 1;
    int x = 0;
    for (int i = (s[0] == '-'); i < s.size(); ++i)
    {
        x = x * 10 + (s[i] - '0');
    }
    if (s[0] == '-') x *= -1;
    return x;
}

unordered_map<string, vector<int> > v;
vector<unordered_set<string> > st(1);

int main()
{
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    string s;
    v.reserve(1e5);
    st.reserve(1e5);
    while (getline(cin, s))
    {
        if (s == "{")
        {
            st.push_back(unordered_set<string>());
            continue;
        }
        if (s == "}")
        {
            for (auto &i:st.back())
            {
                v[i].pop_back();
            }
            st.pop_back();
            continue;
        }
        int e = s.find('=');
        string rvalrval = s.substr(e + 1, s.size() - e - 1);
        string lval = s.substr(0, e);
        int var = todig(rval);
        bool f = st.back().insert(lval).S == 1;
        if (var != 1e9 + 1)
        {
            if (f)
                v[lval].push_back(var);
            else
                v[lval].back() = var;
        }
        else
        {
            if (v[rval].size() == 0)
            {
                v[rval].reserve(100);
                v[rval].push_back(0);
            }
            cout << v[rval].back() << endl;
            if (f)
                v[lval].push_back(v[rval].back());
            else
                v[lval].back() = v[rval].back();
        }
    }
    return 0;
}

