#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll mx = 3e5;
const ll MOD = 1e9 + 7;
const ll p2 = (MOD + 1) / 2;
ll n, a[mx], pl[mx], pr[mx];
ll ans;
map<ll, vector<ll> > mp;

ll divide2(ll x) {
    return (x * p2) % MOD;
}

void solve1(vector<ll> dist) {
    ll m = dist.size();
    vector<ll> pref(m), suf(m), dr(m), dl(m), suf_dr(m);
    pref[0] = dist[0];
    for (ll i = 1; i < m; ++i) {
        pref[i] = (pref[i - 1] + dist[i]) % MOD;
    }
    suf[m - 1] = dist[m - 1];
    for (ll i = m - 2; i >= 0; --i) {
        suf[i] = (suf[i + 1] + dist[i]) % MOD;
    }
    dr[m - 1] = dist[m - 1];
    for (ll i = m - 2; i > 0; --i) {
        dr[i] = (dist[i] * suf[i + 1] + dist[i]) % MOD;
    }
    dr[0] = dist[0] * suf[1];
    dl[0] = 0;
    for (ll i = 1; i < m; ++i) {
        dl[i] = (dist[i] * (pref[i - 1] + 1)) % MOD;
    }
    suf_dr[m - 1] = dr[m - 1];
    for (ll i = m - 2; i >= 0; --i) {
        suf_dr[i] = (suf_dr[i + 1] + dist[i]) % MOD;
    }
    ll ans1 = 0;
    for (ll i = 1; i < m - 1; ++i) {
        ans1 = (ans1 + (dl[i] * suf_dr[i + 1])) % MOD;
    }
    ll ans2 = 0;
    for (ll i = 1; i < m - 1; ++i) {
        ll k = dist[i], el = pref[i - 1] + 1, er = suf[i + 1];
        ans2 = (ans2 + (((el * er) % MOD) * (divide2((k * (k - 1)) % MOD)))) % MOD;
    }
    ans += (ans1 + ans2);
}

ll func(vector<ll> dist, ll len) {
    ll res = (len * (len + 1) / 2) % MOD;
    res = (res - (divide2(dist[0] * (dist[0] + 1))) % MOD + MOD) % MOD;
    for (ll i = 1; i < dist.size(); ++i) {
        if (dist[i] > 0)
            res = ((res - (divide2((dist[i]) * (dist[i] - 1)))) % MOD + MOD) % MOD;
    }
    return res;
}

void solve(vector<ll> v) {
    vector<ll> big_dist, f;
    ll m = v.size(), lst = 0;
    for (ll i = 0; i < m; ++i) {
        if (i == m - 1 || pr[v[i]] < v[i + 1]) {
            big_dist.push_back(pr[v[i]] - pl[v[lst]] - 1);
            vector<ll> dist;
            dist.push_back(v[lst] - pl[v[lst]] - 1);
            for (ll j = lst + 1; j <= i; ++j) {
                dist.push_back(v[j] - v[j - 1]);
            }
            dist.push_back(pr[v[i]] - v[i]);
            f.push_back(func(dist, pr[v[i]] - pl[v[lst]] - 1));
            solve1(dist);
            lst = i + 1;
        }
    }
    ll kek = big_dist.size();
    vector<ll> suf(kek);
    suf[kek - 1] = f[kek - 1];
    for (ll i = kek - 2; i >= 0; --i) {
        suf[i] = (suf[i + 1] + f[i]) % MOD;
    }
    for (ll i = 0; i < kek - 1; ++i) {
        ans = (ans + f[i] * suf[i + 1]) % MOD;
    }
}

int main()
{
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        mp[a[i]].push_back(i);
    }
    vector<pair<ll, ll> > st1;
    for (ll i = 0; i < n; ++i) {
        while (!st1.empty() && st1.back().first <= a[i])
            st1.pop_back();
        if (st1.empty())
            pl[i] = -1;
        else
            pl[i] = st1.back().second;
        st1.push_back({a[i], i});
    }
    vector<pair<ll, ll> > st2;
    for (ll i = n - 1; i >= 0; --i) {
        while (!st2.empty() && st2.back().first <= a[i])
            st2.pop_back();
        if (st2.empty())
            pr[i] = n;
        else
            pr[i] = st2.back().second;
        st2.push_back({a[i], i});
    }
    for (auto pr : mp) {
        solve(pr.second);
    }
    cout << ans << endl;
    return 0;
}
