// COlymp.cpp : Defines the entry point for the console application.
//

#include <iostream>

using namespace std;

int length(long long n);
int tp(int a);
long long smart(long long n, long long nums[]);
int dumb(long long n, long long nums[]);

int main()
{
	long long n;
	cin >> n;
	long long nums[1000000];


	for (long long i = 0; i < n; i++)
	{
		long long t;
		cin >> t;
		nums[i] = t;
	}

	cout << smart(n, nums) << "\n";

	return 0;
}

long long smart(long long n, long long nums[])
{
	long long count[10];
	long long sum[10];

	for (int i = 0; i < 10; i++)
	{
		count[i] = sum[i] = 0;
	}

	for (long long i = 0; i < n; i++)
	{
		long long t = nums[i];
		int l = length(t);
		sum[l - 1] += t;
		count[l - 1]++;
	}

	long long mm = 0;

	for (long long i = 0; i < n; i++)
	{
		long long num = nums[i];
		int l = length(num);
		for (int j = 1; j <= 10; j++)
		{
			long long p = tp(j);
			mm += nums[i] * p * (j == l ? count[j - 1] - 1 : count[j - 1]);
			while (mm > 1000000007)
				mm -= 1000000007;
			mm += (j == l ? sum[j - 1] - num : sum[j - 1]);
			while (mm > 1000000007)
				mm -= 1000000007;
		}
	}

	return mm;
}

int dumb(long long n, long long nums[])
{
	long long mm = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (i != j)
			{
				int l1 = length(nums[i]);
				mm += tp(l1) * nums[j] + nums[i];
				mm %= 1000000007;
			}
		}
	}
	return mm;
}

int length(long long n)
{
	int i = 10;
	int r = 1;
	while (i < n + 1)
	{
		i = i * 10;
		r++;
	}
	return r;
}

int tp(int a)
{
	long long r = 1;
	for (int i = 0; i < a; i++)
		r *= 10;
	return r;
}
