import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public void solve() throws IOException {
        String s = nextToken();
        int min0 = -1;
        int min1 = -1;
        int max1 = -1;
        int max0 = -1;
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '0') {
                if (min0 == -1) {
                    min0 = i;
                }
                max0 = i;
            } else {
                if (min1 == -1) {
                    min1 = i;
                }
                max1 = i;
            }
        }
        max0++;
        max1++;
        min0++;
        min1++;
        if (max0 == 0) {
            out.print((min1) + " " + (max1 - 1) + " " + (min1 + 1) + " " + max1);
            return;
        }
        if (max1 - min1 >= max0 - min0) {
            out.print((min1) + " " + (max1 - 1) + " " + (min1 + 1) + " " + max1);
            return;
        }
        out.print((min0) + " " + (max0 - 1) + " " + (min0 + 1) + " " + max0);
        return;

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}
