import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public class pair implements Comparable<pair> {
        int x, a;

        public int compareTo(pair p) {
            if (x != p.x) {
                return x - p.x;
            }
            return a - p.a;
        }

        pair(int u, int i) {
            x = u;
            a = i;
        }
    }

    public class paird implements Comparable<paird> {
        double x;
        int a;

        public int compareTo(paird p) {
            if (x != p.x) {
                return Double.compare(x, p.x);
            }
            return a - p.a;
        }

        paird(double u, int i) {
            x = u;
            a = i;
        }
    }

    public void solve() throws IOException {
        pair[] a = new pair[3];
        long res = 0;
        a[0] = new pair(nextInt(), nextInt());
        a[1] = new pair(nextInt(), nextInt());
        a[2] = new pair(nextInt(), nextInt());
        TreeSet<pair> c = new TreeSet<>();
        Arrays.sort(a);
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            c.add(new pair(nextInt(), m - i - 1));
        }
        while (a[0].a > 0 && c.size() > 0) {
            int p = c.first().x;
            if (Math.abs(p - a[0].x) < Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[0].x);
                a[0].a--;
                c.pollFirst();
            } else {
                break;
            }
        }
        while (a[2].a > 0 && c.size() > 0) {
            int p = c.last().x;
            if (Math.abs(p - a[2].x) < Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[2].x);
                c.pollLast();
                a[2].a--;
            } else {
                break;
            }
        }
        int k = a[1].a - c.size();
        k = -k;
        for (pair cc : c) {
            res += Math.abs(a[1].x - cc.x);
        }
        if (k > 0) {
            double ab = (a[0].x + a[1].x + 0.0) / 2;
            double bc = (a[1].x + a[2].x + 0.0) / 2;
            paird ra[] = new paird[c.size()];
            paird rc[] = new paird[c.size()];
            int l = 0;
            for (pair cc : c) {
                ra[l] = new paird(cc.x * 1.0 - ab, cc.a);
                if (cc.x > a[1].x) ra[l].x = a[1].x * 1.0 - ab;
                rc[l] = new paird(bc - cc.x * 1.0, cc.a);
                if (cc.x < a[1].x) rc[l].x = bc - a[1].x * 1.0;
                l++;
            }
            Arrays.sort(ra);
            Arrays.sort(rc);
            boolean used[] = new boolean[m];
            int i = 0, j = 0;
            while (k > 0) {
                while (used[ra[i].a]) i++;
                while (used[rc[j].a]) j++;
                if (a[0].a == 0) {
                    res += (int) (2 * rc[j].x);
                    used[rc[j].a] = true;
                    j++;
                    a[2].a--;
                    k--;
                } else if (a[2].a == 0) {
                    res += (int) (2 * ra[i].x);
                    used[ra[i].a] = true;
                    i++;
                    a[0].a--;
                    k--;
                } else {
                    if (ra[i].x < rc[j].x) {
                        used[ra[i].a] = true;
                        res += (int) (2 * ra[i].x);
                        i++;
                        a[0].a--;
                        k--;
                    } else {
                        res += (int) (2 * rc[j].x);
                        used[rc[j].a] = true;
                        j++;
                        a[2].a--;
                        k--;
                    }
                }
            }
        }
        out.print(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    boolean hasNext() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            try {
                in = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return false;
            }
        }
        return true;
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}