#include <bits/stdc++.h>

#define pub push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const ll LINF = (ll)1e18 + 7;

struct vert{
    int pred, r;
};

struct cnm{
    vert t[100007];
    cnm() { for (int i = 0; i < 100007; i++) t[i].pred = i, t[i].r = 0; }

    int get(int v){
        if (t[v].pred == v) return v;
        t[v].pred = get(t[v].pred);
        return t[v].pred;
    }

    void merge(int a, int b){
        a = get(a), b = get(b);
        if (a != b){
            if (t[a].r < t[b].r) swap(a, b);
            t[b].pred = a;
            if (t[a].r == t[b].r) t[a].r++;
        }
    }
} cc;

int n;
vector<pair<int, int> > g[100007];
set<pair<ll, int> > se;
ll was[100007];

void dij(){
    while(se.size()){
        auto now = *se.begin();
        se.erase(se.begin());
        for (auto to : g[now.y]) if (was[to.x] > was[now.y] + to.y){
            se.erase(mp(was[to.x], to.x));
            was[to.x] = was[now.y] + to.y;
            se.insert(mp(was[to.x], to.x));
        }
    }
}

struct st{
    ll x, type, val;
    st() {}
    st(ll xx, int ttype, int vval) { x = xx, type = ttype, val = vval; }
    bool operator< (st nxt) const {
        if (nxt.x == x){
            return type < nxt.type;
        } else {
            return x < nxt.x;
        }
    }
};

map<ll, vector<int> > ma;

vector<st> t;
void add(ll l, ll r, int val){
    t.pub(st(l, -1, val));
    t.pub(st(r, 1, -val));
}

bool ok[100007];

int main() {
#ifdef WIN
    freopen("01", "r", stdin);
#endif // WIN
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].pub(mp(b, c));
        g[b].pub(mp(a, c));
    }
    int sz;
    cin >> sz;
    for (int i = 0; i < n; i++) was[i] = LINF;
    for (int i = 0; i < sz; i++){
        int v;
        cin >> v;
        was[v - 1] = 0;
        se.insert(mp(0, v - 1));
    }
    dij();

    for (int i = 0; i < n; i++) ma[was[i]].pub(i);

    int now = 0;
    ll last = LINF + 7;

    for (auto it = ma.rbegin(); it != ma.rend(); it++){
        add(2 * (*it).x, 2 * last, now);
        //cout << (*it).x << ' ' << last << ' ' << now << endl;
        last = (*it).x - 1;
        now += (*it).y.size();
        for (auto v : (*it).y) ok[v] = 1;
        for (auto v : (*it).y){
            for (auto to : g[v]) if (ok[to.x]){
                if (cc.get(v) != cc.get(to.x)){
                    now--;
                    cc.merge(v, to.x);
                }
            }
        }
    }

    for (int v = 0; v < n; v++) for (auto to : g[v]) if (v < to.x){
        ll mi = min(was[v], was[to.x]);
        ll ma = max(was[v], was[to.x]);
        ll w = to.y;
        if (ma - mi >= w) continue;
        add(2 * ma, 2 * ma + (w - (ma - mi)), 1);
    }

    int ans = 0, sum = 0;
    sort(t.begin(), t.end());
    for (int i = 0; i < t.size(); i++){
        //cout << t[i].x << ' ' << t[i].val << endl;
        sum += t[i].val;
        ans = max(ans, sum);
    }
    cout << ans;
    return 0;
}
