#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()

using namespace std;

const int maxN = 2005;
const ll INF = 1e18;

int main()
{
    //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll p_a, n_a, p_b, n_b, p_c, n_c;
    cin >> p_a >> n_a >> p_b >> n_b >> p_c >> n_c;
    if (p_a > p_b)
    {
        swap(p_a, p_b);
        swap(n_a, n_b);
    }
    if (p_b > p_c)
    {
        swap(p_b, p_c);
        swap(n_b, n_c);
    }
    if (p_a > p_b)
    {
        swap(p_a, p_b);
        swap(n_a, n_b);
    }
    int n;
    cin >> n;
    deque<int> pos(n);
    rep(i, 0, n)
        cin >> pos[i];
    sort(pos.begin(), pos.end());
    ll ans = 0;
    while (sz(pos) > 0 && pos.front() <= p_a)
    {
        if (n_a > 0)
        {
            n_a--;
            ans += abs(pos.front() - p_a);
        }
        else if (n_b > 0)
        {
            n_b--;
            ans += abs(pos.front() - p_b);
        }
        else if (n_c > 0)
        {
            n_c--;
            ans += abs(pos.front() - p_c);
        }
        else
            assert(false);
        pos.pop_front();
    }
    while (sz(pos) > 0 && pos.back() >= p_c)
    {
        if (n_c > 0)
        {
            n_c--;
            ans += abs(pos.back() - p_c);
        }
        else if (n_b > 0)
        {
            n_b--;
            ans += abs(pos.back() - p_b);
        }
        else if (n_a > 0)
        {
            n_a--;
            ans += abs(pos.back() - p_a);
        }
        else
            assert(false);
        pos.pop_back();
    }
    n = sz(pos);
    ll pref[n + 1]; pref[0] = 0;
    rep(i, 0, n)
        pref[i + 1] = pref[i] + pos[i];
    ll best = INF;
    rep(cnt, 0, min((ll)sz(pos), n_c) + 1)
    {
        ll cur = 0;
        cur += p_c * cnt - (pref[n] - pref[n - cnt]);
        if (cnt == n)
        {
            best = min(best, cur);
            continue;
        }
        int P = lower_bound(pos.begin(), pos.end(), p_b) - pos.begin();
        int L = max(0LL, n - cnt - n_b);
        int R = min((ll)n, n_a);
        if (L > R)
            continue;
        int l = L - 1, r = R, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (pos[mid] - p_a < p_b - pos[mid])
                l = mid;
            else
                r = mid;
        }
        cur += pref[l + 1] - p_a * (l + 1);
        l = l + 1; r = n - cnt; // [)
        if (l >= r)
        {
            cur += 0;
        }
        else if (l >= P)
        {
            cur += (pref[r] - pref[l]) - p_b * (r - l);
        }
        else if (r <= P)
        {
            cur += p_b * (r - l) - (pref[r] - pref[l]);
        }
        else
        {
            cur += (pref[r] - pref[P]) - p_b * (r - P);
            cur += p_b * (P - l) - (pref[P] - pref[l]);
        }
        best = min(best, cur);
    }
    cout << ans + best << "\n";
    return 0;
}
