#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include<set>

using namespace std;

typedef long long ll;
typedef long double ld;

void prisv(int ver, int val)
{
    if(ver < 0)
    {
        if(val == 1) val = 0;
        else val = 1;
        cout << -ver << " " << val << endl;
        return;
    }
    cout << ver << " " << val << endl;
    return;
}

void Rand(bool is_our_turn, set<int> remain)
{
    int x, y;
    if(is_our_turn)
    {
        if(!remain.empty()){
        x = *remain.begin();
        prisv(x, 0);
        remain.erase(x);}
    }
    while(!remain.empty())
    {
        if(!remain.empty()){
        cin >> x >> y;
        remain.erase(x);}
        if(!remain.empty()){
        x = *remain.begin();
        prisv(x, 0);
        remain.erase(x);}
        cout << remain.size() << endl;
    }
}

int module(int a)
{
    if(a<0) return -a;
    return a;
}

set<int> union_(set<int> a, set<int> b)
{
    for(set<int>::iterator it = b.begin(); it != b.end(); ++it)
    {
        a.insert(*it);
    }
    return a;
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    map<int, set<int> > G;
    set<int> unused;
    for(int i = 1; i <= n; ++i)
    {
        if (i == 0) {
            continue;
        }
        unused.insert(i);
    }
    int x, y;
    for(int i = 0; i < m; ++i)
    {
        cin >> x >> y;
        G[x].insert(y);
        G[y].insert(x);
    }
    for(int i = -n; i <= n; ++i)
    {
        if (i == 0) {
            continue;
        }
        if(G[i].size() > 1)
        {
            int x, y, t, k;
            x = *G[i].begin();
            auto ity = G[i].begin();
            ++ity;
            y = *(ity);
            if(y == -x)
            {
                prisv(i, 0);
                unused.erase(i);
                Rand(false, unused);
                return 0;
            }
            else
            {
                prisv(i, 0);
                cin >> t >> k;
                unused.erase(i);
                unused.erase(t);
                if(t == module(x)) {prisv(y, 0); unused.erase(module(y));}
                else {prisv(x, 0); unused.erase(module(x));}
                Rand(false, unused);
                return 0;
            }
        }
    }
        for(int i = 1; i <= n; ++i)
        {
            if((G[i].size() + G[-i].size() == 2) && (*G[i].begin() != -*G[-i].begin()))
            {
                int x, y, t, k;
                x = *G[i].begin();
                y = *G[-i].begin();
                prisv(x, 0);
                unused.erase(module(x));
                cin >> t >> k;
                unused.erase(t);
                if(t == i)
                {
                    prisv(y, 0);
                    unused.erase(module(y));
                    Rand(false, unused);
                    return 0;
                }
                else
                {
                    prisv(i, 0);
                    unused.erase(i);
                    Rand(false, unused);
                    return 0;
                }
            }
        }
    set<int> nopairs;
    set<int> onepairs;
    for(int i = 1; i <= n; ++i)
    {
        if(G[i].size() + G[-i].size() == 0) nopairs.insert(i);
        if(G[i].size() + G[-i].size() == 1) onepairs.insert(i);
    }
    if(nopairs.size()%2 == 0)
    {
        cout << "-1 -1" << endl;
        return 0;
    }
    std::set<int> dest1;

    dest1 = union_(nopairs, onepairs);
    if(nopairs.size() + onepairs.size() == n)
    {
        cout << "-1 -1" << endl;
        return 0;
    }
    else
    {
        int x, y;
        x = *dest1.begin();
        prisv(x,0);
        dest1.erase(x);
        unused.erase(x);
        while(true)
        {
            cin >> x >> y;
            if(dest1.find(x) != dest1.end())
            {
                dest1.erase(x);
                unused.erase(x);
                x = *dest1.begin();
                prisv(x, 0);
                dest1.erase(x);
                unused.erase(x);
            }
            else
            {
                unused.erase(x);
                if(y == 0)
                {
                    prisv(*G[x].begin(), 0);
                    unused.erase(module(*G[x].begin()));
                    Rand(false, unused);
                    return 0;
                }
                else
                {
                    prisv(*G[x].begin(), 1);
                    unused.erase(module(*G[x].begin()));
                    Rand(false, unused);
                    return 0;
                }
            }
        }
    }
    return 0;
}

/*
0 1
3 2
6 3
4
-2 1 3 2

*/
