#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<int> a, b;

const ll MOD = 1000000007;

ll f(int i, int j) {
    if (i == j) {
        return 0;
    }
    int m = (i + j) / 2;
    ll sL = 0, tR = 0;
    for (int q = i; q <= m; ++q) {
        sL += a[q];
    }
    sL %= MOD;
    for (int q = m + 1; q <= j; ++q) {
        tR += b[q];
    }
    tR %= MOD;
    ll ans1 = (sL * tR) % MOD;

    ll sR = 0, tL = 0;
    for (int q = m + 1; q <= j; ++q) {
        sR += a[q];
    }
    sR %= MOD;
    for (int q = i; q <= m; ++q) {
        tL += b[q];
    }
    tL %= MOD;
    ll ans2 = (tL * sR) % MOD;
    ans1 = (ans1 + ans2) % MOD;

    ans2 = f(i, m);
    ans1 = (ans1 + ans2) % MOD;
    ans2 = f(m + 1, j);
    ans1 = (ans1 + ans2) % MOD;
    return ans1;
}

int ct_nums(int x) {
    int ctr = 1;
    while (ctr <= x) {
        ctr *= 10;
    }
    return ctr;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
        b[i] = ct_nums(a[i]);
    }
    sum %= MOD;

    /*for (int &i : a) {
        cout << i << ' ';
    }
    cout << endl;
    for (int &i : b) {
        cout << i << ' ';
    }
    cout << endl;*/

    cout << (f(0, n - 1) + ((n - 1) * sum) % MOD) % MOD;
    return 0;
}
