#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const int maxn = 1e3 + 88;
const ll mod = 1e9 + 7;
const ll mod2 = 1e9 + 9;

long long pref[maxn], suff[maxn];
pair<long long, long long> cnt[3];
ll t[4*maxn];
ll x[maxn];

ll build(int v, int l, int r)
{
    if (l == r)
        return t[v] = suff[l];
    ll mid = (l + r)/2;
    return t[v] = min(build(2*v, l, mid), build(2*v + 1, mid + 1, r));
}

ll get(int v, int l, int r, int ql, int qr)
{
    if (l > qr || r < ql)
        return infll;
    if (l >= ql && r <= qr)
        return t[v];
    ll mid = (l + r)/2;
    return min(get(2*v, l, mid, ql, qr), get(2*v + 1, mid + 1, r, ql, qr));
}

void solve1()
{
    ll n, a, na, b, nb, c, nc, i;
    for (i = 0; i < 3; i++)
        cin >> cnt[i].fr >> cnt[i].sc;
    sort(cnt, cnt + 3);
    a = cnt[0].fr, na = cnt[0].sc;
    b = cnt[1].fr, nb = cnt[1].sc;
    c = cnt[2].fr, nc = cnt[2].sc;
    cin >> n;
    for (i = 0; i < n; i++)
        cin >> x[i];
    sort(x, x + n);
    for (i = 0; i < na; i++)
        pref[i] = abs(a - x[i]) + (i != 0 ? pref[i - 1] : 0);
    for (i = na; i < n; i++)
        pref[i] = infll;
    for (i = n - 1; i >= n - nc; i--)
        suff[i] = abs(c - x[i]) + (i != n - 1 ? suff[i + 1] : 0);
    for (i = 0; i < n - nc; i++)
        suff[i] = infll;
    ll sum = 0;
    for (i = 0; i <= n; i++)
    {
        suff[i] = min(infll, suff[i] + sum);
        sum += abs(b - x[i]);
    }
    build(1, 0, n);
    ll ans = get(1, 0, n, 0, nb);
    sum = abs(b - x[0]);
    for (i = 0; i < na; i++)
    {
        ll cur = get(1, 0, n, i + 1, i + nb + 1);
        if (cur == infll)
            continue;
        ans = min(ans, cur + pref[i] - sum);
        sum += abs(b - x[i]);
    }
    cout << ans;
}

//int d[maxn], c[maxn], p[maxn];
//map<int,int> dm, pm;
//vector<int> ds, ps;
//bool fl[maxn];
//int t[2055][8055];
//pair<int, int> pr[maxn];
//int lvl;
//
//void build(int v, int l, int r){
//    if(l == r){
//        t[lvl][v] = inf;
//        return;
//    }
//    int c = (l + r)/2;
//    build(v * 2, l, c);
//    build(v * 2 + 1, c + 1, r);
//    t[lvl][v] = inf;
//}
//
//int getMin(int v, int tl, int tr, int l, int r){
//    if(l > r)
//        return inf;
//    if(tl == l && tr == r){
//        return t[lvl][v];
//    }
//    int c = (tl + tr);
//    return min(getMin(2 * v, tl, c, l, min(r, c)),
//               getMin(2 * v + 1, c + 1, tr, max(l, c + 1), r));
//}
//
//void update(int v, int l, int r, int x, int pos){
//    if(l == r){
//        t[v] = min(t[v], x);
//        return;
//    }
//    int c = (l + r)/2;
//    if(pos <= c)
//        update(v * 2, l, c, x, pos);
//    else
//        update(v * 2 + 1, c + 1, r, x, pos);
//}
//
//void solve(){
//    int n, m;
//    cin >> n >> m;
//    for(int i = 0; i < n; i++){
//        cin >> d[i] >> p[i] >> c[i];
//        ds.pb(d[i]);
//    }
//    sort(ds.begin(), ds.end());
//    for(int i = 0; i < ds.size(); i++){
//        dm[ds[i]] = i;
//    }
//    for(int i = 0; i < n; i++)
//        d[i] = dm[d[i]];
//    fl[0] = 1;
//    for(int i = 1; i < m; i++){
//        lvl = i;
//        build(1, 0, n);
//    }
//    for(int i = 0; i < n; i++){
//        for(int j = 0; j < m; j++){
//            if(fl[j]){
//                lvl = j;
//                int f = getMin(1, 0, n, d[i] + 1, n);
//                lvl = min(j + p[i], m);
//                update(1, 0, n, f + c[i], d[i]);
//            }
//        }
//    }
//
//}

int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
    cin.tie();
    cout.tie();
    solve1();
    return 0;
}
