#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <cctype>
#include <string>

using namespace std;

/*int main()
{
	long long n;
	cin >> n;

	long long ans = (2 * n)*(2 * n) + (2 * n)*(2 * n)*(2 * n);

	ans += 2*n + 2*(2*n)*(2*n - 1);

	if (2 * n >= 3)
		ans += (2 * n)*(2 * n - 1)*(2 * n - 2);

	if (2 * n >= 4)
		ans += (2 * n)*(2 * n - 1)*(2 * n - 2)*(2*n - 3) / 4;

	cout << ans;
}*/

/*int main()
{
	string s;
	cin >> s;
	int n = (int)s.size();
	vector<int> p(n);
	vector<int> c(n + 1, 0);
	p[0] = s[0] == '1';
	for (int i = 1; i < n; i++) {
		p[i] = p[i - 1] + (s[i] == '1');
		c[p[i]]++;
	}
	
	for (int)
}*/

const int BASE = 1e+9 + 9;
const int p = 101;

int get_hash(const string &s)
{
	long long h = 0;
	for (int i = 0; i < s.size(); i++)
		h = (h * p + s[i] - 'a' + 1) % BASE;
	return h;
}

int main()
{
	map<int, string> v; //hash, string
	map<int, stack<int>> cur_val; //hash, cur_v
	stack<set<int>> nw; //stack<hash>

	nw.push(set<int>());

	string s;
	while (cin >> s) {
		if (s == "{")
			nw.push(set<int>());
		else if (s == "}") {
			for (auto x : nw.top())
				cur_val[x].pop();
			nw.pop();
		}
		else {
			string a = s.substr(0, s.find('='));
			string b = s.substr(a.size() + 1);
			int h = get_hash(a);

			if (v.count(h) == 0) {
				v.insert({ h, a });
				cur_val.insert({ h, stack<int>() });
				cur_val[h].push(0);
			}

			if (b[0] == '-' || b[0] <= '9' && b[0] >= '0') {
				if (nw.top().count(h))
					cur_val[h].pop();

				nw.top().insert(h);
				int t = stoi(b);
				cur_val[h].push(t);
			}
			else {
				if (a == b) {
					cout << cur_val[h].top() << '\n';
					continue;
				}

				int h2 = get_hash(b);

				if (v.count(h2) == 0) {
					v.insert({ h2, b });
					cur_val.insert({ h2, stack<int>() });
					cur_val[h2].push(0);
				}

				if (nw.top().count(h))
					cur_val[h].pop();
				else
					nw.top().insert(h);

				cur_val[h].push(cur_val[h2].top());
				cout << cur_val[h].top();
				cout << '\n';
			}
		}
	}
}
