#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double dl;

ll INF = 1e18 * 3;

ll maxn = 1e5 + 10;
vector<ll>pref_a(maxn), pref_b(maxn), pref_c(maxn);
vector<ll>v;
ll a, b, c, cnt_a, cnt_b, cnt_c;
ll n;

ll check(ll first, ll second) {
	ll ans = 0;
	if (second - 1 >= 0)
		ans += pref_b[second - 1];
	if (first - 1 >= 0)
		ans -= pref_b[first - 1];
	ans += pref_c[n - 1];
	if (second - 1 >= 0)
		ans -= pref_c[second - 1];
	return ans;
}


int  main()
{
	//freopen("input.txt", "r", stdin);
	vector<pair<ll, ll>>vr(3);
	for (ll i = 0; i < 3; i++) {
		cin >> vr[i].first >> vr[i].second;
	}
	sort(vr.begin(), vr.end());
	a = vr[0].first;
	cnt_a = vr[0].second;
	b = vr[1].first;
	cnt_b = vr[1].second;
	c = vr[2].first;
	cnt_c = vr[2].second;
	cin >> n;
	v.resize(n);
	for (ll i = 0; i < n; i++) {
		cin >> v[i];
	}
	sort(v.begin(), v.end());
	pref_a[0] = abs(a - v[0]);
	pref_b[0] = abs(b - v[0]);
	pref_c[0] = abs(c - v[0]);
	for (ll i = 1; i < n; i++) {
		pref_a[i] = pref_a[i - 1] + abs(a - v[i]);
		pref_b[i] = pref_b[i - 1] + abs(b - v[i]);
		pref_c[i] = pref_c[i - 1] + abs(c - v[i]);
	}
	ll gl_ans = INF;
	for (ll i = 0; i <= min(n, cnt_a); i++) {
		ll ans = (i == 0) ? 0 : pref_a[i - 1];

		ll l = max(i, n - cnt_c), r = min(n, i + cnt_b);
		if (l > r)
			continue;

		for(int it = 0;it < 200 && r-l>1;it++){
			ll m1 = l + (r - l) / 3;
			if (m1 == l)
				m1++;
			ll m2 = l + (r - l) * 2 / 3;
			if (check(i, l) > check(i, m1)) {
				l = m1;
			}
			if (check(i, r) > check(i, m2)) {
				r = m2;
			}
		}
		ll sum = INF;
		for (int i1 = l; i1 <= r; i1++) {
			sum = min(sum, check(i, i1));
		}
		gl_ans = min(ans+sum, gl_ans);
	}
	cout << gl_ans;
	return 0;
}