#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
#include <queue>
using namespace std;

#define X first
#define Y second

const long long len = 3e5;
long long x;
vector < pair < long long, long long > > g[len];
long long tp;
void ed(long long l, long long r, long long c) {
	g[l].push_back({ tp, c });
	g[r].push_back({ tp, c });
	g[tp].push_back({ l, c });
	g[tp].push_back({ r, c });
	tp++;
}

long long p[len];

map < long long, vector < long long > > t;

bool used[len];
const long long inf = 1ll << 61;
long long d[len];

long long cnt = 0;

long long gt(long long v) {
	return p[v] = (p[v] == v ? v : gt(p[v]));
}

void merge(long long l, long long r) {
	l = gt(l);
	r = gt(r);
	cnt--;
	p[l] = r;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> x;
	tp = x;
	for (long long i = 0; i < x - 1; i++) {
		long long l, r, v;
		cin >> l >> r >> v;
		--l;
		--r;
		ed(l, r, v);
	}

	for (long long i = 0; i < tp; i++) {
		p[i] = -1;
	}
	for (long long i = 0; i < tp; i++) {
		d[i] = inf;
	}

	long long y;
	cin >> y;
	priority_queue < pair < long long, long long > > q;
	for (long long i = 0; i < y; i++) {
		long long f;
		cin >> f;
		--f;
		d[f] = 0;
		q.push({ 0, f });
	}


	while (!q.empty()) {
		auto nw = q.top();
		q.pop();
		long long tme = -nw.first;
		long long v = nw.second;

		if (used[v])
			continue;

		t[-tme].push_back(v);
		d[v] = tme;
		used[v] = true;
		
		for (auto ed : g[v]) {
			if (d[ed.first] > d[v] + ed.second) {
				d[ed.first] = d[v] + ed.second;
				q.push({ -d[ed.first], ed.first });
			}
		}
	}

	for (long long i = 0; i < tp; i++) {
		if (d[i] == inf) {
			t[len].push_back(i);
		}
	}
	long long ans = 0;
	for (auto nw : t) {
		for (auto kek : nw.second) {
			long long v = kek;
			p[v] = v;
			cnt++;
		}
		for (auto kek : nw.second) {
			long long v = kek;
			for (auto ed : g[v]) {
				long long to = ed.first;
				if (p[to] != -1) {
					merge(v, to);
				}
			}
		}
		ans = max(ans, cnt);
	}
	cout << ans;
}