#include <iostream>
#include <algorithm>
#include <map>
#include <string>
#include <stack> 
#include <vector>

using namespace std;

stack< vector< pair< string, int> >  > st;
map<string, int> m;

int get_num(string k) {
	bool h = false;
	if (k[0] == '-') {
		h = true;
		k = k.substr(1, k.length() - 1);
	}
	int ans = 0;
	for (int j = 0; j < k.length(); j++) {
		ans *= 10;
		ans += int(k[j]) - int('0');
	}
	if (h) {
		ans = -ans;
	}
	return ans;
}

int main() {
	::ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	st.push(vector< pair <string, int> >());
	string x;
	while (cin >> x) {
		if (x == "{") {
			st.push(vector< pair<string, int>>());
			continue;
		}
		if (x == "}") {
			for (int i = 0; i < st.top().size(); i++) {
				m[st.top()[i].first] = st.top()[i].second;
			}
			st.pop();
			continue;
		}
		int n = x.length(), i = 0;
		while (x[i] != '=') {
			i++;
		}
		string a = x.substr(0, i), b = x.substr(i + 1, n - i - 1);
		if ((int(b[0]) >= int('0') && int(b[0]) <= int('9')) || b[0] == '-') {
			int y = get_num(b);
			st.top().push_back(make_pair(a, m[a]));
			m[a] = y;
		}
		else {
			int y;
			if (m.find(a) == m.end()) {
				m[a] = 0;
			}
			if (m.find(b) == m.end()) {
				m[b] = 0;
				y = 0;
			}
			else {
				y = m[b];
			}
			st.top().push_back(make_pair(a, m[a]));
			m[a] = y;
			cout << y << '\n';
		}
	}
}