#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <climits>
#include <stdio.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef unsigned long long llu;

#define all(n) n.begin(), n.end()
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define files freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout)
#define mp(_first, _second) make_pair(_first, _second)

string Read()
{
	char c = _getc_nolock(stdin);
	while (!isalpha(c) && !isdigit(c) && c != '=' && c != '}' && c != '{' && c != '-')
	{
		if (c == -1)
			break;
		c = _getc_nolock(stdin);
	}
	string x = "\nsToP\n";
	while (isalpha(c) || isdigit(c) || c == '=' || c == '}' || c == '{' || c == '-')
	{
		if (x == ("\nsToP\n"))
			x.clear();
		x.push_back(c);
		c = _getc_nolock(stdin);
	}
	return x;
}

map<string, vector<pair<int, int>>> nv;

void callStack(int stach)
{
	string d;
	while (getline(cin, d))
	{
		//d = Read();
		if (d == "\nsToP\n")
			break;
		if (d.front() == '}')
		{
			for (auto i = nv.begin(); i != nv.end(); ++i)
				if (!i->second.empty())
					while (i->second.back().first >= stach)
					{
						i->second.pop_back();
						if (i->second.empty())
							break;
					}
			break;
		}
		if (d.front() == '{')
		{
			callStack(stach + 1);
			continue;
		}
		string v1, v2;
		int i = 0, val = INT_MAX;
		while (d[i] != '=') v1.push_back(d[i++]);
		++i;
		if (isdigit(d[i]) || d[i] == '-')
			val = atoi(d.substr(i, d.size() - i).c_str());
		else
			v2 = d.substr(i, d.size() - i);
		if (val == INT_MAX)
		{
			//init
			if (nv.find(v2) == nv.end())
				nv[v2] = vector<pair<int, int>>(1, mp(stach, 0));
			//reuse
			if (nv[v2].empty())
				nv[v2] = vector<pair<int, int>>(1, mp(stach, 0));
			//init
			if (nv.find(v1) == nv.end())
				nv[v1] = vector<pair<int, int>>(1, mp(stach, 0));
			//reuse
			if (nv[v1].empty())
				nv[v1] = vector<pair<int, int>>(1, mp(stach, 0));
			//createonthatstack
			if (nv[v1].back().first != stach && v1 != v2)
				nv[v1].push_back(mp(stach, 0));

			nv[v1].back().second = nv[v2].back().second;
			cout << nv[v2].back().second << endl;
		}
		else
		{
			//init
			if (nv.find(v1) == nv.end())
				nv[v1] = vector<pair<int, int>>(1, mp(stach, 0));
			//reuse
			if (nv[v1].empty())
				nv[v1] = vector<pair<int, int>>(1, mp(stach, 0));
			//createonthatstack
			if (nv[v1].back().first != stach)
				nv[v1].push_back(mp(stach, 0));

			nv[v1].back().second = val;
		}
	}
}

int main()
{
	//speed;
	//files;
	callStack(0);
	return 0;
}