#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const double EPS = 1e-6;
const int MAXN = 1e5 + 7;

map <string, int> val;

int toInt(string s) {
    int res = 0;
    bool fl = 0;
    for (int i = 0; i < (int) s.size(); i++) {
        if (!i && s[0] == '-') {
            fl = 1;
            continue;
        }
        char c = s[i];
        res *= 10;
        res += c - '0';
    }
    if (fl) {
        res = -res;
    }
    return res;
}

map <string, int> parse() {
    string s;
    map <string, int> backup;
    while (getline(cin, s)) {
        if (s[0] == '{') {
            auto a = parse();
            for (auto p : a) {
                val[p.first] = p.second - INF;
            }
            continue;
        }
        if (s[0] == '}') {
            return backup;
        }
        int pos = s.find('=');
        string a = s.substr(0, pos);
        string b = s.substr(pos + 1, s.size());
        if (b[0] == '-' || (b[0] >= '0' && b[0] <= '9')) {
            if (!backup[a]) {
                backup[a] = val[a] + INF;
            }
            val[a] = toInt(b);
            //cout << "!" << val[a] << "\n";
        } else {
            if (!backup[a]) {
                backup[a] = val[a] + INF;
            }
            val[a] = val[b];
            cout << val[a] << "\n";
        }
    }
    return backup;
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // MY
    parse();
}
