#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e18 + 7;
const double EPS = 1e-6;
const ll MAXN = 1e5 + 7;

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // MY
    vector <pair <ll, ll> > ps(3);
    for (ll i = 0; i < 3; i++) {
        cin >> ps[i].first >> ps[i].second;
    }
    sort(ps.begin(), ps.end());
    ll n;
    cin >> n;
    vector <ll> a, b;
    for (ll i = 0; i < n; i++) {
        ll x;
        cin >> x;
        if (x <= ps[1].first) {
            a.push_back(x);
        } else {
            b.push_back(x);
        }
    }
    sort(a.rbegin(), a.rend());
    sort(b.begin(), b.end());
    ll pl = 0;
    while (ps[0].second && a.size() && a.back() <= ps[0].first) {
        pl += abs(ps[0].first - a.back());
        a.pop_back();
        ps[0].second--;
    }
    while (ps[2].second && b.size() && b.back() >= ps[2].first) {
        pl += abs(b.back() - ps[2].first);
        b.pop_back();
        ps[2].second--;
    }
    vector <ll> toA(a.size() + 1, INF), toB(b.size() + 1, INF);
    ll suma = 0, sumb = 0;
    for (ll x : a) {
        suma += abs(ps[1].first - x);
    }
    for (ll x : b) {
        sumb += abs(x - ps[1].first);
    }
    toA[a.size()] = suma;
    for (ll i = 0; i < min((ll) a.size(), ps[0].second); i++) {
        ll x = a[i];
        suma -= abs(ps[1].first - x);
        suma += abs(x - ps[0].first);
        toA[a.size() - i - 1] = suma;
    }
    toB[b.size()] = sumb;
    for (ll i = 0; i < min((ll) b.size(), ps[2].second); i++) {
        ll x = b[i];
        sumb -= abs(x - ps[1].first);
        sumb += abs(ps[2].first - x);
        toB[b.size() - i - 1] = sumb;
    }
    ll dist = INF;
    if (ps[0].second > a.size()) {
        dist = min(dist, abs(ps[1].first - ps[0].first));
    }
    if (ps[2].second > b.size()) {
        dist = min(dist, abs(ps[2].first - ps[1].first));
    }
    for (ll i = 1; i <= (ll) b.size(); i++) {
        toB[i] = min(toB[i - 1], toB[i]);
    }
    ll ans = INF;
    for (ll x = 0; x <= (ll) a.size(); x++) {
        ll res = toA[x];
        if (x > ps[1].second) {
            if (dist == INF) continue;
            res += dist * abs(x - ps[1].second);
        }
        res += toB[max(0LL, ps[1].second - x)];
        //cout << x << " " << res << "\n";
        ans = min(ans, res);
    }
    cout << ans + pl;
}
