#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e18 + 7;
const double EPS = 1e-6;
const ll MAXN = 1e5 + 7;

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // MY
    vector <pair <ll, ll> > ps(3);
    for (ll i = 0; i < 3; i++) {
        cin >> ps[i].first >> ps[i].second;
    }
    sort(ps.begin(), ps.end());
    ll n;
    cin >> n;
    vector <ll> a, b;
    for (ll i = 0; i < n; i++) {
        ll x;
        cin >> x;
        if (x <= ps[1].first) {
            a.push_back(x);
        } else {
            b.push_back(x);
        }
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    vector <ll> toA(a.size() + 1, INF), toB(b.size() + 1, INF);
    ll suma = 0, sumb = 0;
    for (ll x : a) {
        suma += abs(ps[1].first - x);
    }
    for (ll x : b) {
        sumb += abs(x - ps[1].first);
    }
    toA[a.size()] = suma;
    for (ll i = 0; i < min((ll) a.size(), ps[0].second); i++) {
        ll x = a[i];
        suma -= abs(ps[1].first - x);
        suma += abs(x - ps[0].first);
        toA[a.size() - i - 1] = suma;
        //cout << i + 1 << " " << toA[a.size() - i - 1] << "\n";
    }
    toB[b.size()] = sumb;
    for (ll i = 0; i < min((ll) b.size(), ps[2].second); i++) {
        ll x = b[i];
        sumb -= abs(x - ps[1].first);
        sumb += abs(ps[2].first - x);
        toB[b.size() - i - 1] = sumb;
    }
    auto B = toB, A = toA;
    for (ll i = 1; i <= (ll) b.size(); i++) {
        B[i] = min(B[i - 1], B[i]);
    }
    for (ll i = 1; i <= (ll) a.size(); i++) {
        A[i] = min(A[i - 1], A[i]);
    }
    ll ans = INF;
    for (ll x = 0; x <= (ll) a.size(); x++) {
        if (toA[x] == INF) continue;
        ll res = toA[x];
        ll dist = abs(ps[1].first - ps[2].first);
        if (x > ps[1].second) {
            if (x - ps[1].second + b.size() > ps[2].second) {
                continue;
            }
            res += dist * abs(x - ps[1].second);
        }
        //cout << x << " " << toA[x] << "\n";
        res += B[max(0LL, ps[1].second - x)];
        ans = min(ans, res);
    }
    for (ll x = 0; x <= (ll) b.size(); x++) {
        if (toB[x] == INF) continue;
        ll res = toB[x];
        ll dist = abs(ps[1].first - ps[0].first);
        if (x > ps[0].second) {
            if (x - ps[0].second + a.size() > ps[0].second) {
                continue;
            }
            res += dist * abs(x - ps[0].second);
        }
        //cout << x << " " << toA[x] << "\n";
        res += A[max(0LL, ps[0].second - x)];
        ans = min(ans, res);
    }
    cout << ans;
}
