#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const double EPS = 1e-6;
const int MAXN = 1e5 + 7;

const int MAX_ST = 13;

ll st[MAX_ST];

bool isPrime(ll x) {
    if (x == 1) return false;
    for (ll i = 2; i * i <= x; ++i) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

ll up, down;

ll dfs(ll num, int len) {
    ll cnt = (num >= down);
//    if (num >= down) {
//        cout << num << "\n";
//    }
    ll now = num;
    for (int i = 1; i < 10; ++i) {
        now += st[len];
        if (now > up) {
            break;
        }
        if (isPrime(now)) {
            cnt += dfs(now, len + 1);
        }
    }
    return cnt;
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // MY
    st[0] = 1;
    for (int i = 1; i < MAX_ST; ++i) {
        st[i] = st[i - 1] * 10;
    }
    cin >> down >> up;
    cout << dfs(0, 0) << "\n";
    return 0;
}
