scopes = [{}]

import sys, re
num_ptn = re.compile('-?[0-9]+')

for expr in sys.stdin:
    expr = expr.strip()
    curr_scope = scopes[-1]
    if '=' in expr:
        lhs, rhs = expr.split('=')
        if num_ptn.fullmatch(rhs):
            curr_scope[lhs] = rhs
        else:
            val = curr_scope.get(rhs, '0')
            curr_scope[lhs] = val
            print(val)
    else:
        if expr == '{':
            scopes.append(curr_scope.copy())
        elif expr == '}':
            scopes.pop()

            
