#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>
#include <stack>

using namespace std;

pair<string, string> split(string st) {
	for (int i = 0; i < st.size(); ++i) {
		if (st[i] == '=') {
			return make_pair(st.substr(0, i), st.substr(i + 1, -1));
		}
	}
	return make_pair(st, "");
}

bool isnum(string st) {
	for (int i = st[0] == '-'; i < st.size(); ++i) {
		if (!(st[i] > 47 && st[i] < 58)) {
			return false;
		}
	}
	return true;
}

#define lhs (sres.first) 
#define rhs (sres.second) 

int main() {
	unordered_map<string, stack<string>> mp;
	vector<vector<string>> changed(1);
	int scope_idx = 0;
	string expr, temp;
	while (cin >> expr) {
		pair<string, string> sres = split(expr);
		if (rhs != "") {
			if (isnum(rhs)) {
				mp[lhs].push(rhs);
				changed[scope_idx].push_back(lhs);
			}
			else {
				temp = (mp[rhs].empty() ? "0" : mp[rhs].top());
				mp[lhs].push(temp);
				changed[scope_idx].push_back(lhs);
				cout << temp << endl;
			}
		}
		else {
			if (expr == "{") {
				scope_idx++;
				changed.emplace_back();
			}
			else {
				for (auto& var : changed[scope_idx]) {
					mp[var].pop();
				}
				scope_idx--;
				changed.pop_back();
			}
		}
	}
}