#include <iostream>
#include <vector>
#include <map>
#include <sstream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    vector<string> stk;
    map<string, vector<int> > mp;

    auto add = [&](string s) {
        int eqs = s.find('=');
        string lName = s.substr(0, eqs);
        s.erase(0, eqs+1);
        string rName = s;
        int val;
        if ('a' <= rName[0] && rName[0] <= 'z') {
            val = mp[rName].empty() ? 0 : mp[rName].back();
            cout << val << "\n";
        } else {
            istringstream(rName) >> val;
        }
        mp[lName].push_back(val);
    };

    auto unAdd = [&](string s) {
        int eqs = s.find('=');
        string lName = s.substr(0, eqs);
        mp[lName].pop_back();
    };

    while (!cin.eof()) {
        string s; getline(cin, s);
        if (s == "}") {
            while (stk.back() != "{") {
                unAdd(stk.back());
                stk.pop_back();
            }
            stk.pop_back();
            continue;
        }
        stk.push_back(s);
        if (s != "{") {
            add(stk.back());
        }
    }

    return 0;
}
