#include <iostream>
#include <vector>

using namespace std;

long long n;
vector <long long> a, k, d1, d2, d3, k1;
long long POW[65];

vector <long long> multiply(vector <long long> a, long long s);
vector <long long> sum (vector <long long> a, vector <long long> b);

int main()
{
    cin >> n;

    vector <long long> t(1, 1);

    POW[0] = 1;

    d1 = t;

    for (int i = 1; i < 63; i++)
        POW[i] = POW[i - 1] * 2LL;

    for (int i = 2 * n; i > 0;) {
        if (i > 26) {
            i -= 26;
            d1 = multiply(d1, POW[26]);
        }
        else {
            d1 = multiply(d1, POW[i]);
            i = -1;
        }
    }

    d2 = t;

    for (int i = 3 * n; i > 0;) {
        if (i > 26) {
            i -= 26;
            d2 = multiply(d2, POW[26]);
        }
        else {
            d2 = multiply(d2, POW[i]);
            i = -1;
        }
    }

    d3 = t;

    for (int i = 4 * n - 2; i > 0;) {
        if (i > 26) {
            i -= 26;
            d3 = multiply(d3, POW[26]);
        }
        else {
            d3 = multiply(d3, POW[i]);
            i = -1;
        }
    }

    a = sum(sum(d1, d2), d3);

    a[0] += 2;

    long long r = 0;

    for (int i = 0; i < a.size(); i++) {
        r = a[0] / 10;
        a[i] %= 10;

        if (i < a.size() - 1)
            a[i + 1] += r;
        else {
            a.push_back(r);

            break;
        }
    }

    for (int i = a.size() - 1; (i > 0) && !a.back(); i--)
        a.pop_back();

    for (int i = a.size() - 1; i > -1; i--)
        cout << a[i];
    return 0;
}

vector <long long> multiply(vector <long long> a, long long s) {
    if (s == 0) {
        a.clear();
        a.push_back(1);

        return a;
    }
    long long r = 0;

    for (int i = 0; i < a.size(); i++) {
        a[i] = a[i] * s + r;
        r = a[i] / 10;
        a[i] %= 10;
    }

    while (r) {
        a.push_back(r);
        r /= 10;
    }

    return a;
}

vector <long long> sum (vector <long long> a, vector <long long> b) {
    if (a.size() < b.size())
        swap(a, b);

    a.push_back(0);
    long long r = 0;

    for (int i = 0; i < b.size(); i++) {
        a[i] += b[i] + r;
        r = a[i] / 10;
        a[i] %= 10;
    }

    for (int i = b.size(); r; i++) {
        if (a.size() <= i)
            a.push_back(0);

        a[i] += r;
        r = a[i] / 10;
        a[i] %= 10;
    }

    return a;
}
