#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

bool isPrime[1000005];
long long POW[105];
vector <long long> prime;
vector <vector <long long> > s;
long long a, b;
long long result = 0;

void cross(long long x);
bool isPRIME(long long x);

int main()
{
    POW[0] = 1;

    for (int i = 1; i < 14; i++)
        POW[i] = POW[i - 1] * 10LL;

    for (int i = 2; i < 1000005; i++) {
        if (!isPrime[i]) {
            prime.push_back(i);

            cross(i);
        }
    }

    s.resize(15);
    s[11].push_back(2);
    s[11].push_back(3);
    s[11].push_back(5);
    s[11].push_back(7);

    for (int i = 10; i > -1; i--) {
        for (int number = 1; number < 9; number++) {
            for (int k = 0; k < s[i + 1].size(); k++) {
                long long cur = number * POW[11 - i] + s[i + 1][k];

                if (isPRIME(cur))
                    s[i].push_back(cur);
            }
        }
    }

    cin >> a >> b;

    for (int i = 0; i < 12; i++) {
        for (int j = 0; j < s[i].size(); j++) {
            if ((s[i][j] >= a) && (s[i][j] <= b))
                result++;
        }
    }

    cout << result;

    return 0;
}

void cross(long long x) {
    for (long long i = x * x; i < 1000005; i += x)
        isPrime[i] = 1;
}


bool isPRIME(long long x) {
    for (int i = 0; (prime[i] * prime[i]) < x; i++) {
        if (!(x % prime[i]))
            return 0;
    }

    return 1;
}
