// anime.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <map>
#include <stack>
#include <set>

using namespace std;

const long long INF = 1e18 + 7;

int main()
{
	long long n;
	cin >> n;
	vector<vector<pair<long long, long long> > > g(n);
	for (long long i = 0; i < n - 1; i++)
	{
		long long v1, v2, w;
		cin >> v1 >> v2 >> w;
		g[v1 - 1].push_back({ v2 - 1, w });
		g[v2 - 1].push_back({ v1 - 1, w });
	}
	vector<long long> dist(n, INF);
	long long m;
	cin >> m;
	set<pair<long long, long long> > q;
	set<long long> street;
	for (long long i = 0; i < m; i++)
	{
		long long c;
		cin >> c;
		dist[c - 1] = 0;
		q.insert({ dist[c - 1], c - 1 });
	}
	vector<bool> used(n, 0);
	long long cur = 1, answ = 0;
	while (!q.empty())
	{
		long long v = q.begin()->second;
		while (!street.empty() && (*street.begin()) <= dist[v])
		{
			street.erase(street.begin());
			cur--;
		}
		q.erase(q.begin());
		if (used[v])
		{
			continue;
		}
		used[v] = 1;
		for (long long i = 0; i < g[v].size(); i++)
		{
			if (!used[g[v][i].first])
			{
				if (dist[g[v][i].first] > dist[v] + g[v][i].second)
				{
					dist[g[v][i].first] = dist[v] + g[v][i].second;
					q.insert({ dist[g[v][i].first], g[v][i].first });
				}
				cur++;
			}
			else if(used[g[v][i].first])
			{
				if (g[v][i].second <= dist[v] - dist[g[v][i].first])
					cur--;
				else
				{
					long long tmp = g[v][i].second - dist[v] + dist[g[v][i].first];
					street.insert(dist[v] + tmp / 2 + (tmp % 2));
				}
			}
		}
		answ = max(answ, cur);
	}
	cout << answ;
	cin >> n;
	return 0;
}