import java.util.*;
import java.io.*;

public class E {
	FastScanner in;
	PrintWriter out;
	
	public void solve() {
		int[][] pl = new int[3][2];
		for(int i = 0; i < 3; i++) {
			pl[i][0] = in.nextInt();
			pl[i][1] = in.nextInt();
		}
		Comparator<int[]> comp = new Comparator<int[]>(){

			@Override
			public int compare(int[] o1, int[] o2) {
				return o1[0] - o2[0];
			}
			
		};
		Arrays.sort(pl, comp);
		Point ap = new Point(pl[0][0], pl[0][1]);
		Point bp = new Point(pl[1][0], pl[1][1]);
		Point cp = new Point(pl[2][0], pl[2][1]);
		int n = in.nextInt();
		long[] x = new long[n];
		for (int i = 0; i < n; i++) {
			x[i] = in.nextLong();
		}
		Arrays.sort(x);
		int id = 0;
		int l = 0;
		int r = 0;
		long sum = 0;
		while (x[id] <= ap.x) {
			if (ap.c > 0) {
				sum += Math.abs(ap.x - x[id]);
				ap.c--;
			} else {
				if (bp.c > 0) {
					sum += Math.abs(bp.x - x[id]);
					bp.c--;
				} else {
					if (cp.c > 0) {
						sum += Math.abs(cp.x - x[id]);
						cp.c--;
					}
				}
			}
			id++;
		}
		l = id;
		id = n - 1;
		while (x[id] >= cp.x) {
			if (cp.c > 0) {
				sum += Math.abs(cp.x - x[id]);
				cp.c--;
			} else {
				if (bp.c > 0) {
					sum += Math.abs(bp.x - x[id]);
					bp.c--;
				} else {
					if (ap.c > 0) {
						sum += Math.abs(ap.x - x[id]);
						ap.c--;
					}
				}
			}
			id--;
		}
		r = id;
		long llen = (bp.x - ap.x)/2;
		long rlen = (cp.x - bp.x)/2;
		while (x[l] <= ap.x + llen) {
			if (ap.c > 0) {
				sum += Math.abs(ap.x - x[l]);
				ap.c--;
			} else {
				break;
			}
			l++;
		}
		while (x[r] >= cp.x - rlen) {
			if (cp.c > 0) {
				sum += Math.abs(cp.x - x[r]);
				cp.c--;
			}
			r--;
		}
		while (r - l + 1 > bp.c) {
			if (ap.c == 0) {
				while (bp.c > 0 && l <= r) {
					sum += Math.abs(bp.x - x[l]);
					bp.c--;
					l++;
				}
				while (l <= r) {
					sum += Math.abs(cp.x - x[l]);
					cp.c--;
					l++;
				}
				break;
			}
			if (cp.c == 0) {
				while (bp.c > 0 && r >= l) {
					sum += Math.abs(bp.x - x[r]);
					bp.c--;
					r++;
				}
				while (r >= l) {
					sum += Math.abs(ap.x - x[r]);
					ap.c--;
					r++;
				}
				break;
			}
			long ll = Math.abs(x[l] - ap.x) + Math.abs(x[r] - bp.x);
			long rr = Math.abs(x[l] - bp.x) + Math.abs(x[r] - cp.x);
			if (ll < rr) {
				sum += Math.abs(x[l] - ap.x);
				ap.c--;
				l++;
			} else {
				sum += Math.abs(x[r] - cp.x);
				cp.c--;
				r--;
			}
		}
		out.print(sum);
	}
	
	static class Point {
		long x;
		long c;
		public Point(long x, long c) {
			this.x = x;
			this.c = c;
		}
	}
	public void run() {
		in = new FastScanner();
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		solve();
		out.close();
	}
	
	class FastScanner {
		StringTokenizer st;
		BufferedReader br;
		
		FastScanner () {
			br = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
		
		long nextLong() {
			return Long.parseLong(next());
		}
		
		double nextDouble() {
			return Double.parseDouble(next());
		}
		

	}
	
	public static void main (String[] args) {
		new E().run();
	}
}
