import java.util.*;
import java.io.*;

public class Task_K {
	FastScanner in;
	PrintWriter out;
	
	static int cons = 11;
	public void solve() {
		int n = in.nextInt();
		int[] sumAll = new int[cons];
		int[] sum = new int[cons];
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = in.nextInt();
			int j = 0;
			int w = a[i];
			while (w != 0) {
				sumAll[j] += w % 10;
				j++;
				w /= 10;
			}
		}
		for (int i = 0; i < n; i++) {
			int j = 0;
			int w = a[i];
			while (w != 0) {
				sum[j] += (w % 10) * (n - 1);
				w /= 10;
				j++;
			}
			int t = j;
			while(t < cons) {
				sum[t] += sumAll[t-j]-findSum(a[i], t-j);
				t++;
			}
		}
		long ans = 0;
		long pow = 1;
		for(int i = 0;i<cons;i++) {
			ans += (long) pow*sum[i];
			ans %= 1000000007;
			pow *= 10;
		}
		out.println(ans);
	}

	private int findSum(int a, int i) {
		int j = 0;
		while(j != i) {
			a /= 10;
			j++;
		}
		return a % 10;
	}

	public void run() {
		in = new FastScanner();
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		solve();
		out.close();
	}

	class FastScanner {
		StringTokenizer st;
		BufferedReader br;

		FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		// boolean hasNext() {
		// if (st != null && st.hasMoreTokens())
		// return true;
		//
		// }
	}

	public static void main(String[] args) {
		new Task_K().run();
	}
}
