#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umin(T1 &x, const T2 &y) {if(x>y)return x=y,true; return false;}
template <typename T1, typename T2>
bool umax(T1 &x, const T2 &y) {if(x<y)return x=y,true; return false;}

template<typename T>
T getint() {
    T x = 0, p = 1;
    char ch;
    do {ch = getchar();} while(ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10 + ch-'0';
        ch = getchar();
    }
    return x*p;
}

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<ll> vll;

const int N = (int)1e6+10;
const int INF = (int)2e9+10;
const ll mod = (ll)1e9+7;
const ll LLINF = (ll)1e18+10;
const ld pi = (ld)acos(-1.0);

int a, na, b, nb, c, nc;
int n, h[N];
ll t[N];
int pot[N];
ll sp[20][N];

void build() {
    for(int i = 1; i <= n+1; ++i) {
        pot[i] = pot[i-1];
        if((1<<(pot[i]+1))==i)
            ++pot[i];
    }
    for(int i = 0; i <= n+1; ++i) {
        sp[0][i] = t[i];
    }
    for(int i = 1; i < 20; ++i) {
        for(int j = 0; j <= n+1-(1<<i)+1; ++j) {
            sp[i][j] = min(sp[i-1][j], sp[i-1][j+(1<<(i-1))]);
        }
    }
}

ll get(int l, int r) {
    int lg = pot[r-l+1];
    return min(sp[lg][l], sp[lg][r-(1<<lg)+1]);
}

int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    cin >> a >> na >> b >> nb >> c >> nc;
    vpii v = {mp(a, na), mp(b, nb), mp(c, nc)};
    sort(all(v));
    a = v[0].F; na = v[0].S;
    b = v[1].F; nb = v[1].S;
    c = v[2].F; nc = v[2].S;
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> h[i];
    }
    sort(h+1, h+n+1);
    for(int i = n; i >= 1; --i) {
        t[i] = t[i+1]+abs(c-h[i]);
    }
    ll bal = 0;
    for(int i = 2; i <= n+1; ++i) {
        bal += abs(h[i-1]-b);
        t[i] += bal;
    }
    build();
    ll add = 0, sub = 0;
    ll ans = LLINF;
    set <ll> s;
    for(int i = 0; i <= min(na, n); ++i) {
        if(i) add += abs(a-h[i]);
        if(i) sub += abs(b-h[i]);
        int l = max(i+1, n-nc+1), r = min(i+nb+1, n+1);
      //  cout << i << ' ' << l << ' ' << r << '\n';
        if(l>r) continue;
        umin(ans, add+get(l, r)-sub);
    }
    cout << ans;

    return 0;
}
