#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

const long long M = 1e9 + 7;

int fac(long long n) {
    if(n < 10)
        return 0;
    else if(n < 100)
        return 1;
    else if(n < 1000)
        return 3;
    else if(n < 10000)
        return 4;
    else if(n < 100000)
        return 5;
    else if(n < 1000000)
        return 6;
    else if(n < 10000000)
        return 7;
}

long long pow(long long a, long long b) {
    if(b == 0)
        return 1;
    long long now = pow(a, b / 2);
    now = ((now * now) % M);
    if(b % 2 == 0)
        return now;
    else
        return now * a % M;
}

int main() {
    long long sum = 0;
    int n;
    cin >> n;
    vector<long long> v(n);
    for(int i = 0; i < n; i++) {
        cin >> v[i];
        sum += v[i];
        sum %= M;
    }

    long long ans = 0;
    for(int i = 0; i < n; i++) {
        long long s = (sum - v[i] + M) % M;
        long long now = (s * pow(10, (fac(v[i]) + 1))) % M;
        now += (n - 1) * v[i];
        now %= M;
        ans += now;
        ans %= M;
    }

    cout << ans << endl;

    return 0;
}
