#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

map< string, vector< pair<int, int> > > table;
vector<string> command;
int op;

int atoi(string& x) {
    int xx = 0;
    bool f = false;
    for (char ch : x) {
        if (ch == '-') {
            f = true;
        } else {
            xx = xx * 10 + ch - '0';
        }
    }
    return (f ? -xx:xx);
}

int get_val(string& x) {
    if (table[x].size() == 0) {
        return 0;
    }
    return table[x].back().second;
}

void set_val(int d, string& x, int what) {
    if (table[x].size() == 0 || table[x].back().first != d) {
        table[x].push_back({d, what});
    } else {
        table[x].back().second = what;
    }
}

void solve(int d) {
    set<string> edited;
    while (op != command.size() && command[op] != "}") {
        if (command[op] == "{") {
            op++;
            solve(d + 1);
            continue;
        }
        string s1, s2;
        int id = 0;
        while (command[op][id] != '=') {
            s1.push_back(command[op][id]);
            id++;
        }
        id++;
        s2 = command[op].substr(id);
        //cout << command[op] << ' ' << id << " deb" << s1 << ' ' << s2 << endl;
        if (s2[0] >= 'a' && s2[0] <= 'z') {
            int a = get_val(s2);
            cout << a << '\n';
            set_val(d, s1, a);
            edited.insert(s1);
        } else {
            int a = atoi(s2);
            set_val(d, s1, a);
            edited.insert(s1);
        }
        op++;
    }
    op++;
    for (string xx : edited) table[xx].pop_back();
}

void solve() {
    freopen("input.txt", "r", stdin);
    string s;
    while (cin >> s) command.push_back(s);
    solve(0);

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

    return 0;
}

