#include <bits/stdc++.h>


#define len(v) ((int)v.size())
#define int long long


using namespace std;


typedef long long ll;

const ll MOD = 1e9 + 7;

ll fast_pow(ll x, ll p) {
	if (p == 0) return 1;
	if (p & 1) {
		return (x * fast_pow(x, p - 1)) % MOD;
	} else {
		ll sub = fast_pow(x, p / 2);
		return (sub * sub) % MOD;
	}
}

ll plus(ll a, ll b) {
	return (a + b) % MOD;
}

ll prod(ll a, ll b) {
	return (a * b) % MOD;
}

ll nop(ll x) {
	return x % MOD;
}

namespace solver {
	vector<int> v;
	vector<int> dp_pr;
	vector<vector<int>> dp_one;
	vector<vector<int>> dp_two;


	int pr(int i) {
		if (i < 0) return 0;
		if (dp_pr[i] != -1) return dp_pr[i];
		return dp_pr[i] = (v[i] + 1 + pr(i - 1)) % MOD;
	}

	int one(int i, bool fixed) {
		if (i == 0) return v[i] + 1;
		if (dp_one[i][fixed] != -1) return dp_one[i][fixed];
		if (fixed) {
			return dp_one[i][fixed] = pr(i);
		} else {
			return dp_one[i][fixed] = (prod(one(i - 1, true), (v[i] + 1)) + one(i - 1, false) + (v[i] + 1)) % MOD;
		}	
	}

	int two(int i, bool fixed) {
		if (i == 0) return 0;
		if (dp_two[i][fixed] != -1) return dp_two[i][fixed];
		if (fixed) {
			return dp_two[i][fixed] = (two(i - 1, true)
				+ prod(nop(v[i] * (v[i] + 1) / 2), one(i - 1, true))
				+ prod((v[i] + 1), one(i - 1, false))) % MOD;	
		} else {
			return dp_two[i][fixed] = (two(i, true) + prod(two(i - 1, true), v[i]) + two(i - 1, false)) % MOD;
		}	
	}

	int two_last(int i) {
		return two(i, false) - two(i, true);
	}
	
	void prepare(vector<int> _v) {
		v = _v;
		dp_pr = vector<int>(len(v), -1);
		dp_one = vector<vector<int>>(len(v), vector<int>(2, -1));
		dp_two = vector<vector<int>>(len(v), vector<int>(2, -1));
	}
};


signed main() {
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	
	vector<int> right(n, n);
	vector<int> left(n, -1);
	vector<int> st;
	for (int i = n - 1; i > -1; i--) {
		while (!st.empty() && v[st.back()] <= v[i]) {
			st.pop_back();
		}
		if (!st.empty()) {
			right[i] = st.back();	
		}
		st.push_back(i);
	}
	
	st.clear();
	for (int i = 0; i < n; i++) {
		while (!st.empty() && v[st.back()] <= v[i]) {
			st.pop_back();
		}
		if (!st.empty()) {
			left[i] = st.back();
		}
		st.push_back(i);
	}

	map<int, vector<int>> all;
	for (int i = 0; i < n; i++) {
		all[v[i]].push_back(i);
	}
	ll rez = 0;
	for (auto p : all) {
		set<pair<int, bool>> cords;
		for (int ind : p.second) {
			cords.emplace(ind, true);
			cords.emplace(right[ind], false);
			cords.emplace(left[ind], false);
		}

		vector<ll> part;
		vector<int> st;
		int pref = -1e9;
		for (auto t : cords) {
			if (t.second) {
				st.push_back(t.first - pref - 1);	
			} else {
				if (!st.empty()) {
					st.push_back(t.first - pref - 1);
					solver::prepare(st);
					part.push_back(solver::one(len(st) - 1, false) - solver::one(len(st) - 1, true));
					rez += solver::two_last(len(st) - 1);
					rez %= MOD;
				}
				st.clear();
			}
			pref = t.first;
		}
		
		ll cock = 0;
		for (ll q : part) {
			cock += q;
			cock %= MOD;
		}
		ll sub = 0;
		for (ll q : part) {
			sub += q * (cock - q);
			sub %= MOD;
		}
		rez += sub * fast_pow(2, MOD - 2);
		rez %= MOD;
	}
	while (rez < 0) {
		rez += MOD;
	}
	rez %= MOD;
	cout << rez << endl;
}



















