#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif // _DEBUG

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

const ll LINF = 8e18;

int solve()
{
    int n;
    cin >> n;
    vector<vector<pii>> g(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y, c;
        cin >> x >> y >> c;
        --x, --y;
        g[x].inb(mk(y, c * 2));
        g[y].inb(mk(x, c * 2));
    }
    vector<ll> dst(n, LINF);
    int m;
    cin >> m;
    set<pair<ll, int>> q;
    for (int i = 0; i < m; ++i)
    {
        int x;
        cin >> x;
        --x;
        q.insert(mk(0, x));
        dst[x] = 0;
    }
    while (!q.empty())
    {
        ll d = q.begin()->X;
        int u = q.begin()->Y;
        q.erase(*q.begin());
        for (auto to : g[u])
        {
            if (d + to.Y >= dst[to.X])
                continue;
            q.erase(mk(dst[to.X], to.X));
            dst[to.X] = d + to.Y;
            q.insert(mk(dst[to.X], to.X));
        }
    }
    vector<pair<ll, pii>> sc;
    for (int i = 0; i < n; ++i)
    {
        sc.inb(mk(dst[i], mk(n, i)));
    }
    vector<vector<ll>> dr(n);
    for (int u = 0; u < n; ++u)
    {
        dr[u].resize(g[u].size());
        for (int i = 0; i < (int)g[u].size(); ++i)
        {
            int to = g[u][i].X;
            ll dd = g[u][i].Y;
            if (abs(dst[u] - dst[to]) == dd)
            {
                dr[u][i] = max(dst[u], dst[to]);
            }
            else
            {
                ll t1 = min(dst[u], dst[to]);
                ll t2 = max(dst[u], dst[to]);
                dr[u][i] = (t2) + (dd - t2 + t1) / 2;
            }
            if (u < to)
            {
                sc.inb(mk(dr[u][i], mk(u, to)));
            }
        }
    }
    sort(all(sc));
    reverse(all(sc));
    int lst = -1;
    int ans = 1;
    int cur = 0;
    //vi p(n, -1);
    map<pii, pii> p;
    //vi r(n, 0);
    map<pii, int> r;
    set<pii> alive;
    function<pii(pii)> get = [&](pii u)
    {
        if (p.find(u) == p.end())
            return mk(-1, -1);
        if (u == p[u])
            return u;
        return p[u] = get(p[u]);
    };
    for (auto ev : sc)
    {
        int t = ev.X;
        int u = ev.Y.X;
        int to = ev.Y.Y;
        if (t != lst)
        {
            ans = max(ans, cur);
            //cout << cur << " " << lst << "\n";
            lst = t;
        }
        if (u == n)
        {
            ///v
            //cout << "NEW VERT: " << to << "\n";
            u = to;
            p[mk(u, u)] = mk(u, u);
            ++cur;
            for (auto to : g[u])
            {
                if (alive.find(mk(u, to.X)) != alive.end() || alive.find(mk(to.X, u)) != alive.end())
                {
                    pii x = get(mk(u, u));
                    pii y = get(mk(min(u, to.X), max(u, to.X)));
                    if (x != y)
                    {
                        --cur;
                        if (r[x] < r[y])
                            swap(x, y);
                        p[y] = x;
                        if (r[y] == r[x])
                            ++r[x];
                    }
                }
            }
        }
        else
        {
            ///e
            //cout << "NEW EDGE: " << u << " " << to << "\n";
            alive.insert(mk(u, to));
            p[mk(u, to)] = mk(u, to);
            ++cur;
            {
                pii x = get(mk(u, u));
                pii y = get(mk(u, to));
                if (x.X != -1 && y.X != -1 && x != y)
                {
                    --cur;
                    if (r[x] < r[y])
                        swap(x, y);
                    p[y] = x;
                    if (r[y] == r[x])
                        ++r[x];
                }
            }
            {
                pii x = get(mk(to, to));
                pii y = get(mk(u, to));
                if (x.X != -1 && y.X != -1 && x != y)
                {
                    --cur;
                    if (r[x] < r[y])
                        swap(x, y);
                    p[y] = x;
                    if (r[y] == r[x])
                        ++r[x];
                }
            }
        }
    }//*/
    ans = max(ans, cur);
    //cout << cur << "\n";
    cout << ans;
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    #ifdef _DEBUG
    freopen("01.txt", "r", stdin);
    #endif // _DEBUG
    solve();
    return 0;
}

