//
// Created by orspc on 10.12.2017.
//

#include <iostream>
#include <map>
#include <string>
#include <vector>

bool isNum(std::string& s) {
    if (s[0] == '-') {
        return true;
    }
    return '0' <= s[0] && s[0] <= '9';
}

int toInt(std::string& s) {
    return atoi(s.c_str());
}

int main() {
    std::vector<std::map<std::string, int>> st;
    st.push_back(std::map<std::string, int>());
    st.reserve(1e5);

    std::string s;
    while (std::cin >> s) {

        if (s == "{") {
            st.push_back(std::map<std::string, int>());
        } else if (s == "}") {
            st.pop_back();
        } else {

            std::string var1, var2;

            int i;
            for (i = 0; s[i] != '='; ++i);

            var1 = s.substr(0, i);
            var2 = s.substr(i + 1, s.size() - i - 1);

            if (isNum(var2)) {
                st[st.size() - 1][var1] = toInt(var2);
            } else {
                int index;
                for (index = st.size() - 1; index >= 0; --index) {
                    if (st[index].count(var2)) {
                        break;
                    }
                }
              //  std::cout << "ind: " << index << '\n';
                if (index == -1) {
                    st[st.size() - 1][var1] = 0;
                    std::cout << 0 << '\n';
                } else {
                    st[st.size() - 1][var1] = st[index][var2];
                    std::cout << st[index][var2] << '\n';
                }
            }
        }
    }
    return 0;
}
