//
// Created by orspc on 10.12.2017.
//

#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <stack>

bool isNum(std::string& s) {
    if (s[0] == '-') {
        return true;
    }
    return '0' <= s[0] && s[0] <= '9';
}

int toInt(std::string& s) {
    return atoi(s.c_str());
}

int main() {
    std::vector<std::map<std::string, int>> st;
    st.push_back(std::map<std::string, int>());
    st.reserve(1e5);
    std::map<std::string, std::stack<int>> lvl;
    int cur_lvl = 0;
    std::string s;
    while (std::cin >> s) {

        if (s == "{") {
            cur_lvl++;
            st.push_back(std::map<std::string, int>());
        } else if (s == "}") {
            for (auto& now : st.back()) {
                lvl[now.first].pop();
                if (lvl[now.first].empty()) {
                    lvl.erase(now.first);
                }
            }
            cur_lvl--;
            st.pop_back();
        } else {

            std::string var1, var2;

            int i;
            for (i = 0; s[i] != '='; ++i);

            var1 = s.substr(0, i);
            var2 = s.substr(i + 1, s.size() - i - 1);

            if (isNum(var2)) {
                if (lvl.count(var1) == 0) {
                    lvl[var1] = std::stack<int>();
                }
                lvl[var1].push(cur_lvl);
                st[st.size() - 1][var1] = toInt(var2);
            } else {
                if (lvl.count(var2) == 0) {
                    st[st.size() - 1][var1] = 0;
                    if (lvl.count(var1) == 0) {
                        lvl[var1] = std::stack<int>();
                    }
                    lvl[var1].push(cur_lvl);
                    std::cout << 0 << '\n';
                } else {
                    st[st.size() - 1][var1] = st[lvl[var2].top()][var2];
                    if (lvl.count(var1) == 0) {
                        lvl[var1] = std::stack<int>();
                    }
                    lvl[var1].push(cur_lvl);
                    std::cout << st[lvl[var2].top()][var2] << '\n';
                }
            }
        }
    }
    return 0;
}