#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using ll = long long;

ll MOD = 1e9 + 7;

ll mod(ll x) {
    return ((x % MOD + MOD) % MOD);
}

ll cnt(ll x) {
    ll ans = 1;
    while(x) {
        x /= 10;
        ans = mod(ans * 10);
    }
    return mod(ans);
}

int main() {
    int n;
    std::cin >> n;
    std::vector<ll> a(n + 1);
    std::vector<ll> deg(n + 1);
    ll s = 0;
    ll k = 0;
    for (int i = 1; i <= n; ++i) {
        std::cin >> a[i];
        s += mod(a[i]);
        s = mod(s);
        deg[i] = cnt(a[i]);
        k += mod(deg[i]);
        k = mod(k);
    }
    //std::cout << s << " " << k << "\n";
    ll sum = 0;
    for (int i = 1; i <= n; ++i) {
        sum += mod(mod(mod(a[i]) * mod(k - deg[i])) + s - a[i]);

    }
    std::cout << sum;
    return 0;
}

