// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

int main(){
	ios_base::sync_with_stdio(0);
	//freopen("input.in", "r", stdin);
	//freopen("output.out", "w", stdout);
	stack<pair<int, int>> stck;
	string s;
	int cur = 1;
	map<string, int> id;
	vector<vector<int> > deep(1);
	vector<stack<pair<int, int> > > hist(1);
	while (cin >> s) {
		if (s[0] == '{') {
			deep.push_back(vector<int> (0));
		} else if (s[0] == '}') {
			while (!deep.back().empty()) {
				if (!hist[deep.back().back()].empty() && hist[deep.back().back()].top().first == deep.size())
					hist[deep.back().back()].pop();
				deep.back().pop_back();
			}
			deep.pop_back();
		} else {
			string name;
			int pos;
			for (pos = 0; s[pos] != '='; ++pos)
				name += s[pos];
			int t1 = id[name];
			
			if (t1 == 0) {
				t1 = id[name] = hist.size();
				hist.push_back(stck);
			}
			name.clear();
			long long val = 0;
			long long sign = 1;
			for (++pos; pos < s.length(); ++pos) {
				if (s[pos] == '-')
					sign = -1;
				else if (s[pos] >= '0' && s[pos] <= '9')
					val = (val * 10 + s[pos] - '0');
				else
					name += s[pos];
			}
			val *= sign;
			if (name.length() != 0) {
				int it2 = id[name];
				if (hist[it2].empty())
					val = 0;
				else
					val = hist[it2].top().second;
			}
			hist[t1].push({ deep.size(), val });
			deep.back().push_back(t1);
			if (name.length() != 0)
				cout << val << '\n';
		}
	}

	return 0;
}

