// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

int main(){
	ios_base::sync_with_stdio(0);
	//freopen("input.in", "r", stdin);
	//freopen("output.out", "w", stdout);
	vector <pair <ll, ll>> sc(3);
	cin >> sc[0].first >> sc[0].second;
	cin >> sc[1].first >> sc[1].second;
	cin >> sc[2].first >> sc[2].second;
	sort(sc.begin(), sc.end());

	int n;
	cin >> n;

	vector <ll> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	sort(v.begin(), v.end());

	int l = 0, r = n;

	while (r - l > 2) {
		int ml = (2 * l + r) / 3;
		int mr = (2 * r + l) / 3;

		if (ml > sc[0].second) {
			r = mr;
			continue;
		}
		if (mr > sc[0].second) {
			r = mr;
			continue;
		}

		ll cntl = 0, cntr = 0;
		int mll = ml, mlr = n;
		while (mlr - mll > 2) {
			int mml = (2 * mll + mlr) / 3;
			int mmr = (2 * mlr + mll) / 3;

			if (mml - ml > sc[1].second) {
				mlr = mmr;
				continue;
			}
			if (mmr - ml > sc[1].second) {
				mlr = mmr;
				continue;
			}

			if (n - mmr > sc[2].second) {
				mll = mml;
				continue;
			}
			if (n - mml > sc[2].second) {
				mll = mml;
				continue;
			}

			ll cntll = 0, cntlr = 0;
			for (int i = 0; i < ml; i++) {
				cntll += abs(sc[0].first - v[i]);
			}
			for (int i = ml; i < mml; i++) {
				cntll += abs(sc[1].first - v[i]);
			}
			for (int i = mml; i < n; i++) {
				cntll += abs(sc[2].first - v[i]);
			}

			for (int i = 0; i < ml; i++) {
				cntlr += abs(sc[0].first - v[i]);
			}
			for (int i = ml; i < mmr; i++) {
				cntlr += abs(sc[1].first - v[i]);
			}
			for (int i = mmr; i < n; i++) {
				cntlr += abs(sc[2].first - v[i]);
			}

			if (cntll < cntlr)
				mll = mml;
			else
				mlr = mmr;
		}

		for (int i = 0; i < ml; i++) {
			cntl += abs(sc[0].first - v[i]);
		}
		for (int i = ml; i < mll; i++) {
			cntl += abs(sc[1].first - v[i]);
		}
		for (int i = mll; i < n; i++) {
			cntl += abs(sc[2].first - v[i]);
		}

		int mrl = mr, mrr = n;
		while (mrr - mrl > 2) {
			int mml = (2 * mrl + mrr) / 3;
			int mmr = (2 * mrr + mrl) / 3;

			if (mml - mr > sc[1].second) {
				mrr = mmr;
				continue;
			}
			if (mmr - mr > sc[1].second) {
				mrr = mmr;
				continue;
			}

			if (n - mmr > sc[2].second) {
				mrl = mml;
				continue;
			}
			if (n - mml > sc[2].second) {
				mrl = mml;
				continue;
			}

			ll cntll = 0, cntlr = 0;
			for (int i = 0; i < mr; i++) {
				cntll += abs(sc[0].first - v[i]);
			}
			for (int i = mr; i < mml; i++) {
				cntll += abs(sc[1].first - v[i]);
			}
			for (int i = mml; i < n; i++) {
				cntll += abs(sc[2].first - v[i]);
			}

			for (int i = 0; i < mr; i++) {
				cntlr += abs(sc[0].first - v[i]);
			}
			for (int i = mr; i < mmr; i++) {
				cntlr += abs(sc[1].first - v[i]);
			}
			for (int i = mmr; i < n; i++) {
				cntlr += abs(sc[2].first - v[i]);
			}

			if (cntll < cntlr)
				mrl = mml;
			else
				mrr = mmr;
		}

		for (int i = 0; i < mr; i++) {
			cntr += abs(sc[0].first - v[i]);
		}
		for (int i = mr; i < mrl; i++) {
			cntr += abs(sc[1].first - v[i]);
		}
		for (int i = mrl; i < n; i++) {
			cntr += abs(sc[2].first - v[i]);
		}

		if (cntl < cntr)
			l = ml;
		else
			r = mr;
	}
	
	ll cnt = 0;

	int l0 = l, r0 = n;
	while (r0 - l0 > 2) {
		int mml = (2 * l0 + r0) / 3;
		int mmr = (2 * r0 + l0) / 3;

		if (mml - l > sc[1].second) {
			r0 = mmr;
			continue;
		}
		if (mmr - l > sc[1].second) {
			r0 = mmr;
			continue;
		}

		if (n - mmr > sc[2].second) {
			l0 = mml;
			continue;
		}
		if (n - mml > sc[2].second) {
			l0 = mml;
			continue;
		}

		ll cntll = 0, cntlr = 0;
		for (int i = 0; i < l; i++) {
			cntll += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mml; i++) {
			cntll += abs(sc[1].first - v[i]);
		}
		for (int i = mml; i < n; i++) {
			cntll += abs(sc[2].first - v[i]);
		}

		for (int i = 0; i < l; i++) {
			cntlr += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mmr; i++) {
			cntlr += abs(sc[1].first - v[i]);
		}
		for (int i = mmr; i < n; i++) {
			cntlr += abs(sc[2].first - v[i]);
		}

		if (cntll < cntlr)
			l0 = mml;
		else
			r0 = mmr;
	}

	int x = 0;
	ll ans = 1e18;
	for (int i = 0; i < l + 1; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l + 1; i < l0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < min(l0 + 1, n); i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = min(l0 + 1, n); i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < r0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = r0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	l0 = l + 1, r0 = n;
	cnt = 0;
	while (r0 - l0 > 2) {
		int mml = (2 * l0 + r0) / 3;
		int mmr = (2 * r0 + l0) / 3;

		if (mml - l > sc[1].second) {
			r0 = mmr;
			continue;
		}
		if (mmr - l > sc[1].second) {
			r0 = mmr;
			continue;
		}

		if (n - mmr > sc[2].second) {
			l0 = mml;
			continue;
		}
		if (n - mml > sc[2].second) {
			l0 = mml;
			continue;
		}

		ll cntll = 0, cntlr = 0;
		for (int i = 0; i < l; i++) {
			cntll += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mml; i++) {
			cntll += abs(sc[1].first - v[i]);
		}
		for (int i = mml; i < n; i++) {
			cntll += abs(sc[2].first - v[i]);
		}

		for (int i = 0; i < l; i++) {
			cntlr += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mmr; i++) {
			cntlr += abs(sc[1].first - v[i]);
		}
		for (int i = mmr; i < n; i++) {
			cntlr += abs(sc[2].first - v[i]);
		}

		if (cntll < cntlr)
			l0 = mml;
		else
			r0 = mmr;
	}

	x = 0;
	for (int i = 0; i < l + 1; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l + 1; i < l0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < min(l0 + 1, n); i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = min(l0 + 1, n); i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < r0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = r0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	l0 = r, r0 = n;
	cnt = 0;
	while (r0 - l0 > 2) {
		int mml = (2 * l0 + r0) / 3;
		int mmr = (2 * r0 + l0) / 3;

		if (mml - l > sc[1].second) {
			r0 = mmr;
			continue;
		}
		if (mmr - l > sc[1].second) {
			r0 = mmr;
			continue;
		}

		if (n - mmr > sc[2].second) {
			l0 = mml;
			continue;
		}
		if (n - mml > sc[2].second) {
			l0 = mml;
			continue;
		}

		ll cntll = 0, cntlr = 0;
		for (int i = 0; i < l; i++) {
			cntll += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mml; i++) {
			cntll += abs(sc[1].first - v[i]);
		}
		for (int i = mml; i < n; i++) {
			cntll += abs(sc[2].first - v[i]);
		}

		for (int i = 0; i < l; i++) {
			cntlr += abs(sc[0].first - v[i]);
		}
		for (int i = l; i < mmr; i++) {
			cntlr += abs(sc[1].first - v[i]);
		}
		for (int i = mmr; i < n; i++) {
			cntlr += abs(sc[2].first - v[i]);
		}

		if (cntll < cntlr)
			l0 = mml;
		else
			r0 = mmr;
	}

	x = 0;
	for (int i = 0; i < l + 1; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l + 1; i < l0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < min(l0 + 1, n); i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = min(l0 + 1, n); i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cnt = 0;
	x = 0;
	for (int i = 0; i < l; i++, x++) {
		cnt += abs(sc[0].first - v[i]);
	}
	if (x > sc[0].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = l; i < r0; i++, x++) {
		cnt += abs(sc[1].first - v[i]);
	}
	if (x > sc[1].second || x < 0)
		x = -1e9;
	else
		x = 0;
	for (int i = r0; i < n; i++, x++) {
		cnt += abs(sc[2].first - v[i]);
	}
	if (x > sc[2].second || x < 0)
		x = -1e9;
	else
		x = 0;

	if (x >= 0)
		ans = min(ans, cnt);

	cout << ans;

	return 0;
}