﻿using System;

namespace ConsApp2
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[] a = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);
            int[] aPows = new int[a.Length];

            int[] powers = new int[6];
            int[] powValues = { 10, 100, 1000, 10000, 100000, 1000000 };

            for(int i = 0; i < n; i++)
            {
                int number = a[i];
                for(int j = 0; j < 6; j++)
                    if(number < powValues[j])
                    {
                        powers[j]++;
                        aPows[i] = j;
                        break;
                    }
            }

            long answer = 0;
            long module = 1_000_000_007;
            for(int i = 0; i < n; i++)
            {
                int number = a[i];
                powers[aPows[i]]--;
                answer += number * (n - 1);
                answer %= module;

                for(int j = 0; j < 6; j++)
                {
                    answer += number * powers[j] * powValues[j];
                    answer %= module;
                }

                powers[aPows[i]]++;
            }

            Console.WriteLine(answer);
            //Console.ReadKey();
        }
    }
}
