#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>
#include<queue>
#include<deque>
#include<time.h>

using namespace std;

/* ^(0,0)^ */

vector<long long> ans1;
vector<long long> ans2;
vector<long long> ans3;

void rel(vector<long long> &ansa, vector<long long> &ansb, long long y1, long long y2, long long m1, long long m2)
{
	multiset<pair<long long, long long>> s1;
	multiset<pair<long long, long long>> s2;
	for (long long i = 0; i < ansa.size(); i++)
		s1.insert({ -(abs(ansa[i] - y1) - abs(ansa[i] - y2)), ansa[i] });
	for (long long i = 0; i < ansb.size(); i++)
		s2.insert({ -(abs(ansb[i] - y2) - abs(ansb[i] - y1)), ansb[i] });
	while (s2.size())
	{
		pair<long long, long long> q1 = *(s2.begin());
		if (q1.first > 0)
			break;
		s1.insert({ q1.first * -1, q1.second });
		s2.erase(s2.find(q1));
	}
	while (s1.size())
	{
		pair<long long, long long> q1 = *(s1.begin());
		if (q1.first > 0)
			break;
		s2.insert({ q1.first * -1, q1.second });
		s1.erase(s1.find(q1));
	}
	while (s1.size() < m1 && s2.size())
	{
		pair<long long, long long> q1 = *(s2.begin());
		if (q1.first > 0 && s2.size() <= m2)
			break;
		s1.insert({ q1.first * -1, q1.second });
		s2.erase(s2.find(q1));
	}
	while (s2.size() < m2 && s1.size())
	{
		pair<long long, long long> q1 = *(s1.begin());
		if (q1.first > 0 && s1.size() <= m1)
			break;
		s2.insert({ q1.first * -1, q1.second });
		s1.erase(s1.find(q1));
	}
	ansa.clear();
	ansb.clear();
	for (auto it : s1)
		ansa.push_back(it.second);
	for (auto it : s2)
		ansb.push_back(it.second);
}

int main()
{
	srand(time(NULL));
	ios_base::sync_with_stdio();
	cin.tie(NULL);
	//cout.setf(ios::fixed);
	//cout.precision(1);
	long long a1, a2, a3;
	long long x1, x2, x3;
	cin >> x1 >> a1 >> x2 >> a2 >> x3 >> a3;
	long long n;
	cin >> n;
	for (long long i = 0; i < n; i++)
	{
		long long a;
		cin >> a;
		ans3.push_back(a);
	}
	rel(ans3, ans2, x3, x2, a3, a2);
	rel(ans3, ans1, x3, x1, a3, a1);
	rel(ans2, ans1, x2, x1, a2, a1);
	rel(ans3, ans2, x3, x2, a3, a2);
	rel(ans3, ans1, x3, x1, a3, a1);
	rel(ans2, ans1, x2, x1, a2, a1);
	long long ans = 0;
	for (long long i = 0; i < ans1.size(); i++)
		ans += abs(ans1[i] - x1);
	for (long long i = 0; i < ans2.size(); i++)
		ans += abs(ans2[i] - x2);
	for (long long i = 0; i < ans3.size(); i++)
		ans += abs(ans3[i] - x3);
	cout << ans;
}