#include <bits/stdc++.h>

using namespace std;

int sToN(string &s) {
    int ans = 0;
    int i = 0;
    bool neg = false;
    if (s[0] == '-')
        neg = true, i++;
    while (i < (int)s.length()) {
        ans *= 10;
        ans += s[i++] - '0';
    }
    return neg ? -ans : ans;
}

//#define FILETEST

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef FILETEST
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // FILETEST

    vector<map<string,int>> varStack(1);
    int head = 0;
    map<string,stack<int>> revHist;

    string s, a, b;
    while (cin >> s) {
        if (s[0] == '{') {
            varStack.push_back(map<string,int>());
            head++;
        } else if (s[0] == '}') {
            varStack.pop_back();
            head--;
            for (auto it = revHist.begin(); it != revHist.end(); it++)
                while (!(it->second).empty() && (it->second).top() > head)
                    (it->second).pop();
        } else if (s.length() > 0) {
            int i = 0;
            while (s[i] != '=')
                i++;
            a = s.substr(0, i);
            b = s.substr(++i);
            if (isdigit(b[0]) || b[0] == '-') {
                varStack[head][a] = sToN(b);
            }
            else {
                if (revHist[b].empty())
                    revHist[b].push(head);
                int p = revHist[b].top();
                if (!varStack[p].count(b))
                    varStack[p][b] = 0;
                varStack[head][a] = varStack[p][b];
                cout << varStack[head][a] << "\n";
            }
            revHist[a].push(head);
        } else
            break;
    }

    return 0;
}
