#include <bits/stdc++.h>

using namespace std;

vector<map<string,int>> varStack(1);
int head = 0;

int sToN(string s) {
    int ans = 0;
    int i = 0;
    bool neg;
    if (s[0] == '-')
        neg = true, i++;
    while (i < (int)s.length()) {
        ans *= 10;
        ans += s[i++] - '0';
    }
    return neg ? -ans : ans;
}

//#define FILETEST

int main() {
    #ifdef FILETEST
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // FILETEST
    string s;
    while (cin >> s) {
        if (s[0] == '{') {
            varStack.push_back(varStack[head++]);
        } else if (s[0] == '}') {
            varStack.pop_back();
            head--;
        } else if (s.length() > 0) {
            int i = 0;
            while (s[i] != '=')
                i++;
            string a = s.substr(0, i);
            string b = s.substr(++i);
            if (isdigit(b[0]) || b[0] == '-')
                varStack[head][a] = sToN(b);
            else {
                if (!varStack[head].count(a))
                    varStack[head][a] = 0;
                if (!varStack[head].count(b))
                    varStack[head][b] = 0;
                varStack[head][a] = varStack[head][b];
                cout << varStack[head][a] << endl;
            }
        } else
            break;
    }

    return 0;
}
