#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second
#define ALL(x) (x).begin(), (x).end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const int MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};
ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll sqr(ll x) { return x*x; } ll sqr(int x) { return (ll)x*x; }
double sqr(double x) { return x*x; } ld sqr(ld x) { return x*x; }
mt19937 mmtw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(mmtw) % (y - x + 1) + x; }

// ========================================================================= //

struct Pair {
    int v1, v2;
    bool r[2][2];
    Pair(int nv1, int nv2) : v1(nv1), v2(nv2) { r[0][0] = r[0][1] = r[1][0] = r[1][1] = true; }
    void swp() {
        swap(v1, v2);
        swap(r[0][1], r[1][0]);
    }
};
vector <Pair> ps;

int n, m;
map<ipair, int> p2p;
int done = 0;
vector <int> val;

ipair turn(int v, int z) {
    val[v] = z;
    ++v;
    printf("%d %d\n", v, z);
    fflush(stdout);
    ++done;
    if (done == n)
        exit(0);
    ipair res;
    scanf("%d%d", &res.X, &res.Y);
    --res.X;
    ++done;
    if (done == n)
        exit(0);
    val[res.X] = res.Y;
    return res;
}

void doWhatever() {
    int i = 0;
    while (true) {
        while (val[i] != -1)
            ++i;
        turn(i, 0);
    }
}

int main() {
    scanf("%d%d", &n, &m);
    val.resize(n, -1);
    for (int i = 0; i < m; ++i) {
        int q1, q2;
        scanf("%d%d", &q1, &q2);
        int v1 = abs(q1) - 1;
        bool g1 = q1 < 0;
        int v2 = abs(q2) - 1;
        bool g2 = q2 < 0;
        if (v1 > v2) {
            swap(v1, v2);
            swap(g1, g2);
        }
        int pi;
        if (p2p.count({v1, v2}))
            pi = p2p[{v1, v2}];
        else {
            pi = sz(ps);
            ps.push_back(Pair(v1, v2));
            p2p[{v1, v2}] = pi;
        }
        ps[pi].r[g1][g2] = false;
    }

    int v0 = -1;
    vector <int> vcnt(n, 0);
    for (Pair const& p : ps) {
        ++vcnt[p.v1];
        ++vcnt[p.v2];
    }
    for (int i = 0; i < n; ++i)
        if (vcnt[i] >= 2)
            v0 = i;

    if (v0 != -1) {
        int i1 = -1, i2 = -1;
        for (int i = 0; i < sz(ps); ++i) {
            if (ps[i].v1 == v0 || ps[i].v2 == v0) {
                if (i1 == -1)
                    i1 = i;
                else
                    i2 = i;
            }
        }
        Pair &p1 = ps[i1];
        Pair &p2 = ps[i2];
        if (p1.v1 != v0)
            p1.swp();
        if (p2.v1 != v0)
            p2.swp();
        ipair a1 = {v0, -1}, a2 = {p1.v2, -1};
        for (int i = 0; i < 2; ++i)
            for (int j = 0; j < 2; ++j)
                if (!p1.r[i][j]) {
                    a1.Y = i;
                    a2.Y = j;
                }
        ipair b1 = {v0, -1}, b2 = {p2.v2, -1};
        for (int i = 0; i < 2; ++i)
            for (int j = 0; j < 2; ++j)
                if (!p2.r[i][j]) {
                    b1.Y = i;
                    b2.Y = j;
                }

        if (a1 == b1) {
            turn(a1.X, a1.Y);
            if (val[a2.X] == -1)
                turn(a2.X, a2.Y);
            else
                turn(b2.X, b2.Y);
        } else {
            turn(a2.X, a2.Y);
            if (val[a1.X] == -1)
                turn(a1.X, a1.Y);
            else
                turn(b2.X, b2.Y);
        }
        doWhatever();
    }

    for (Pair &p : ps) {
        for (int iter = 0; iter < 2; ++iter) {
            for (int x = 0; x < 2; ++x) {
                if (!p.r[x][0] && !p.r[x][1]) {
                    turn(p.v1, x);
                    doWhatever();
                }
            }
            p.swp();
        }
        if (n % 2 == 1 && p.r[0][0] + p.r[0][1] + p.r[1][0] + p.r[1][1] == 2) {
            bool xr = p.r[0][1];
            set <int> rem;
            for (int i = 0; i < n; ++i)
                rem.insert(i);
            int i = 0;
            while (true) {
                if (val[p.v1] != -1) {
                    turn(p.v2, val[p.v1] ^ xr ^ 1);
                    break;
                } else if (val[p.v2] != -1) {
                    turn(p.v1, val[p.v2] ^ xr ^ 1);
                    break;
                }
                while (val[i] != -1 || i == p.v1 || i == p.v2)
                    ++i;
                turn(i, 0);
            }
            doWhatever();
        }
    }

    printf("-1 -1\n");
    return 0;
}
