/**
 *    author:  tourist
 *    created: 27.09.2017 14:54:16       
**/
#include <bits/stdc++.h>

using namespace std;

vector<int> pr;

inline bool prime(long long x) {
  if (x < 2) {
    return false;
  }
  for (int i = 0; i < (int) pr.size() && pr[i] * 1LL * pr[i] <= x; i++) {
    if (x % pr[i] == 0) {
      return false;
    }
  }
  return true;
}

const int N = 1234567;

long long x[N];
long long y[N];

int main() {
  long long L, R;
  cin >> L >> R;
  int max_n = (int) (sqrt((double) R) + 10);
  vector<bool> zz(max_n, true);
  pr.clear();
  for (int i = 2; i < max_n; i++) {
    if (zz[i]) {
      pr.push_back(i);
      if (i * 1LL * i < max_n) {
        for (int j = i * i; j < max_n; j += i) {
          zz[j] = false;
        }
      }
    }
  }
  int b = 0, e = 1;
  x[0] = 0;
  y[0] = 1;
  while (b < e) {
    for (int d = 1; d <= 9; d++) {
      long long z = x[b] + d * y[b];
      if (z > R) {
        break;
      }
      if (prime(z)) {
        x[e] = z;
        y[e] = y[b] * 10;
        e++;
      }
    }
    b++;
  }
  int ans = 0;
  for (int i = 0; i < e; i++) {
    if (L <= x[i]) {
      ans++;
    }
  }
  printf("%d\n", ans);
  return 0;
}
