#include <iostream>
#include <cmath>
#include <iomanip>
#include <cstring>
#include <cstdio>
 
using namespace std;
 
const int maxn = 1e6 + 100;
string s;
int p[maxn], s1, t1, s2, t2;
char a[maxn]; 

inline bool check(int len, int &s1, int &t1, int &s2, int &t2) {
    for(int i = len - 1; i < s.size() - 1; i++)
        for(int j = i + 1; j < s.size(); j++) {
            int x = 0;
             
            if(i == len - 1) {
                x = p[i];
            } else {
                x = p[i] - p[i - len];
            }
             
             
            if(p[j] - p[j - len] == x) {
                s1 = i - len + 1;
                t1 = i;
                s2 = j - len + 1;
                t2 = j; 
                return true;
            }
 
 
        }
    return false;           
}
 
int main() {
	ios_base::sync_with_stdio(true);
	scanf("%s", &a);
	s = a;
    if(s[0] == '1')
        p[0] = 1;
    for(int i = 1; i < s.size(); i++) {
        p[i] = p[i - 1];
        if(s[i] == '1')
            p[i]++;
    }
 
     
    int l = 1, r = s.size();
    while(l <= r) {
        int mid = (l + r) / 2;
        if(check(mid, s1, t1, s2, t2)) {
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }
 
    printf("%d %d %d %d", s1 + 1, t1 + 1, s2 + 1, t2 + 1);
    return 0;
}