#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define sz(v) int(v.size())

using namespace std;

const int N = (int) 1e5 + 10;
const int INF = (int) 1e9 + 7;

int n, m, total;
vector<int> a;
int p[20];

int get_len(int x) {
    int sz = 0;
    while (x) {
        sz++;
        x /= 10;
    }
    return sz;
}

void solve() {
    int pref_sum = 0;
    for (int i = 0; i < n; i++) {
        (total += 1ll * pref_sum * p[get_len(a[i])] % INF) %= INF;
        (total += 1ll * i * a[i] % INF) %= INF;
        (pref_sum += a[i]) %= INF;
    }
}

int main() {
    p[0] = 1;
    for (int i = 1; i < 20; i++) {
        p[i] = (p[i - 1] * 10LL) % INF;
    }
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    n = sz(a);
    solve();
    reverse(all(a));
    solve();
    cout << total;
    return 0;
}
