#include <iostream>
#include <fstream>
#include <vector>
#include <map>
using namespace std;

map <string, vector < pair <int, int> > > m;
map <string, int> c, a;

int bin_search(string s, int x)
{
    //cout << s << ' ' << x << endl;
    vector <pair <int, int> > z = m[s];
    int l = 0, r = z.size();
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        //cout << m << endl;
        if (z[m].second >= x)
            l = m;
        else
            r = m;
    }
    if (z[l].second > x)
        l--;
    return l;
}

int main()
{
    ios_base::sync_with_stdio(0), cin.tie(0);
    /*freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);*/
    string s;
    int k = 1;
    while (cin >> s)
    {
        string x, d;
        int q = 0;
        bool f = true, f1 = false;
        for (int i = 0; i < s.length(); ++i)
        {
            if (s[i] == '{')
                k++;
            if (s[i] == '}')
                k--;
            if (s[i] >= 'a' && s[i] <= 'z')
                if (f)
                    x += s[i];
                else
                    d += s[i];
            if (s[i] == '=')
                f = false;
            if (s[i] == '-')
                f1 = true;
            if (s[i] >= '0' && s[i] <= '9')
                q = q * 10 + s[i] - '0';
        }

        if (f1)
            q = -q;
        //cout << x << ' ' << d << ' ' << q << endl;
        if (x.size() > 0)
        {
            if (m[x].size() == 0)
            {
                c[x] = 1;
                a[x] = k;
                m[x].push_back({0, k});
            }
            if (a[x] < k)
            {
                c[x]++;
                a[x] = k;
                m[x].push_back({0, k});
            }
            if (a[x] > k)
            {
                //cout << x << endl;
                int q = bin_search(x, k);
                //cout << q << endl;
                if (m[x][q].second < k)
                {
                    m[x][q + 1].first = 0;
                    m[x][q + 1].second = k;
                    c[x] = q + 2;
                }
                else
                    c[x] = q + 1;
                a[x] = k;
                //cout << c[x] << endl;
            }
            if (d.size() > 0)
            {
                /*if (x == d)
                {
                    cout << m[x][c[x] - 1].first << endl;
                    continue;
                }*/
                if (m[d].size() == 0)
                {
                    c[d] = 1;
                    a[d] = k;
                    m[d].push_back({0, k});
                }
                if (a[d] > k)
                {
                    //cout << d << ' ';
                    int q = bin_search(d, k);
                    //cout << q << endl;
                    if (q == -1)
                        m[d][q + 1].first = 0;
                    else
                        if (m[d][q].second < k)
                        {
                            m[d][q + 1].first = m[d][q].first;
                            c[d] = q + 2;
                            m[d][q + 1].second = k;
                        }
                        else
                            c[d] = q + 1;
                    a[d] = k;
                }
                m[x][c[x] - 1].first = m[d][c[d] - 1].first;
                cout << m[x][c[x] - 1].first << endl;
            }
            else
                m[x][c[x] - 1].first = q;
        }
    }
    return 0;
}
