#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 100500;
const int OPEN = 0;
const int CLOSE = 1;
const int TOVAR = 2;
const int TOINT = 3;

struct Query 
{
	int type;
	int a, b;
} q[N];

int n, timer;
map < string, int > pos;
vector < int > g[N];
vector < Query > t;

int get(string s)
{
	if (pos.count(s))
		return pos[s];
	return pos[s] = ++timer;
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));

	//cin.tie(NULL);
	//cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	string s;
	while(cin >> s)
	{
		n++;
		if (s == "{")
		{
			q[n].type = OPEN;
		}
		else if (s == "}")
		{	
			q[n].type = CLOSE;
		}
		else
		{
			string a, b;
			bool found = false;	
			for (int i = 0; i < (int)s.size(); i++)
			{
				if (s[i] == '=')
				{
					found = true;
				}
				else if (found)
					b += s[i];
				else
					a += s[i];					
			}
			if (b[0] >= 'a' && b[0] <= 'z')
			{
				q[n].type = TOVAR;
				q[n].a = get(a);
				q[n].b = get(b);
			}
			else
			{
				q[n].type = TOINT;
				int x = 0;
				for (int i = 0; i < (int)b.size(); i++)
				{
					if (b[i] != '-')
						x = x * 10 + b[i] - '0';
				}
				if (b[0] == '-')
					x = 0 - x;
				q[n].a = get(a);
				q[n].b = x;
			}
		}
	}
	forn(i, n)
	{
		if (q[i].type == CLOSE)
		{
			while(!t.empty() && t[(int)t.size() - 1].type != OPEN)
			{
				g[t[(int)t.size() - 1].a].pop_back();
				t.pop_back();
			}
			t.pop_back();
		} 
		else if (q[i].type == TOINT)
		{
			g[q[i].a].pb(q[i].b);
		}
		else if (q[i].type == TOVAR)
		{
			int x = 0;
			if (!g[q[i].b].empty())
				x = g[q[i].b][(int)g[q[i].b].size() - 1];
			g[q[i].a].pb(x);
			cout << x << endl;			
		}
		if (q[i].type != CLOSE)
		{
			t.pb(q[i]);
		}
	}

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
