#include <bits/stdc++.h>

#define SZ(x) (int)x.size()
#define S second
#define F first
#define pb push_back

typedef long long ll;

using namespace std;

const int N = (int) 2e5;

char ch[N];

unordered_map<string, vector<pair<int, int > > > v;

bool beg[N], en[N];

string fir[N], sec[N];

int val[N];

int rev(string x) {
	int ret = 0;
	int dig = 1;
	for (int i = SZ(x) - 1; i >= 0; i--) {
		if (i == 0) {
			if (x[i] == '-') return -ret;
		}
		ret += (int)(x[i] - '0') * dig;
		dig *= 10;
	}
	return ret;
}

int main() {
	#ifdef COMP
	freopen (".in", "r", stdin);
	freopen (".out", "w", stdout);
	#endif
	int n = 0;
	while (scanf("\n%s", ch) == 1) {
		n++;                                    
		string s = ch;
		if (SZ(s) == 1) {
			if (s == "}") en[n] = 1;
			else beg[n] = 1;
			continue;
		}
		string fi = "", se = "";
		bool ok = 0;
		for (int j = 0; j < SZ(s); j++) {
			if (s[j] == '=') ok = 1;
			else if (!ok) fi += s[j];
			else se += s[j];
		}
		fir[n] = fi;
		if (se[0] >= 'a' && se[0] <= 'z') sec[n] = se;
		else val[n] = rev(se);
	}
	for (int i = 1; i <= n; i++) {
		if (SZ(fir[i]) > 0 && v[fir[i]].empty()) v[fir[i]].pb({0, 0});
		if (SZ(sec[i]) > 0 && v[sec[i]].empty()) v[sec[i]].pb({0, 0});		
	}
	int bod = 0;
	vector<string> cha[N];
	for (int i = 1; i <= n; i++) {
		if (SZ(fir[i]) > 0 && SZ(sec[i]) > 0) {
			printf("%d\n", v[sec[i]].back().F);
			v[fir[i]].pb({v[sec[i]].back().F, bod});
			cha[bod].pb(fir[i]);
			continue;
		}
		if (SZ(fir[i]) > 0) {
			v[fir[i]].pb({val[i], bod});
			cha[bod].pb(fir[i]);
			continue;
		}
		if (beg[i] == 1) {
			bod++;
			continue;
		}
		if (en[i] == 1) {
			for (auto j : cha[bod]) {
				while ((v[j].back()).S >= bod) v[j].pop_back();
			}
			cha[bod].clear();
			bod--;
		}
	}
	return 0;
}