#include <bits/stdc++.h>

#define F first
#define S second
#define SZ(x) (int)x.size()
#define pb push_back

typedef long long ll;

using namespace std;

const int N = 2222;

pair<ll, int> t[N * 2][N * 4];

pair<int, int> pr[N * 2][N];

struct kop {
	int d, c, p;
};
                          
kop arm[N];

void compress(int n) {
	vector<pair<int, int> > v;
	for (int i = 1; i <= n; i++) {
		v.pb({arm[i].d, i});
	}  
	sort(v.begin(), v.end());
	int now = 1;
	arm[v[0].S].d = now;
	for (int i = 1; i < SZ(v); i++) {
		if (v[i].F > v[i - 1].F) now++;
		arm[v[i].S].d = now;	
	}
}

void build(int v1, int v, int l, int r) {
	if (l == r) {
		t[v1][v] = {(ll)1e18, l};
		return;
	}
	int mid = (l + r) / 2;
	build(v1, v + v, l, mid);
	build(v1, v + v + 1, mid + 1, r);
	t[v1][v] = {(ll)1e18, t[v1][v + v].S};
}

void upd(int v1, int v, int l, int r, int pos, ll x) {
	if (l == r) {
		t[v1][v].F = min(t[v1][v].F, x);
		return;
	}
	int mid = (l + r) / 2;
	if (pos <= mid) upd(v1, v + v, l, mid, pos, x);
	else upd(v1, v + v + 1, mid + 1, r, pos, x);
	if (t[v1][v + v].F < t[v1][v + v + 1].F) {
		t[v1][v] = t[v1][v + v]; 
	}                           
	else t[v1][v] = t[v1][v + v + 1];
}

pair<ll, int> get(int v1, int v, int l, int r, int L, int R) {
	if (r < L || l > R || L > R) return {(ll)1e18, 0};
	if (L <= l && R >= r) return t[v1][v];
	int mid = (l + r) / 2;
	return min(get(v1, v + v, l, mid, L, R), get(v1, v + v + 1, mid + 1, r, L, R));
}

int main() {
	#ifdef COMP
	freopen (".in", "r", stdin);
	freopen (".out", "w", stdout);
	#endif
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		scanf("%d %d %d", &arm[i].d, &arm[i].c, &arm[i].p);
	}
	compress(n);                                                                                
	for (int i = 1; i <= m + 2000; i++) build(i, 1, 1, n);
	for (int i = 1; i <= n; i++) {
		for (int j = m + 2000; j >= 0; j--) {
			if (j + arm[i].c > m + 2000) continue;
			pair<ll, int> mn = get(j, 1, 1, n, arm[i].d, n);
			if (mn.F == (ll)1e18) continue;
			int now = j + arm[i].c;
			if (get(now, 1, 1, n, arm[i].d, arm[i].d).F > mn.F + arm[i].p) {
				pr[now][arm[i].d] = {i, mn.S};
				upd(now, 1, 1, n, arm[i].d, mn.F + arm[i].p);
			}
		}			
	}
	ll ans = (ll)1e18;
	int lay = -1, diam = -1;
	for (int i = m; i <= m + 2000; i++) {
		for (int di = 1; di <= n; di++) {
			ll now = get(i, 1, 1, n, di, di).F;
			if (now < ans) {
				ans = now;
				lay = i;
				diam = di;
			}
		}
	}
	if (ans == (ll)1e18) {
		cout << -1;
		return 0;
	}
    cout << ans << " ";
    vector<int> out;
    while (lay > 0) {
    	out.pb(pr[lay][diam].F);
    	int nex = lay - arm[pr[lay][diam].F].c;
    	diam = pr[lay][diam].S;
   		lay = nex;          
    }
    sort(out.begin(), out.end());
    printf("%d\n", SZ(out));
    for (auto i : out) printf("%d ", i);                                      
	return 0;
}