

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.StringTokenizer;

/**
 * Created by Alexander on 10.12.2017.
 */
public class TaskG {
    public static void main(String[] args) throws Exception {
        Tokenizer tk = new Tokenizer(new InputStreamReader(System.in));
        long n = tk.nextLong()+1;

        long fir = n*n;
        long sec = n*n*n;
        long thir = (n * n * n * n + n * n + 2 * n) / 4;

        long ans = fir + sec + thir;
        System.out.println(ans + "");
    }

    public static class Tokenizer {
        BufferedReader in;
        StringTokenizer tokenizer;

        Tokenizer(Reader reader) {
            in = new BufferedReader(reader);
        }

        String next() throws Exception {
            while (tokenizer == null || !tokenizer.hasMoreElements()) {
                String line = in.readLine();
                if (line == null)
                    return null;

                tokenizer = new StringTokenizer(line);
            }
            return tokenizer.nextToken();
        }

        int nextInt() throws Exception {
            return Integer.parseInt(next());
        }

        long nextLong() throws Exception{
            return Long.parseLong(next());
        }
    }
}
