#include <iostream>
#include <string>

using namespace std;

const long long MAX = 1e6;
const long long mmm = 1e9 + 7

int lens[MAX];
int arr[MAX];
int degee[MAX];

int main() {
	int n;
	string str;
	cin >> n;

	degee[0] = 1;
	for (int i = 1; i < 1000; ++i) {
		degee[i] = degee[i - 1] * 10;
	}

	for (int i = 0; i < n; ++i) {
		cin >> str;
		lens[i] = str.length();
		arr[i] = stoi(str);
	}

	long long sum = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			sum += arr[i] * degee[lens[j]] + arr[j];
			if (sum > mmm)
				sum %= mmm;
			sum += arr[j] * degee[lens[i]] + arr[i];
			if (sum > mmm)
				sum %= mmm;
		}
	}
	cout << sum;
	return 0;
}