#include <bits/stdc++.h>
using namespace std;
using ll = long long; using ld = long double;
const int maxn = 1e6;

int n, p[maxn], l1, r1, l2, r2;
string s;

inline int get(int l, int r) {
    return p[r] - (l ? p[l - 1] : 0);
}

inline bool ok(int len) {
    vector<int> l(maxn + 1, -1), r(maxn + 1, -1);
    for(int i = len - 1; i < n; i++) {
        int cur = get(i - len + 1, i);
        if(l[cur] != -1) {
            l1 = l[cur] + 1; r1 = r[cur] + 1;
            l2 = i - len + 1 + 1; r2 = i + 1;
            return true;
        }
        l[cur] = i - len + 1; r[cur] = i;
    }
    return false;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //#ifndef PAUNSVOKNO
    //freopen("in.txt", "r", stdin);
    //#endif // PAUNSVOKNO
    cin >> s; n = s.size();
    for(int i = 0; i < n; i++) p[i] = (i ? p[i - 1] : 0) + (s[i] == '1');
    int lf = 1, rg = n;
    while(lf < rg) {
        int md = (lf + rg) / 2;
        if(lf == md) md++;
        if(ok(md)) lf = md;
        else rg = md - 1;
    }
    ok(lf);
    cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2;
}
