#include <iterator>
#include <utility>
#include <algorithm>
#include <string>
#include <vector>
#include <unordered_set>
#include <iostream>
#include <cstdint>

using namespace std;

const uint64_t MOD = 1e9 + 7;

uint64_t calc(uint64_t a) {
	uint64_t res = 0;
	while (a != 0) {
		res++;
		a /= 10;
	}
	return res;
}

uint64_t power(uint64_t a, uint64_t b) {
	uint64_t res = 1;
	for (int i = 1; i <= b; i++) {
		res = (res * a) % MOD;
	}
	return res;
}

int main()
{
	uint64_t n;
	cin >> n;
	vector<uint64_t> arr(n);
	for (int i = 0; i < n; i++) cin >> arr[i];
	sort(arr.begin(), arr.end());
	vector<uint64_t> dp(n); //dp[0]=0
	vector<uint64_t> sum_of_pows(10);
	vector<uint64_t> num_of_pows(10);
	uint64_t sum_prev = arr[0];
	sum_of_pows[calc(arr[0])] += arr[0];
	num_of_pows[calc(arr[0])]++;
	for (int i = 1; i < n; i++) {
		uint64_t add_left = ((sum_prev*power(10, calc(arr[i]))) % MOD + arr[i]*i % MOD) % MOD;
		//uint64_t add_right = (((arr[i] * i) % MOD *power(10, calc(arr[i-1]))) % MOD + sum_prev) % MOD;
		uint64_t add_right = 0;
		for (int j = 9; j >= 1; j--) {
			if (sum_of_pows[j] == 0) continue;
			add_right += (((arr[i] * num_of_pows[j]) % MOD * power(10, j)) % MOD + sum_of_pows[j]) % MOD;
		}
		dp[i] = (((add_left + add_right) % MOD) + dp[i - 1]) % MOD;
		sum_prev = (sum_prev + arr[i]) % MOD;
		sum_of_pows[calc(arr[i])] = (arr[i] + sum_of_pows[calc(arr[i])]) % MOD;
		num_of_pows[calc(arr[i])]++;

	}
	cout << dp[n-1];
	return 0;
}