#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
const ll mod = 1e9 + 7;

ll pw[10];

int getl(int n) {
    int cnt = 0;
    while (n) {
        cnt++;
        n /= 10;
    }
    return cnt;
}

ll a[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    pw[0] = 1;
    for (int i = 1; i < 10; ++i) {
        pw[i] = pw[i - 1] * 10LL;
        if (pw[i] >= mod)
            pw[i] %= mod;
    }
    ll sum1 = 0, sum2 = 0;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum1 += a[i];
        if (sum1 >= mod)
            sum1 %= mod;
        int len = getl(a[i]);
        sum2 += pw[len];
        if (sum2 >= mod)
            sum2 %= mod;
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        int len = getl(a[i]);
        ll m1 = (sum2 - pw[len] + mod) % mod;
        ll add1 = m1 * (ll)a[i];
        if (add1 >= mod)
            add1 %= mod;

        ll add2 = a[i] * (ll)(n - 1LL);
        if (add2 >= mod)
            add2 %= mod;
        ans += add1 + add2;
        if (ans >= mod)
            ans %= mod;
    }
    cout << ans;
    return 0;
}
