#include <bits/stdc++.h>
#ifndef LOCAL
#define cerr if(0)cerr
#endif
#define ll long long
#define ld long double
#define fi first
#define se second
#define pb push_back

using namespace std;

struct Node {
 	string val;
 	map<char, Node*> nxta;
 	Node(string val = "0") : val(val) {}
 	Node(Node* b) {val = b->val; nxta = b->nxta; }
 	Node* nxt(char c)
 	{
 	 	if(nxta[c] == NULL)
 	 		nxta[c] = new Node();
 	 	return nxta[c];
 	}
};

stack<Node*> mst;

void upd(string s, string v)
{
 	Node * cur = mst.top();
 	Node * np = new Node(cur);
 	mst.push(np);
 	for(int i = 0; i < s.size(); ++i)
 	{
 		Node* n = new Node(cur->nxt(s[i]));
 		np->nxta[s[i]] = n;
 		np = n;
 		cur = cur->nxt(s[i]); 	
 	}
 	np->val = v;
}

string gv(string s)
{
 	Node * cur = mst.top();
 	for(int i = 0; i < s.size(); ++i)
 	{
 		cur = cur->nxt(s[i]); 	
 	}
 	return cur->val;
}

string rdln()
{
 	char c = getchar();
 	string ans = "";
 	while(c != '\n' && c != '\0' && c != EOF && c != ' ' && c != '\t')
 	{
 	 	ans += c;
 	 	c = getchar();
 	}
 	if(ans[ans.size() - 1] == '\n') ans = ans.substr(0, ans.size() - 1);
 	return ans;
}

int main()
{
// 	ios_base::sync_with_stdio(0);
// 	cin.tie(0);
// 	cout.tie(0);
 	#ifdef LOCAL
 	freopen("a.in", "r", stdin);
 	freopen("a.out", "w", stdout);
 	freopen("err.log", "w", stderr);
 	#endif
	mst.push(new Node());
 	stack<int> back;
 	int cback = 0;
	while(!feof(stdin))
	{
	 	string com = rdln();
	 	if(com == "") continue;
	 	cerr << "Got cmd \"" << com  << "\"\n"; 
	 	if(com[0] == '{')
	 	{
	 		cerr << " Going in. Save " << cback << "\n";
	 		back.push(cback);
	 	 	cback = 0;
	 	}
	 	else if(com[0] == '}')
	 	{
	 		cerr << " Going out. Incl " << cback << " oper\n";
	 		for(; cback > 0; --cback) mst.pop();
	 	 	cback = back.top();
	 	 	back.pop();
	 	}
	 	else
	 	{
	 		int i = 0;
	 		string var = "", val = "";
	 		for(; com[i] != '='; ++i) var += com[i];
	 		i++;
	 		for(; i < com.size(); ++i) val += com[i];
	 		cerr << " var " << var << " <- val " << val << "\n";
	 		if(isalpha(val[0]))
	 		{
	 			val = gv(val);
	 			cerr << "  var is " << val << "\n";
	 		    cout << val << "\n";
	 		}
	 		upd(var, val);
	 		cback++;
	 		cerr << " now " << cback << " ops in block\n";
	 	}
	 	cerr << "END OF OP\n";
	}
 	return 0;
}
