#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e3 + 10, inf = 1e9 + 100;

int n, m;

pair<int, pair<int, int> >  fen[2 * maxn][maxn];

void inc(int id, int i, pair<int, pair<int, int> > v){
    for (; i < n; i = (i | (i + 1)))
        fen[id][i] = min(fen[id][i], v);
}

pair<int, pair<int, int> > get(int id, int i){
    pair<int, pair<int, int> > ret;
    ret.first = inf;
    for (; i >= 0; i = (i & (i + 1)) - 1)
        ret = min(ret, fen[id][i]);
    return ret;
}

int cost[maxn], diam[maxn], pr[maxn];

pair<int, int> mas[maxn];

int pos[maxn];

int kuda[maxn];

int dp[maxn][2 * maxn];

pair<int, int> par[maxn][2 * maxn];

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        cin >> diam[i] >> pr[i] >> cost[i];
        pr[i] = min(pr[i], m);
        mas[i] = make_pair(diam[i], i);
    }
    sort(mas, mas + n);
    reverse(mas, mas + n);
    for (int i = 0; i < n; i++)
        pos[mas[i].second] = i;
    int last = 0;
    for (int i = 0; i < n; i++)
    if (i > 0 && mas[i].first != mas[i - 1].first){
        for (int j = last; j < i; j++)
            kuda[mas[j].second] = i - 1;
        last = i;
    }
    for (int j = last; j < n; j++)
        kuda[mas[j].second] = n - 1;
    for (int i = 0; i <= 2 * m; i++)
        for (int j = 0; j < n; j++)
            fen[i][j].first = inf;
    for (int i = 0; i < n; i++){
        for (int j = -m; j + pr[i] <= m; j++){
            dp[i][j + m] = inf;
            if (j + pr[i] == m){
                dp[i][j + m] = cost[i];
                par[i][j + m].first = -1;
            }
            else{
                auto val = get(j + pr[i] + m, kuda[i]);
                if (val.first != inf){
                    dp[i][j + m] = cost[i] + val.first;
                    par[i][j + m] = val.second;
                }
            }
            if (dp[i][j + m] != inf)
                inc(j + m, pos[i], make_pair(dp[i][j + m], make_pair(i, j)));
        }
    }
    int val = inf, x, y;
    for (int i = 0; i < n; i++)
        for (int j = -m; j <= 0; j++)
            if (dp[i][j + m] < val)
                val = dp[i][j + m], x = i, y = j;
    if (val == inf){
        cout << -1 << '\n';
        return 0;
    }
    cout << val << ' ';
    vector<int> answer;
    answer.push_back(x + 1);
    while (par[x][y + m].first != -1){
        pair<int, int> nw = par[x][y + m];
        x = nw.first;
        y = nw.second;
        answer.push_back(x + 1);
    }
    cout << answer.size() << '\n';
    sort(answer.begin(), answer.end());
    for (auto i : answer)
        cout << i << ' ';
}
