#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e3 + 10, inf = 1e9 + 100;

const ll llinf = 1e18 + 100;

int n, m;

pair<ll, pair<int, int> >  fen[maxn][maxn];

void inc(int id, int i, pair<ll, pair<int, int> > v){
    for (; i < n; i = (i | (i + 1)))
        fen[id][i] = min(fen[id][i], v);
}

pair<ll, pair<int, int> > get(int id, int i){
    pair<ll, pair<int, int> > ret;
    ret.first = llinf;
    for (; i >= 0; i = (i & (i + 1)) - 1)
        ret = min(ret, fen[id][i]);
    return ret;
}

int cost[maxn], diam[maxn], pr[maxn];

pair<int, int> mas[maxn];

int pos[maxn];

int kuda[maxn];

ll dp[maxn][maxn];

pair<int, int> par[maxn][maxn];

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        cin >> diam[i] >> pr[i] >> cost[i];
        pr[i] = min(pr[i], m);
        mas[i] = make_pair(diam[i], i);
    }
    sort(mas, mas + n);
    reverse(mas, mas + n);
    for (int i = 0; i < n; i++)
        pos[mas[i].second] = i;
    int last = 0;
    for (int i = 0; i < n; i++)
    if (i > 0 && mas[i].first != mas[i - 1].first){
        for (int j = last; j < i; j++)
            kuda[mas[j].second] = i - 1;
        last = i;
    }
    for (int j = last; j < n; j++)
        kuda[mas[j].second] = n - 1;
    for (int i = 0; i <= m; i++)
        for (int j = 0; j < n; j++)
            fen[i][j].first = llinf;
    for (int i = 0; i < n; i++){
        for (int j = 0; j <= m; j++)
            dp[i][j] = llinf;
        for (int j = 1; j <= m; j++){
            int to = max(0, j - pr[i]);
            if (j == m){
                if (dp[i][to] > cost[i])
                    dp[i][to] = cost[i], par[i][to].first = -1;
            }
            auto val = get(j, kuda[i]);
            if (val.first + cost[i] < dp[i][to]){
                dp[i][to] = cost[i] + val.first;
                par[i][to] = val.second;
            }
        }
        for (int j = 0; j <= m; j++)
        if (dp[i][j] != llinf)
            inc(j, pos[i], make_pair(dp[i][j], make_pair(i, j)));

    }
    ll val = llinf;
    int x, y = 0;
    for (int i = 0; i < n; i++)
        if (dp[i][0] < val)
            val = dp[i][0], x = i;
    if (val == llinf){
        cout << -1 << '\n';
        return 0;
    }
    cout << val << ' ';
    vector<int> answer;
    answer.push_back(x + 1);
    while (par[x][y].first != -1){
        pair<int, int> nw = par[x][y];
        x = nw.first;
        y = nw.second;
        answer.push_back(x + 1);
    }
    cout << answer.size() << '\n';
    sort(answer.begin(), answer.end());
    for (auto i : answer)
        cout << i << ' ';
}
