#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
using namespace std;

inline int len(int num) {
    return int(log10(num)) + 1;
}

#define MAX_N 100019
#define MOD int(1e9 + 7)
#define a(x) int(1e ## x)

map<int, int> repeat;
int n, a[MAX_N], suff[MAX_N][10], pows[10] = {1, 10, a(2), a(3), a(4), a(5), a(6), a(7), a(8), a(9)},
 pref[MAX_N][10], suffk[MAX_N][10], prefk[MAX_N][10];

int main() {
    ios::sync_with_stdio(false);
    cin >> n;
    for(int i(0); i < n; ++i)
        cin >> a[i];
    sort(a, a + n);
    //n = distance(a, unique(a, a + n));
    for(int i(0); i < n; ++i)
        ++repeat[a[i]];

    for(int i(n - 1); i > -1; --i) {
        for(int j(0); j < 10; ++j)
            suff[i][j] = suff[i + 1][j],
            suffk[i][j] = suffk[i+1][j];
        suff[i][len(a[i])] += a[i];
        suffk[i][len(a[i])] += 1;
    }
    pref[0][len(a[0])] += a[0];
    prefk[0][len(a[0])] = 1;
    for(int i(1); i < n; ++i) {
        for(int j(0); j < 10; ++j)
            pref[i][j] = pref[i - 1][j],
            prefk[i][j] = prefk[i - 1][j];
        pref[i][len(a[i])] += a[i];
        prefk[i][len(a[i])] += 1;
    }
    long long sum = 0, ls;
    for(int i(0); i < n; ++i) {
        for(int j(0); j < 10; ++j) {
            if(suff[i + 1][j] != 0)
                sum += a[i] * pows[j] * suffk[i+1][j] + suff[i + 1][j];
            if (i && pref[i - 1][j] != 0)
                sum += a[i] * pows[j] * prefk[i-1][j] + pref[i - 1][j];
            sum %= MOD;
        }
    }
    for(auto p : repeat) {
        if(p.second != 1)
            sum -= (p.first * pows[len(p.first)] + p.first) * (p.second) * (p.second - 1);
    }
    sum = (sum % MOD + MOD) % MOD;
    cout << sum << endl;
    return 0;
}
