#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000000007;

int len(long long x) {
    int l = 0;
    while (x > 0) {
        l++;
        x /= 10;
    }
    return l;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<long long> sum(11);
    vector<long long> cnt(sum.size());
    vector<long long> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum[len(a[i])] += a[i];
        cnt[len(a[i])]++;
    }

    for (int i = 0; i < sum.size(); i++) {
        sum[i] %= MOD;
    }

    vector<long long> p10(sum.size());
    p10[0] = 1;
    for (int i = 1; i < sum.size(); i++) {
        p10[i] = p10[i - 1] * 10 % MOD;
    }
    long long s = 0;
    for (int i = 0; i < n; i++) {
        for (int l = 1; l < sum.size(); l++) {
            s += (a[i] * p10[l] % MOD * cnt[l] + sum[l]) % MOD;
        }
    }

    for (int i = 0; i < n; i++) {
        s -= (a[i] * p10[len(a[i])] + a[i]) % MOD;
    }

    s %= MOD;
    if (s < 0) {
        s += MOD;
    }

    cout << s << endl;

    return 0;
}