#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    int m;
    cin >> m;
    if (m != n - 1) {
        cout << "No" << endl;
        return 0;
    }

    vector<bool> used(n);
    int last = -1;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        if (x < last) {
            cout << "No" << endl;
            return 0;
        }
        if (used[x]) {
            cout << "No" << endl;
            return 0;
        }
        last = x;
        used[x] = true;
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cout << "Yes" << endl << i + 1 << endl;
            return 0;
        }
    }

    return 0;
}