#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <stack>

using namespace std;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
	vector <pair<long long, long long> > home(3);
	for (int i = 0; i < 3; i++) {
		int u, v;
		cin >> u >> v;
		home[i].first = u;
		home[i].second = v;
	}
	sort(home.begin(), home.end());
	int n;
	cin >> n;
	vector <long long> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	long long ans = 0;
	for (int i = 0; i < a.size(); i++) {
		ans += abs(a[i] - home[1].first);
	}
	long long l = 0, r = a.size() - 1;
	while (l <= r) {
		long long prev = abs(a[l] - home[1].first);
		long long best = abs(a[l] - home[0].first);
		if (prev >= best && home[0].second) {
			home[0].second--;
			ans -= prev;
			ans += best;
			l++;
		}
		else {
			break;
		}
	}
	if (l > r) {
		cout << ans;
		return 0;
	}
	while (r >= l) {
		long long prev = abs(a[r] - home[1].first);
		long long best = abs(a[r] - home[2].first);
		if (prev >= best && home[2].second) {
			home[2].second--;
			ans -= prev;
			ans += best;
			r--;
		}
		else {
			break;
		}
	}
	if (l > r) {
		cout << ans;
		return 0;
	}
	while (r - l + 1 > home[1].second) {
		if (home[0].second && home[2].second) {
			long long prevright = abs(a[r] - home[1].first);
			long long prevleft = abs(a[l] - home[1].first);
			long long bestright = abs(a[r] - home[2].first);
			long long bestleft = abs(a[l] - home[0].first);
			if (abs(bestleft - prevleft) < abs(bestright - prevright)) {
				ans -= prevleft;
				ans += bestleft;
				l++;
				home[0].second--;
			}
			else {
				ans -= prevright;
				ans += bestright;
				r--;
				home[2].second--;
			}
			continue;
		}
		if (home[0].second) {
			long long prevleft = abs(a[l] - home[1].first);
			long long len = abs(a[l] - home[0].first);
			l++;
			ans -= prevleft;
			ans += len;
		}
		else {
			long long prevleft = abs(a[r] - home[1].first);
			long long len = abs(a[r] - home[2].first);
			r--;
			ans -= prevleft;
			ans += len;
		}
	}
	cout << ans;
	return 0;
}