#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <stack>
#include <stdio.h>
#include <fstream>

using namespace std;

typedef long long ll;

bool check(ll a)
{
	if (a == 1)
	{
		return false;
	}
	if (a == 3)
	{
		return true;
	}
	for (int i = 2; i < sqrt(a) + 1; ++i)
	{
		if (a % i == 0)
		{
			return false;
		}
	}
	return true;
}

ll dec_pow(int i)
{
	int res = 10;
	for (int j = 1; j < i; ++j)
	{
		res *= 10;
	}
	return res;
}

ll to_ll(string s)
{
	ll res = 0;
	for (int i = 0; i < s.size(); ++i)
	{
		res *= 10;
		res += s[i] - '0';
	}
	return res;
}

int main()
{
	string s;
	map <string, stack<ll>> vars;
	while (cin >> s)
	{
		if (s == "{")
		{
			for (auto &i : vars)
			{
				i.second.push(i.second.top());
			}
		}
		else if (s == "}")
		{
			for (auto &i : vars)
			{
				i.second.pop();
				if (i.second.empty())
				{
					i.second.push(0);
				}
			}
		}
		else
		{
			int i = 0;
			string var1;
			while (s[i] != '=')
			{
				var1 += s[i];
				++i;
			}
			++i;
			if ((s[i] >= '0' && s[i] <= '9') || s[i] == '-')
			{
				int mul = 1;
				if (s[i] == '-')
				{
					++i;
					mul = -1;
				}
				string num;
				while (i < s.size())
				{
					num += s[i];
					if (vars[var1].empty())
					{
						vars[var1].push(to_ll(num) * mul);
					}
					else
					{
						vars[var1].pop();
						vars[var1].push(to_ll(num) * mul);
					}
					++i;
				}
			}
			else
			{
				string var2;
				while (i < s.size())
				{
					var2 += s[i];
					++i;
				}
				if (vars[var1].empty() && var1 != var2)
				{
					if (!vars[var2].empty())
					{
						vars[var1].push(vars[var2].top());
					}
					else
					{
						vars[var1].push(0);
					}
				}
				else if(var1 != var2)
				{
					vars[var1].pop();
					if (!vars[var2].empty())
					{
						vars[var1].push(vars[var2].top());
					}
					else
					{
						vars[var1].push(0);
					}
				}
				cout << vars[var1].top() << endl;
			}
		}
	}
	return 0;
}