#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

const int M = 1000000007;

ll to_ll(string s)
{
	ll res = 0;
	for (int i = 0; i < s.size(); ++i)
	{
		res *= 10;
		res += s[i] - '0';
	}
	return res;
}

ll dec_pow(int i)
{
	if (i == 0)
	{
		return 0;
	}
	ll res = 10;
	for (int j = 1; j < i; ++j)
	{
		res *= 10;
	}
	return res;
}

int main()
{
	ll k;
	int n;
	cin >> n;
	vector <int> count(9, 0);
	vector <string> v(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i];
		count[v[i].size()]++;
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 1; j < 9; ++j)
		{
			if (v[i].size() != j)
			{
				ans += (((to_ll(v[i]) % M) * (dec_pow(j) % M)) % M) * (count[j] % M);
			}
			else
			{
				ans += (((to_ll(v[i]) % M) * (dec_pow(j) % M)) % M) * ((count[j] - 1) % M);
			}
			ans %= M;
		}
		ans += (to_ll(v[i]) % M) * ((n - 1) % M);
		ans %= M;
	}
	cout << ans;
	return 0;
}