#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

void run();

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

string s;


void run() {
	cin >> s;
	int l0 = -1, r0 = -1, l1 = -1, r1 = -1;

	int n = s.length();
	for (int i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			if (l0 == -1)
			{
				l0 = i;
			}
			r0 = i;
		}
		else
		{
			if (l1 == -1)
			{
				l1 = i;
			}
			r1 = i;
		}
	}
	int l, r;
	if (l1 != -1)
	{
		l = l1;
		r = r1;
	}
	if (l0 != -1)
	{
		l = l0;
		r = r0;
	}
	if (l0 != -1 && r0 - l0 > r - l)
	{
		r = r0;
		l = l0;
	}
	if (l1 != -1 && r1 - l1 > r - l)
	{
		r = r1;
		l = l1;
	}

	cout << l + 1 << " " << r << " " << l + 2 << " " << r + 1 << "\n";
}