#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

void run();

typedef long long ll;

const ll LINF = (ll) 1e9 + 123;

#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const int N = 3e5 + 123;

struct P {
	ll x;
	int cnt;
};
P p[3];
int n;
ll x[N];
ll tmp[N];
ll dp[N];

void run() {
	rep(i, 0, 3) {
		cin >> p[i].x >> p[i].cnt;
	}
	sort(p, p + 3, [](P a, P b) {
		return a.x < b.x;
	});
	cin >> n;
	rep(i, 0, n) {
		cin >> x[i];
	}
	sort(x, x + n);
	ll pre = 0;

	int l = 0;
	while (l < n && x[l] <= p[0].x) {
		if (p[0].cnt > 0) {
			pre += abs(p[0].x - x[l]);
			p[0].cnt--;
		}
		else if (p[1].cnt > 0) {
			pre += abs(p[1].x - x[l]);
			p[1].cnt--;
		}
		else {
			pre += abs(p[2].x - x[l]);
			p[2].cnt--;
		}
		l++;
	}
	int r = n - 1;
	while (r >= l && x[l] >= p[2].x) {
		if (p[2].cnt > 0) {
			pre += abs(p[2].x - x[r]);
			p[2].cnt--;
		}
		else if (p[1].cnt > 0) {
			pre += abs(p[1].x - x[r]);
			p[1].cnt--;
		}
		else {
			pre += abs(p[0].x - x[r]);
			p[0].cnt--;
		}
		r--;
	}

	n = r - l + 1;
	if (n == 0) {
		cout << pre << "\n";
		return;
	}
	copy(x + l, x + l + n, tmp);
	copy(tmp, tmp + n, x);

	int ptr = -1;
	ll cur = 0;
	rep(i, 0, n) {
		cur += abs(x[i] - p[1].x);
		while (i - ptr > p[1].cnt) {
			ll ncur = cur;
			ncur -= abs(x[ptr + 1] - p[1].x);
			ncur += abs(x[ptr + 1] - p[0].x);
			ptr++;
		}
		while (ptr + 1 <= i && ptr + 2 <= p[0].cnt) {
			ll ncur = cur;
			ncur -= abs(x[ptr + 1] - p[1].x);
			ncur += abs(x[ptr + 1] - p[0].x);
			if (ncur > cur) {
				break;
			}
			else {
				cur = ncur;
				ptr++;
			}
		}
		if (ptr + 1 > p[0].cnt) {
			dp[i] = LINF;
		}
		else {
			dp[i] = cur;
		}
	}

	ll ans = dp[n - 1];

	ll f = 0;
	per(i, n - 1, 0) {
		if (n - i > p[2].cnt) {
			break;
		}
		f += abs(x[i] - p[2].x);
		ll t = f;
		if (i - 1 >= 0) {
			t += dp[i - 1];
		}
		ans = min(ans, t);
	}

	ans += pre;
	cout << ans << "\n";
}