#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>

using namespace std;

int b1 = 0, e1 = 0, b2 = 0, e2 = 0;
string a;
vector<int> pr(1e6 + 100);

bool check(int n) {
	vector<int> used(1e7 + 100, -1);
	for (int i = 0; i <= a.size() - n; ++i){
		if (used[pr[i + n] - pr[i]] != -1) {
			b1 = used[pr[i + n] - pr[i]] + 1;
			e1 = used[pr[i + n] - pr[i]] + n;
			b2 = i + 1;
			e2 = i + n;
			return true;
		}
		else
			used[pr[i + n] - pr[i]] = i;
	}
	return false;
}


int main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	cin >> a;

	int k = 0;
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] == '1') {
			if (!b1) {
				b1 = i + 1;
				e1 = i + 1;
			}
			else {
				b2 = i + 1;
				e2 = i + 1;
			}
			++k;
		}
		pr[i + 1] = k;
	}

	if (!b1) {
		b2 = 2;
		e2 = 2;
	}
	else if (!b2) {
		if (b1 == 1) {
			b1 = 2;
			e1 = 2;
			b2 = 3;
			e2 = 3;
		}
		else if(b1 == 2) {
			b1 = 1;
			e1 = 1;
			b2 = 3;
			e2 = 3;
		}
		else {
			b1 = 1;
			e1 = 1;
			b2 = 2;
			e2 = 2;
		}
	}

	int r = a.size(), l = 1;

	while (r - l > 1) {
		int mid = (l + r) / 2;
		if (check(mid))
			l = mid;
		else
			r = mid;
	}

	cout << b1 << ' ' << e1 << ' ' << b2 << ' ' << e2;

	return 0;
}