#include <cstdio>
#include <bits/stdc++.h>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double ld;

const int N = 100001;
const ll INF = 100000000000000000;

vector<int> g[N];
vector<ll> w[N];
int s[N];
ll d[N];
int used[N];

set<pair<ld, int> > q;
const ld eps = 1e-5;
int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back(y);
        g[y].push_back(x);
        w[x].push_back(z);
        w[y].push_back(z);
    }
    int m;
    cin >> m;
    for (int i = 1; i <= n; i++)
        d[i] = INF;
    for (int i = 0; i < m; i++)
    {
        cin >> s[i];
        q.insert(make_pair(0, s[i]));
        d[s[i]] = 0;
    }
    int ans = 1;
    int cur = 1;
   // cout << endl;
    while (q.size())
    {
        int v = q.begin()->second;
      //  cout << v << endl;
        ld timer = q.begin()->first;
        used[v] = 1;
        q.erase(q.begin());
        if (v == -1)
        {
            cur--;
        }
        else
        {
            cur--;
            for (int i = 0; i < g[v].size(); i++)
            {
                int u = g[v][i];
                int c = w[v][i];
                if (!used[u])
                {
                    cur++;
                    if (d[u] > d[v] + c)
                    {
                        q.erase(make_pair(d[u], u));
                        d[u] = d[v] + c;
                        q.insert(make_pair(d[u], u));
                    }
                }
                else
                {
                    if (d[u] + c > d[v])
                    {
                        cur++;
                        q.insert(make_pair(timer + (ld)(c - d[v] + d[u]) / (ld)2, -1));
                    }
                }
            }
        }
       // cout << timer << " " << cur << endl;
        if (!q.size() || q.begin()->first - timer > eps)
            ans = max(ans, cur);
    }
    cout << ans;
    return 0;
}
/*
3
1 2 1
2 3 1
3 1 2 3

8
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
1 8 4
2
1 8
*/
