import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public class pair implements Comparable<pair> {
        int x, a;

        public int compareTo(pair p) {
            if (x != p.x) {
                return x - p.x;
            }
            return a - p.a;
        }

        pair(int u, int i) {
            x = u;
            a = i;
        }
    }

    public class paird implements Comparable<paird> {
        double x;
        int a;

        public int compareTo(paird p) {
            if (x != p.x) {
                return Double.compare(x, p.x);
            }
            return a - p.a;
        }

        paird(double u, int i) {
            x = u;
            a = i;
        }
    }

    public void solve() throws IOException {
        pair[] a = new pair[3];
        long res = 0;
        a[0] = new pair(nextInt(), nextInt());
        a[1] = new pair(nextInt(), nextInt());
        a[2] = new pair(nextInt(), nextInt());
        TreeSet<pair> c = new TreeSet<>();
        Arrays.sort(a);
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            c.add(new pair(nextInt(), i));
        }
        while (a[0].a > 0 && c.size() > 0) {
            int p = c.first().x;
            if (Math.abs(p - a[0].x) < Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[0].x);
                a[0].a--;
                c.pollFirst();
            } else {
                break;
            }
        }
        while (a[2].a > 0 && c.size() > 0) {
            int p = c.last().x;
            if (Math.abs(p - a[2].x) < Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[2].x);
                c.pollLast();
                a[2].a--;
            } else {
                break;
            }
        }
        int k = a[1].a - c.size();
        k = -k;
        if (k <= 0) {
            while (c.size() > 0) {
                res += Math.abs(a[1].x - c.pollFirst().x);
            }
        } else {
            for (int i = 0; i < k; i++) {
                int x = c.first().x;
                int y = c.last().x;
                if (a[0].a == 0) {
                    res += Math.abs(a[2].x - y);
                    c.pollLast();
                    a[2].a--;
                } else {
                    if (a[2].a == 0) {
                        res += Math.abs(a[0].x - x);
                        a[0].a--;
                        c.pollFirst();
                    } else {
                        if (Math.abs(a[2].x - y) == Math.abs(a[0].x - x)) {
                            if (Math.abs(a[1].x - y) < Math.abs(a[1].x - x)) {
                                res += Math.abs(a[2].x - y);
                                c.pollLast();
                                a[2].a--;
                            } else {
                                res += Math.abs(a[0].x - x);
                                a[0].a--;
                                c.pollFirst();
                            }
                        } else if (Math.abs(a[2].x - y) < Math.abs(a[0].x - x)) {
                            res += Math.abs(a[2].x - y);
                            c.pollLast();
                            a[2].a--;
                        } else {
                            res += Math.abs(a[0].x - x);
                            a[0].a--;
                            c.pollFirst();
                        }
                    }
                }
            }
            while (c.size() > 0) {
                res += Math.abs(a[1].x - c.pollFirst().x);
            }
        }
        out.print(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    boolean hasNext() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            try {
                in = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return false;
            }
        }
        return true;
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}