#include <bits/stdc++.h>

#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const ll LINF = (ll)1e18 + 7;

struct tree{
    ll t[4 * 100007];
    ll p[4 * 100007];

    void clear() { for (int i = 0; i < 4 * 100007; i++) t[i] = 0, p[i] = 0; }

    void push(int v){
        if (p[v]){
            t[v] += p[v];
            if (v * 2 + 1 < 4 * 100007) p[v * 2 + 1] += p[v];
            if (v * 2 + 2 < 4 * 100007) p[v * 2 + 2] += p[v];
            p[v] = 0;
        }
    }

    void up(int v, int vl, int vr, int l, int r, ll val){
        push(v);
        if (r < vl || l > vr) return;
        if (vl >= l && vr <= r){
            p[v] += val;
            push(v);
        } else {
            int vm = (vl + vr) >> 1;
            up(v * 2 + 1, vl, vm, l, r, val);
            up(v * 2 + 2, vm + 1, vr, l, r, val);
            t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
        }
    }

    ll get(int v, int vl, int vr, int l, int r){
        push(v);
        if (r < vl || l > vr) return LINF;
        if (vl >= l && vr <= r){
            return t[v];
        }
        int vm = (vl + vr) >> 1;
        return min(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm + 1, vr, l, r));
    }
} t;

pair<int, int> b[3];
int n;
int a[100007];
ll dp[3][100007];

int main() {
#ifdef WIN
    freopen("01", "r", stdin);
#endif // WIN
    for (int i = 0; i < 3; i++) cin >> b[i].x >> b[i].y;
    sort(b, b + 3);
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a, a + n);
    int now = 0;
    for (int i = n - 1; i >= 0; i--){
        now++;
        if (now > b[2].y) dp[2][i] = LINF;
        else dp[2][i] = dp[2][i + 1] + abs(b[2].x - a[i]);
    }
    for (int it = 1; it >= 0; it--){
        int sz = b[it].y;
        int pos = b[it].x;
        t.clear();
        for (int i = n - 1; i >= 0; i--){
            t.up(0, 0, n, i, i, dp[it + 1][i]);
            t.up(0, 0, n, i + 1, n, abs(pos - a[i]));
            dp[it][i] = min(LINF, t.get(0, 0, n, i, min(n, i + sz)));
        }
    }
    cout << dp[0][0];
    return 0;
}
