#include <bits/stdc++.h>

#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

set<int> used;
int n, m;

pair<int, int> out(int x, int val) {

    if (x < 0) x = -x, val ^= 1;
    //assert(!used.count(x));

    cout << x << " " << val << endl;

    used.insert(abs(x));
    if (used.size() == n) exit(0);

    int a, b;
    cin >> a >> b;

    used.insert(abs(a));
    if (used.size() == n) exit(0);

    return { a, b };
}

int num(int x) {
    assert(x >= 0);
    if (x % 2) return -(x / 2) - 1;
    return x / 2 + 1;
}

void finish(int x, int val) {

    out(x, val);
    while (1) {
        for (int i = 1; i <= n; i++) if (!used.count(i)) {
            out(i, 0);
        }
    }
}

int get(int x) {
    if (x > 0) return 2 * (x - 1);
    return 2 * (-x - 1) + 1;
}

int main() {
#ifdef WIN
    //freopen("01", "r", stdin);
#endif // WIN

    cin >> n >> m;

    vector<set<int> > E(2 * n);
    vector<vector<int> > G(2 * n);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        int v1 = -1, v2 = -1;
        if (a > 0) v1 = 2 * (a - 1);
        else v1 = 2 * (-a - 1) + 1;
        if (b > 0) v2 = 2 * (b - 1);
        else v2 = 2 * (-b - 1) + 1;
        E[v1].insert(v2);
        E[v2].insert(v1);
    }

    for (int i = 0; i < 2 * n; i++) {
        for (int x : E[i]) G[i].push_back(x);
    }


    /*for (int x = 0; x < 2 * n; x++) {
        for (int to : G[x]) {
            cerr << x << "->" << to << endl;
        }
        cerr << "\n";
    }*/

    for (int x = 0; x < 2 * n; x++) {
        set<int> S;
        for (int to : G[x]) S.insert(to / 2);
        if (S.size() <= 1) continue;

        int A = -1, B = -1;

        for (int to : G[x]) {
            if ((to / 2) == *S.begin()) A = to;
            if ((to / 2) == *S.rbegin()) B = to;
        }

        assert(A != -1 && B != -1);
        auto c = out(num(x), 0);


        //cerr << "x = " << x << endl;
        //cerr << "FADFSSADAS" << endl;

        //cerr << num(A) << " " << c.first << endl;

        if (abs(num(A)) == c.first) finish(num(B), 0);
        else finish(num(A), 0);
    }


    for (int x = 0; x < 2 * n; x += 2) {
        set<int> S;

        for (int to : G[x]) S.insert(to / 2);
        for (int to : G[x ^ 1]) S.insert(to / 2);

        //cerr << x << ", S = "; for (int x : S) cerr << x << ", ";
        //cerr << endl;

        if (S.size() <= 1) continue;

        int A = -1, B = -1;
        for (int to : G[x]) {
            if (*S.begin() == to / 2) A = to;
            if (*S.rbegin() == to / 2) B = to;
        }
        for (int to : G[x ^ 1]) {
            if (*S.begin() == to / 2) A = to;
            if (*S.rbegin() == to / 2) B = to;
        }
        assert(A != -1 && B != -1);

        //cerr << A << ", " << B << endl;

        auto c = out(num(A), 0);
        if (abs(num(x)) == c.first) finish(num(B), 0);
        else finish(num(x), 0);
    }

    for (int x = 0; x < 2 * n; x++) if (!used.count(x)) {
        set<int> S;
        for (int to : G[x]) S.insert(to);
        if (S.size() <= 1) continue;
        finish(num(x), 0);
    }


    int ok = 0;
    for (int i = 0; i < 2 * n; i += 2) if (G[i].size() && G[i ^ 1].size()) {
        ok = 1;
    }
    if (!ok) cout << "-1 -1" << endl, exit(0);

    int cnt = 0;
    for (int i = 0; i < 2 * n; i += 2) if (G[i].empty() && G[i ^ 1].empty()) cnt++;
    if (cnt % 2 == 0) cout << "-1 -1" << endl, exit(0);

    for (int x = 0; x < 2 * n; x++) {
        if (used.count(x)) continue;
        if (G[x].size() == 1 && G[x ^ 1].empty()) {
            auto c = out(num(x), 0);
            if (abs(num(G[x][0])) != c.first) finish(num(G[x][0]), 0);
        }
    }

    set<int> leaves;
    for (int i = 0; i < 2 * n; i += 2) if (G[i].empty() && G[i ^ 1].empty())
        leaves.insert(i);

    while (1) {
        auto c = out(num(*leaves.begin()), 0);
        leaves.erase(leaves.begin());

        int nv = get(c.first);
        if (leaves.count(nv) || leaves.count(nv ^ 1)) {
            leaves.erase(nv);
            leaves.erase(nv ^ 1);
            continue;
        }

        int A = get(c.first);
        int B = G[A][0];

        //cerr << A << " " << B << endl;

        if (c.second == 0)  finish(num(B), 0);
        else finish(num(B ^ 1), 0);
    }
    assert(0);
    return 0;
}

