#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int dd = (int)2007;

int d[dd], c[dd], p[dd];
ll dp[dd][2 * dd];
int par[dd][2 * dd];


struct Fen {
    pair<ll, int> T[dd];

    Fen() { fill(T, T + dd, make_pair((ll)1e18, -1)); }

    void upd(int pos, pair<ll, int> val) {
        for (int i = pos + 1; i; i -= (i&-i)) T[i] = min(T[i], val);
    }
    pair<ll, int> get(int pos) {
        pair<ll, int> res((ll)1e18, -1);
        for (int i = pos + 1; i < dd; i += (i&-i)) res = min(res, T[i]);
        return res;
    }
} Q[2 * dd];

int main() {
#ifdef WIN
    freopen("01", "r", stdin);
#endif // WIN


    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> d[i] >> c[i] >> p[i];

    for (int i = 0; i < n; i++) c[i] = min(c[i], m);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= 2 * m; j++) {
            dp[i][j] = (ll)1e18;
            par[i][j] = -1;
        }
    }

    vector<int> G;
    for (int i = 0; i < n; i++) G.push_back(d[i]);

    sort(G.begin(), G.end());
    G.resize(unique(G.begin(), G.end()) - G.begin());

    for (int i = 0; i < n; i++) d[i] = lower_bound(G.begin(), G.end(), d[i]) - G.begin() + 1;

    for (int i = 0; i < n; i++) {
        for (int j = c[i] + 1; j <= 2 * m; j++) {
            auto cur = Q[j - c[i]].get(d[i]);

            if (cur.first + p[i] < dp[i][j]) {
                dp[i][j] = cur.first + p[i];
                par[i][j] = cur.second;
            }
        }

        if (dp[i][c[i]] > p[i]) {
            dp[i][c[i]] = p[i];
            Q[c[i]].upd(d[i], make_pair(dp[i][c[i]], i));
        }
        for (int j = c[i] + 1; j <= 2 * m; j++) {
            if (dp[i][j] < (ll)1e18) {
                Q[j].upd(d[i], make_pair(dp[i][j], i));
            }
        }

        /*for (int j = 0; j <= m; j++) {
            cout << i << " " << j << "  = ";
            cout << dp[i][j] << ", ";
        }
        cout << "\n";*/
    }

    ll cur = (ll)1e18;
    int ii = -1, jj = -1;

    for (int i = 0; i < n; i++) {
        for (int j = m; j <= 2 * m; j++) {
            if (dp[i][j] < cur) {
                cur = dp[i][j];
                ii = i, jj = j;
            }
        }

    }

    if (cur == (ll)1e18) cout << -1, exit(0);

    cout << cur << " ";
    vector<int> ans;

    int i = ii, j = jj;

    while (i != -1) {
        ans.push_back(i);

        int ni = par[i][j];
        int nj = j - c[i];
        i = ni, j = nj;
    }

    cout << ans.size() << "\n";
    reverse(ans.begin(), ans.end());
    for (int x : ans) cout << x + 1 << " ";




    return 0;
}

