#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
typedef long long ll;

int solve();

int main(){
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen ("input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
#endif // home
    solve();
}
struct Point {
    ll x,y,num;
    Point (ll _x, ll _y,int _num)
    {
        x = _x;
        y = _y;
        num = _num;
    }
    Point(){}

    Point operator+(Point v) {
        return Point(x+v.x, y+v.y, 0);
    }
    Point operator-(Point v) {
        return (Point(x-v.x,y-v.y,0));
    }
};
long long crossproduct(Point a, Point b)
{
    return (ll)a.x*(ll)b.y - (ll)a.y * b.x;
}
long long dotproduct(Point a,Point b)
{
    return (ll)a.x * b.x + (ll)a.y * b.y;
}
bool online(Point A, Point B , Point C)
{
    B = (B-A);
    C = (C-A);
    if (crossproduct(B,C) == 0)
    {
        return 1;
    }
    return 0;
}
struct Line
{
    ll a,b,c;
    Line (Point p, Point t)
    {
        a = t.y - p.y;
        b = p.x - t.x;
        c = -a * p.x - b * p.y;
    }
    Line () {}
};
ll gcd(ll a,ll b)
{
    if(a<b)
        swap(a,b);
    if (b==0)
        return a;
    return gcd(b,a%b);
}
map<pair<ll,ll>, vector<pair<Point,Point> > > m1,m2;
Point a[(int)2e5];
Point b[(int)2e5];
int solve(){
    int n ,m;
    cin >> n;
    for(int i = 1;i<=n;i++)
    {
        ll x,y;
        cin >> x >> y;
        a[i] = Point(x,y,i);
    }
    a[0]= a[n];
    cin >> m;
    for(int i = 1;i<=n;i++)
    {
        ll x,y;
        cin >> x >> y;
        b[i] = Point(x,y,i);
    }
    b[0]= b[m];
    for(int i = 0;i<n;i++)
    {
        Line ln;
        ln = Line(a[i],a[i+1]);
        ll A = ln.a;
        ll B = ln.b;
        if (A==0)
        {
            B=1;
            m1[{A,B}].push_back({a[i],a[i+1]});
            continue;
        }
        if(B==0)
        {
            A = 1;
            m1[{A,B}].push_back({a[i],a[i+1]});
            continue;
        }
        ll k = 1;
        if (A<0 && B>0 || A>0 && B<0)
            k = -1;
        A = abs(A);
        B = abs(B);
        ll g = gcd(A,B);
        A/=g;
        B/=g;
        A*=k;
        m1[{A,B}].push_back({a[i],a[i+1]});
    }
    for(int i = 0;i<m;i++)
    {
        Line ln;
        ln = Line(b[i],b[i+1]);
        ll A = ln.a;
        ll B = ln.b;
        if (A==0)
        {
            B=1;
            m2[{A,B}].push_back({b[i],b[i+1]});
            continue;
        }
        if(B==0)
        {
            A = 1;
            m2[{A,B}].push_back({b[i],b[i+1]});
            continue;
        }
        ll k = 1;
        if (A<0 && B>0 || A>0 && B<0)
            k = -1;
        A = abs(A);
        B = abs(B);
        ll g = gcd(A,B);
        A/=g;
        B/=g;
        A*=k;
        m2[{A,B}].push_back({b[i],b[i+1]});
    }
    for(auto v:m1)
    {
        for(auto x:v.second)
        {
            if (m2[v.first].size()==0)
                break;
            for(auto y:m2[v.first])
            {
                if (online(x.first, x.second, y.first)){
                        continue;

                }

                Point p = a[(x.first.num + 2) % n];
               // cout << x.first.num<<endl;
               // cout << x.second.num<<endl;
               // cout << p.num<<endl;
                //cout << y.first.num<<endl;
                ll c = crossproduct(x.first - x.second, p - x.second);
                ll c1 = crossproduct(x.first - x.second, y.first - x.second);
               // cout << c<<' '<<c1<<endl;
                if (!(c < 0 && c1 > 0 || c > 0 && c1 < 0)) continue;
                //cout<<'!'<<v.first.first<<' '<<v.first.second<<endl;;

                p = b[(y.first.num + 2) % m];

                c = crossproduct(y.first - y.second, p - y.second);
                c1 = crossproduct(y.first - y.second, x.first - y.second);

                if (!(c < 0 && c1 > 0 || c > 0 && c1 < 0)) continue;

                ll c2, c3, c4;

                c1 = dotproduct(x.first - x.second, y.first - x.second);
                c2 = dotproduct(x.first - x.second, y.second - x.second);
                c3 = dotproduct(x.second - x.first, y.first - x.first);
                c4 = dotproduct(x.second - x.first, y.second - x.first);

                if (c1 <= 0 && c2 <= 0) continue;
                if (c3 <= 0 && c4 <= 0) continue;

                cout << "YES\n";
                cout << x.first.num << ' ' << y.first.num << '\n';
                return 0;
            }
        }
    }
    for(auto x:m1)
    {
        cout << x.first.first<<' '<<x.first.second<<endl;
    }
    cout<<endl;
    for(auto x:m2)
    {
        if (x.second.size())
        cout << x.first.first<<' '<<x.first.second<<endl;
    }
    cout<<endl;
    cout << "NO";
}

