#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 100005;
const int mod = 1e9 + 7;

ll arr[maxN];
ll pref[10][maxN];

int getLg(ll x) {
    int res = 0;
    while (x > 0) {
        x /= 10;
        res++;
    }
    return res;
}

ll solve(int n) {
    ll st = 1;
    for (int k = 0; k < 10; k++) {
        pref[k][0] = 0;

        for (int i = 1; i <= n; i++) pref[k][i] = (pref[k][i - 1] + arr[i - 1] * st) % mod;

        st = (st * 10) % mod;
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        int lg = getLg(arr[i]);

        ans = (ans + pref[lg][i] + arr[i] * i) % mod;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) cin >> arr[i];

    ll ans = solve(n);
    reverse(arr, arr + n);
    cout << (ans + solve(n)) % mod << endl;

    return 0;
}
