#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <alg.h>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef pair <int, int> pii;

int main() {
	string s;
	cin >> s;
	ll n = s.size();
	ll ans = 1;
	ll pref = 0, suf = 0;
	for (int len = 1; len < n; len++) {
		pref += s[len - 1] - '0';
		suf += s[n - len] - '0';
		if (abs(suf - pref) + 1 != n - len + 1){
			ans = len;
		}
	}
	vector <pii> b(n + 1, make_pair(-1, -1));
	ll nowSum = 0;
	for (int i = 0; i < ans; i++) {
		nowSum += s[i] - '0';
	}
	b[nowSum] = make_pair(0, ans - 1);
	for (int i = ans; i < n; i++) {
		nowSum -= s[i - ans] - '0';
		nowSum += s[ans] - '0';
		if (b[nowSum] == make_pair(-1, -1)) {
			b[nowSum] = make_pair(i - ans + 1, i);
		}
		else {
			pii fir = b[nowSum];
			cout << fir.first + 1 << ' ' << fir.second + 1 << ' ' << i - ans + 2 << ' ' << i + 1;
			return 0;
		}
	}
	return 0;
}