#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <cctype>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	string s;
	cin >> s;
	int n = (int)s.size();
	if (s[0] == s[n - 1]) {
		cout << 1 << " " << n - 1 << " " << 2 << " " << n << endl;
		return 0;
	}

	vector<int> p(n);
	p[0] = s[0] == '1';
	for (int i = 1; i < n; i++)
		p[i] = p[i - 1] + (s[i] == '1');

	//000010000
	if (p[n - 1] == 1) {
		if (s[0] == '1')
			cout << "2 2 3 3" << endl;
		else
			cout << "1 1 2 2" << endl;

		return 0;
	}


	if (s[0] == '0') {
		int i = 0;
		while (i < n && s[i] == '0')
			i++;
		cout << i + 1 << " " << n - 1 << " " << i + 2 << " " << n << endl;
	}
	else {
		int i = n - 1;
		while (i >= 0 && s[i] == '0')
			i--;
		cout << 1 << " " << i << " " << 2 << " " << i + 1 << endl;
	}
}
