#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <cctype>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	//freopen("input.txt", "r", stdin);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	sort(h.begin(), h.end());

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	sort(a.begin(), a.end());

	long long ans = 0;

	for (int i = 0; i < n; i++) {


		int cl = -1, cr = -1, lcap = 0, rcap = 0;
		for (int j = 0; j < 3; j++) {
			if (cr == -1 && h[j].first >= a[i] && h[j].second > 0)
				cr = j;
			if ((cl == -1 ||  (a[i] - h[cl].first > a[i] - h[j].first)  ) && h[j].first < a[i] && h[j].second > 0) 
				cl = j;

			if (h[j].first >= a[i])
				rcap += h[j].second;
			if (h[j].first < a[i])
				lcap += h[j].second;
		}

		if (cl != -1 && rcap <= n - i - 1) {
			ans += (long long)a[i] - h[cl].first;
			h[cl].second--;
		}
		else {
			int mv = -1;
			if (cl == -1)
				mv = cr;
			else if (cr == -1)
				mv = cl;
			else
				mv = (h[cr].first - a[i] >= a[i] - h[cl].first ? cl : cr);

			ans += (long long)abs(a[i] - h[mv].first);
			h[mv].second--;
		}


	}

	cout << ans << endl;
}
