#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	//freopen("input.txt", "r", stdin);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	sort(h.begin(), h.end());

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	sort(a.begin(), a.end());

	long long ans = 0;

	vector<long long> dp(n);
	vector<int> last(n);

	dp[0] = abs(a[0] - h[0].first);
	last[0] = 0;
	h[0].second--;

	for (int i = 1; i < n; i++) {
		long long r = INT_MAX, trg = -1;
		for (int j = 0; j < 3; j++) {
			if (h[j].second > 0 && r > abs(a[i] - h[j].first)) {
				r = abs(a[i] - h[j].first);
				trg = j;
			}
		}

		if (dp[i - 1] + r > 
			((i > 1) ? dp[i - 2] : 0) 
			+ abs(a[i - 1] - h[trg].first) 
			+ abs(h[last[i - 1]].first - a[i])) {
			last[i] = last[i - 1];
			last[i - 1] = trg;
			dp[i] =
				((i > 1) ? dp[i - 2] : 0)
				+ abs(a[i - 1] - h[trg].first)
				+ abs(h[last[i - 1]].first - a[i]);
		}
		else {
			last[i] = trg;
			dp[i] = dp[i - 1] + r;
		}

		h[trg].second--;
	}

	cout << dp[n - 1] << endl;
}
