#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>

using namespace std;

int count_d(int x)
{
	int res = 0;

	do {
		res++;
		x /= 10;
	} while (x > 0);

	return res;
}

long long p10(int x)
{
	long long res = 1;
	for (int i = 1; i <= x; i++)
		res *= 10;

	return res;
}

const long long BASE = 1e+9 + 7;

int main()
{
	int n;
	cin >> n;

	vector<int> a(n);
	vector<int> d(n);
	vector<int> count(10, 0);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		d[i] = count_d(a[i]);
		count[d[i]]++;
	}

	long long ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 1; j <= 9; j++) {
			int tms = count[j] - (d[i] == j);

			ans = (ans + (long long)a[i] * tms * (1LL + p10(j))) % BASE;
		}

	cout << ans;
}

/*int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	sort(h.begin(), h.end());

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	sort(a.begin(), a.end());

	long long ans = 0;
	for (int i = 0; i < n; i++) {
		int dst, d = INT_MAX;
		for (int j = 0; j < 3; j++) {
			if (h[j].second > 0 && d > abs(a[i] - h[j].first)) {
				dst = j;
				d = abs(a[i] - h[j].first);
			}
		}

		h[dst].second--;
		ans += (long long)d;
	}

	cout << ans << endl;
}*/