#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double dl;

ll INF = 1e17;
ll inf = 1e9;

vector<vector<pair<ll, ll>>> g;

int main()
{
	//freopen("input.txt", "r", stdin);

	ll n;
	scanf("%lld", &n);

	g.resize(n);

	vector<ll> deg(n, 0);

	map<pair<ll, ll>, ll> rood;
	vector<pair<ll, ll>>ege;


	for (int i = 0; i < n - 1; ++i)
	{
		ll u, v, l;
		scanf("%lld%lld%lld", &u, &v, &l);
		--u;
		--v;

		deg[u] += 1;
		deg[v] += 1;

		g[u].push_back({ v, l });
		g[v].push_back({ u, l });

		rood[{u, v}] = i;
		rood[{v, u}] = i;

		ege.push_back({ u, v });

	}

	ll m;
	scanf("%lld", &m);
	vector<ll> bad(m);
	vector<ll> t(n, inf), pred(n, -1);
	set<pair<ll, pair<ll, pair<ll, ll>>>> sett;

	vector<ll> used(n);

	for (int i = 0; i < m; ++i)
	{
		scanf("%lld", &bad[i]);
		--bad[i];
		t[bad[i]] = 0;
		sett.insert({ 0,{ 1,{ bad[i], -1 } } });
		//used[bad[i]] = 1;
	}

	ll comp = 1, ans = 1;

	ll predt = 0;
	ll noww = -1;
	while (!sett.empty())
	{
		pair<ll, pair<ll, pair<ll, ll>>> p = *sett.begin();
		sett.erase(sett.begin());

		if (p.first != predt)
		{
			ans = max(ans, comp);
			predt = p.first;
		}

		if (p.second.first == 1 && used[p.second.second.first] == 0)
		{
			ll v = p.second.second.first;

			used[v] = 1;

			comp -= 1;

			for (int i = 0; i < g[v].size(); ++i)
			{
				ll to = g[v][i].first;
				ll len = g[v][i].second;

				if (p.second.second.second == to)
					continue;

				if (!used[to])
				{
					sett.insert({ (ll)(t[v] + len),{ 1,{ to, v } } });
					comp += 1;
					pred[to] = v;
				}
				else
				{
					if (t[to] + len == t[v])
					{
						//comp += 1;
					}
					else
					{
						sett.insert({ ll(len - (t[v] - t[to]) + 1) / 2 + t[v],{ 0,{ rood[{v, to}], -1 } } });
						comp += 1;
					}
				}
			}
		}
		else if (p.second.first == 0)
		{
			comp -= 1;
		}
	}

	ans = max(ans, comp);
	printf("%lld\n", ans);

	return 0;
}

/*


*/