#include<bits/stdc++.h>
using namespace std;

struct node {
    int l, r, x;
    node * left, * right;
    node(int _l, int _r, int _x, node * _left, node * _right) {
        l = _l;
        r = _r;
        x = _x;
        right = _right;
        left = _left;
    }
};

node * build(int l, int r) {
    if (l == r) {
        return new node(l, r, 0, NULL, NULL);
    }
    int m = (l + r) / 2;
    return new node(l, r, 0, build(l, m), build(m + 1, r));
}
node * modify(int pos, int x, node * v) {
    if (v -> l == v -> r) {
        return new node(pos, pos, x, NULL, NULL);
    }
    int med = (v -> l + v -> r) / 2 ;
    node * ans;
    if (pos <= med) {
        return new node(v -> l, v -> r, 0, modify(pos, x, v -> left), v -> right);
    } else {
        return new node(v -> l, v -> r, 0, v -> left, modify(pos, x, v -> right));
    }
}

int get(node * v, int pos) {
    if (v -> l == v -> r) { return v -> x;}
    int med = (v -> l + v -> r) / 2 ;
    if (pos <= med) return get(v -> left, pos);
    return get(v -> right, pos);
}

signed main()
{
//    freopen("tmp.txt", "r", stdin);
    map <string, int> var;
    string s;
    vector <int> type; //1 varnum 2 varvar 3 open 4 close
    vector <pair <int, int> > req;
    int cnt = 0;
    while (cin >> s) {
        if (s == "{") {
            type.push_back(3);
            req.push_back({1, 1});
        } else if (s == "}") {
            type.push_back(4);
            req.push_back({1, 1});
        } else {
            int id = find(s.begin(), s.end(), '=') - s.begin();
            string a = "", b = "";
            for (int i = 0; i < id; i++) {
                a += s[i];
            }
            bool any_chr = false;
            for (int i = id + 1; i < s.size(); i++) {
                if ('a' <= s[i] && 'z' >= s[i]) {
                    any_chr = true;
                }
                b += s[i];
            }
            if (var.count(a) == 0) {
                var[a] = cnt++;
            }
            if (any_chr) {
                if (var.count(b) == 0) {
                    var[b] = cnt++;
                }
                type.push_back(2);
                req.push_back(make_pair(var[a], var[b]));
            } else {
                type.push_back(1);
                req.push_back(make_pair(var[a], stoi(b)));
            }
        }
    }
//    return 0;
    vector <node *> states(1, build(0, cnt - 1));
    vector <int> id;
    int pt = 0;
    for (int i = 0; i < (int)type.size(); i++) {
        if (type[i] == 1) {
            states.push_back(modify(req[i].first, req[i].second, states[pt]));
            pt = states.size() - 1;
        } else if (type[i] == 2) {
            int val = get(states[pt], req[i].second);
            cout << val << "\n";
            states.push_back(modify(req[i].first, val, states[pt]));
            pt = states.size() - 1;
        } else if (type[i] == 3) {
            id.push_back(pt);
        } else {
            pt = id.back(); id.pop_back();
        }
    }
}

