#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <climits>
#include <stdio.h>
using namespace std;

typedef long long ll;
typedef unsigned long long llu;

#define all(n) n.begin(), n.end()
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define files freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout)

void callStack(map<string, int> nv)
{
	string d;
	while (getline(cin, d))
	{
		if (d == "}")
			break;
		if (d == "{")
		{
			callStack(nv);
			continue;
		}
		string v1, v2;
		int i = 0, val = INT_MAX;
		while (d[i] != '=')	v1.push_back(d[i++]);
		++i;
		if (isdigit(d[i]) || d[i] == '-')
			val = atoi(d.substr(i, d.size() - i).c_str());
		else
			v2 = d.substr(i, d.size() - i);
		if (val == INT_MAX)
		{
			if (nv.find(v2) == nv.end())
				nv[v2] = 0;
			nv[v1] = nv[v2];
			cout << nv[v2] << endl;
		}
		else
			nv[v1] = val;
	}
}

int main()
{
	speed;
	//files;
	map<string, int> nv;
	callStack(nv);
	return 0;
}