#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <climits>
#include <stdio.h>
using namespace std;

typedef long long ll;
typedef unsigned long long llu;

#define all(n) n.begin(), n.end()
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define files freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout)

int main()
{
	//files;
	int n, m;
	cin >> n >> m;
	if (m + 1 != n)
		cout << "No";
	else
	{
		stack<int> Real, Prom;
		for (int i = 1; i <= n; ++i)
			Real.push(i);
		for (int i = 1; i <= m; ++i)
		{
			int f;
			cin >> f;
			Prom.push(f);
		}
		int nuse = -1;
		while (!Real.empty())
		{
			int v1, v2;
			v1 = Real.top();
			if (!Prom.empty())
				v2 = Prom.top();
			else
			{
				nuse = 1;
				break;
			}
			if (v1 < v2)
			{
				nuse = -1;
				break;
			}
			else if (v1 == v2)
				Real.pop(), Prom.pop();
			else
			{
				if (nuse == -1)
					nuse = v1;
				else
				{
					nuse = -1;
					break;
				}
				Real.pop();
			}
		}
		if (nuse == -1)
			cout << "No";
		else
			cout << "Yes\n" << nuse;
	}
	return 0;
}