// anime.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <map>
#include <stack>
#include <unordered_map>

using namespace std;

long long PW = 31;
const long long MOD = 99978397283;

long long make_hash(string s)
{
	long long cur_hash = 0;
	for (long long i = 0; i < s.size(); i++)
	{
		cur_hash = (cur_hash * PW + s[i] - 'a') % MOD;
	}
	return cur_hash;
}

int main()
{
	stack<unordered_map<long long, long long> > dct;
	string s;
	dct.push(unordered_map<long long, long long>());
	vector<long long> answ;
	while(cin >> s)
	{
		if (s == "{")
		{
			dct.push(dct.top());
		}
		else if (s == "}")
		{
			dct.pop();
		}
		else if (s != "")
		{
			string t;
			long long p = 0;
			while (s[p] != '=')
			{
				t.push_back(s[p]);
				p++;
			}
			p++;
			if (s[p] >= 'a' && s[p] <= 'z')
			{
				string t2;
				while (p < s.size())
				{
					t2.push_back(s[p]);
					p++;
				}
				dct.top()[make_hash(t)] = dct.top()[make_hash(t2)];
				cout << dct.top()[make_hash(t)] << endl;
			}
			else
			{
				bool mins = 0;
				if (s[p] == '-')
				{
					mins = 1;
					p++;
				}
				long long num = 0;
				while (p < s.size())
				{
					num = num * 10 + (s[p] - '0');
					p++;
				}
				if (mins)
					num = -num;
				dct.top()[make_hash(t)] = num;
			}
		}
	}
	return 0;
}

