#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define vec vector

int str_to_int(string s) {
    bool neg = (s[0] == '-');
    if (s[0] == '-') { s.erase(0, 1); }
    int num = 0;
    for (char c : s) {
        num = num * 10 + (c - '0');
    }
    return (neg ? -num : num);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    vec<multiset<string> > vars(1);
    int cur = 0;
    map<string, stack<int> > dict;

    string s;
    while (cin >> s) {
        if (s[0] == '{') {
            vars.resize(++cur + 1);
            continue;
        } else if (s[0] == '}') {
            for (auto k : vars[cur]) {
                dict[k].pop();
            }
            vars[cur--].clear();
            continue;
        }
        int ind = s.find("=");
        string a = s.substr(0, ind);
        string b = s.substr(ind + 1, s.length() - ind - 1);

        vars[cur].insert(a);
        //cout << a << " " << b << '\n';
        if (dict.find(a) == dict.end()) { dict[a].push(0); }
        if (dict.find(b) == dict.end()) { dict[b].push(0); }

        if (a == b) {
            cout << dict[b].top() << '\n';
            dict[a].push(dict[b].top());
        }
        else if (b[0] >= 'a' && b[0] <= 'z') {
            cout << dict[b].top() << '\n';
            dict[a].push(dict[b].top());
        } else {
            dict[a].push(str_to_int(b));
        }
    }
    return 0;
}
