﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace A
{
    class Program
    {
        static int[] a;
        static int n;
        static int[] prefSums;
        static void Main(string[] args)
        {
            a = Array.ConvertAll(Console.ReadLine().ToCharArray(), x => x == '1' ? 1 : 0);
            n = a.Length;
            prefSums = new int[n + 1];
            prefSums[0] = 0;
            for (int i = 0; i < n; i++)
                prefSums[i + 1] = prefSums[i] + a[i];
            int lLen = 1, rLen = n - 1;
            while (rLen - lLen > 1)
            {
                int mid = (lLen + rLen) / 2;
                int res1Start, res2Start;
                F(mid, out res1Start, out res2Start);
                if (res1Start != -1 && res2Start != -1)
                    lLen = mid;
                else
                    rLen = mid - 1;
            }
            int result1Start, result1End, result2Start, result2End;
            int len = rLen;
            F(rLen, out result1Start, out result2Start);
            if (result1Start == -1 || result2Start == -1)
            {
                F(lLen, out result1Start, out result2Start);
                len = lLen;
            }
            result1Start++;
            result2Start++;
            result1End = result1Start + len - 1;
            result2End = result2Start + len - 1;
            Console.WriteLine(result1Start + " " + result1End + " " + result2Start + " " + result2End);
            //Console.ReadLine();
        }
        static void F(int len, out int res1Start, out int res2Start)
        {
            Dictionary<int, int> d = new Dictionary<int, int>();
            res1Start = -1;
            res2Start = -1;
            for (int i = 0; i + len - 1 < n; i++)
            {
                int res = prefSums[i + len] - prefSums[i];
                if (d.ContainsKey(res))
                {
                    res1Start = d[res];
                    res2Start = i;
                    break;
                }
                else
                    d.Add(res, i);
            }
        }
    }
}
