#include <iostream>
#include<vector>
#include<algorithm>

typedef long long ll;
const ll mod = 1e9 + 7;

int main() {
	ll n;
	std::cin >> n;
	std::vector<ll>a(n), pw(10), cnt(n);
	pw[0] = 1;
	for (int i = 1; i < 10; ++i) {
		pw[i] = pw[i - 1] * 10;
	}
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i];
	}
	std::sort(a.begin(), a.end());
	std::vector<std::vector<ll> > pref(n, std::vector<ll>(10));
	ll sum = 0;
	for (int i = 0; i < n; ++i) {
		ll p = a[i], x = 0;
		while (p != 0) {
			p /= 10;
			++x;
		}
		pref[i][x] += 1;
		cnt[i] = x;
		for (int j = 0; j < 10; ++j)
			if (i > 0) {
				pref[i][j] += pref[i - 1][j];
			}
	}
	for (int i = 0; i < n; ++i) {
		sum = (sum + a[i] * (n - 1) % mod) % mod;
		for (int j = 0; j < 10; ++j) {
			sum = (sum + a[i] * (pref[n - 1][j] - (cnt[i] == j)) % mod * pw[j] % mod) % mod;
		}
	}
	std::cout << sum;
	return 0;
}