#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

const int M = 2005;
const ll INF = 2e18;

pair<ll, int> t[M][4 * M];
int pr[M * 2][M];

void update(int i, int v, int vl, int vr, int pos, ll val, int j)
{
    if (vl == vr)
    {
        if (val < t[i][v].X) t[i][v] = {val, j};
    }
    else
    {
        int vm = (vl + vr) >> 1;
        if (pos <= vm)
            update(i, v * 2 + 1, vl, vm, pos, val, j);
        else
            update(i, v * 2 + 2, vm + 1, vr, pos, val, j);
        t[i][v] = min(t[i][v * 2 + 1], t[i][v * 2 + 2]);
    }
}

pair<ll, int> get(int i, int v, int vl, int vr, int l, int r)
{
    if (l > vr || r < vl) return {INF, 0};
    if (l <= vl && vr <= r) return t[i][v];
    int vm = (vl + vr) >> 1;
    return min(get(i, v * 2 + 1, vl, vm, l, r), get(i, v * 2 + 2, vm + 1, vr, l, r));
}

int solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> d(n), c(n), p(n), dd(n);
    for(int i = 0; i < n; ++i)
    {
        cin >> d[i] >> c[i] >> p[i];
        dd[i] = d[i];
    }
    sort(all(dd));
    for(int i = 0; i < n;++i)
    {
        d[i] = lower_bound(all(dd), d[i]) - dd.begin();
    }
    for(int i = 0; i < 2 * M; ++i)
        for(int j = 0; j < M; ++j) pr[i][j] = -1;
    for(int i = 0; i < M; ++i)
        for(int j = 0; j < 4 * M; ++j) t[i][j] = {INF, 0};
    ll ans = INF;
    int l, r;
    for(int i = 0; i < n; ++i)
    {
        for(int j = 4000; j > c[i]; --j)
        {
            if (j - c[i] > m) continue;
            pair<ll, int> x = get(j - c[i], 0, 0, n - 1, d[i], n - 1);
            if (x.X == INF) continue;
            if (j <= m && get(j, 0, 0, n - 1, d[i], d[i]).X > x.X + p[i] || j > m)
            {
                pr[j][i] = x.Y;
            }
            if (j <= m)
                update(j, 0, 0, n - 1, d[i], x.X + p[i], i);
            if (j >= m && x.X + p[i] < ans)
                ans = x.X + p[i], l = j, r = i;
        }
        update(c[i], 0, 0, n - 1, d[i], p[i], i);
            if (c[i] >= m && p[i] < ans)
                ans = p[i], l = c[i], r = i;
    }
    for(int i = m; i < M; ++i)
    {
        if (get(i, 0, 0, n - 1, 0, n - 1).X < ans)
            ans = get(i, 0, 0, n - 1, 0, n - 1).X, l = i, r = get(i, 0, 0, n - 1, 0, n - 1).Y;
    }
    if (ans == INF) cout << -1, exit(0);
    cout << ans << ' ';
    vi an;
    while(r != -1)
    {
        an.inb(r + 1);
        int x = pr[l][r];
        l -= c[r];
        r = x;
    }
    cout << an.size() << '\n';
    sort(all(an));
    for(int x : an) cout << x << ' ';
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    #ifdef _DEBUG
    freopen("01.txt", "r", stdin);
    #endif // _DEBUG
    solve();
    return 0;
}
