//
// Created by orspc on 10.12.2017.
//
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <unordered_set>

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::string s;
    std::cin >> s;
    std::vector<int> sum(s.size() + 1);
    for (int i = 0; i < s.size(); ++i) {
        sum[i + 1] = sum[i] + s[i] - '0';
    }
    int left = 1, right = (int) s.size();
    while (right - left > 1) {
        std::unordered_set<int> m;
        int mid = (left + right) >> 1;
        for (int i = mid - 1; i < s.size(); ++i) {
            int cnt = sum[i + 1] - sum[i - mid + 1];
            if (m.count(cnt)) {
                left = mid;
                break;
            } else {
                m.insert(cnt);
            }
        }
        if (left != mid) {
            right = mid;
        }
    }
    {
        std::unordered_set<int> m;
        int mid = right;
        for (int i = mid - 1; i < s.size(); ++i) {
            int cnt = sum[i + 1] - sum[i - mid + 1];
            if (m.count(cnt)) {
                left = mid;
                break;
            } else {
                m.insert(cnt);
            }
        }
    }
    {
        std::map<int, std::pair<int, int>> m;
        int mid = left;
        for (int i = mid - 1; i < s.size(); ++i) {
            int cnt = sum[i + 1] - sum[i - mid + 1];
            if (m.count(cnt)) {
                std::cout << m[cnt].first + 1 << ' ' << m[cnt].second + 1<< ' ' << i - mid + 2 << ' ' << i + 1;
                return 0;
            } else {
                m[cnt] = {i - mid + 1, i};
            }
        }
    }
}