//
// Created by orspc on 10.12.2017.
//
#include <iostream>
#include <set>

using ll = long long;

bool is_prime(int a) {
    for (int i = 2; i * i <= a; ++i) {
        if (a % i == 0) {
            return 0;
        }
    }
    return 1;
}

int main() {
    std::set<ll> s[12];
    s[0] = {2, 3, 5, 7};
    s[1] = {2, 3, 5, 7};
    ll deg = 10;
    for (int i = 2; i <= 11; ++i) {
        for (auto num : s[i - 1]) {
            for (int k = 1; k <= 9; ++k) {
                if (is_prime(k * deg + num)) {
                    s[i].insert(k * deg + num);
                    s[0].insert(k * deg + num);
                }
            }
        }
        deg *= 10;
    }
    ll a = 0, b = 0;
    std::cin >> a >> b;
    ll cnt = 0;
    for (auto i = s[0].lower_bound(a); i != s[0].lower_bound(b + 1); ++i) {
        ++cnt;
    }
    std::cout << cnt;
    return 0;
}