//
// Created by orspc on 10.12.2017.
//
#include <iostream>
#include <set>

using ll = long long;

bool is_prime(ll a) {
    for (register int i = 2; (ll) i * i <= a; ++i) {
        if (a % i == 0) {
            return 0;
        }
    }
    return 1;
}

int main() {
    ll deg = 10;
    ll a = 0, b = 0, cnt = 0;
    std::set<ll> s[12];
    s[1] = {2, 3, 5, 7};
    s[2] = {13, 17, 23, 37, 43, 47, 53, 67, 73, 83, 97};
    s[3] = {113, 137, 167, 173, 197, 223, 283, 313, 317, 337, 347, 353, 367, 373, 383, 397, 443, 467, 523, 547, 613, 617, 643, 647,
    653, 673, 683, 743, 773, 797, 823, 853, 883, 937, 947, 953, 967, 983, 997};
    s[4] = {1223, 1283, 1367, 1373, 1523, 1613, 1823, 1997, 2113, 2137, 2347, 2383, 2467, 2617, 2647, 2683, 2797, 2953, 3137, 3167,
    3313, 3347, 3373, 3467, 3547, 3613, 3617, 3643, 3673, 3797, 3823, 3853, 3947, 3967, 4283, 4337, 4373, 4397, 4523, 4547,
            4643, 4673, 4937, 4967, 5113, 5167, 5197, 5347, 5443, 5647, 5653, 5683, 5743, 5953, 6113, 6173, 6197, 6317, 6337, 6353,
            6367, 6373, 6397, 6547, 6653, 6673, 6823, 6883, 6947, 6967, 6983, 6997, 7283, 7523, 7547, 7643, 7673, 7823, 7853, 7883,
            7937, 8167, 8317, 8353, 8443, 8467, 8647, 9137, 9173, 9283, 9337, 9397, 9467, 9547, 9613, 9643, 9743, 9883, 9967};

    std::cin >> a >> b;
    for (auto i : s[1]) {
        if (i > b) {
            std::cout << cnt;
            return 0;
        } else if (i >= a) {
            ++cnt;
        }
    }
    for (auto i : s[2]) {
        if (i > b) {
            std::cout << cnt;
            return 0;
        } else if (i >= a) {
            ++cnt;
        }
    }
    for (auto i : s[3]) {
        if (i > b) {
            std::cout << cnt;
            return 0;
        } else if (i >= a) {
            ++cnt;
        }
    }
    for (auto i : s[4]) {
        if (i > b) {
            std::cout << cnt;
            return 0;
        } else if (i >= a) {
            ++cnt;
        }
    }
    for (int i = 5; i <= 11; ++i) {
        for (int k = 1; k <= 9; ++k) {
            for (auto num : s[i - 1]) {
                ll x = k * deg + num;
                if (is_prime(x)) {
                    s[i].insert(x);
                    if (x > b) {
                        std::cout << cnt;
                        return 0;
                    }
                    if (x >= a) {
                        ++cnt;
                    }
                }
            }
        }
        deg *= 10;
    }
    std::cout << cnt;
    return 0;
}