// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

bool is_prime(long long v) {
	if (v == 1)
		return false;
	for (ll i = 2; i * i <= v; ++i)
		if (v % i == 0)
			return false;
	return true;
}

vector<ll> v;

long long cur = 0;

long long precalc[12];

void work(int len) {
	v.push_back(cur);
	//cout <<len << " " << cur << endl;
	if (len == 11){
		return;
	}
	for (int i = 1; i <= 9; ++i) {
		cur += precalc[len] * i;
		if (is_prime(cur))
			work(len + 1);
		cur -= precalc[len] * i;
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	//freopen("input.in", "r", stdin);
	/*freopen("output.out", "w", stdout);
	precalc[0] = 1;
	for (int i = 1; i < 12; ++i)
		precalc[i] = precalc[i - 1] * 10;
	work(0);
	sort(v.begin(), v.end());
*/
	string s;
	cin >> s;
	int n = s.length();
	if (s[0] == s[n - 1]) {
		cout << 1 << ' ' << n - 1 << ' ' << 2 << ' ' << n << '\n';
		return 0;
	}
	for (int i = n - 1; i >= 1; i--) {
		if (s[0] == s[i - 1]) {
			cout << 1 << ' ' << i - 1 << ' ' << 2 << ' ' << i << '\n';
			return 0;
		}
		if (s[n - i] == s[n - 1]) {
			cout << n - i + 1 << ' ' << n - 1 << ' ' << n - i + 2 << ' ' << n << '\n';
			return 0;
		}
	}
	return 0;
}

