// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

int a, na, b, nb, c, nc;
vector<int> pos;

long long check(int md) {
	long long res = 0;
	int tb = nb;
	for (int i = 0; i < md; ++i)
		res += abs(pos[i] - a);
	while (pos.size() - md > nc)
		res += abs(pos[md++] - b), tb--;
	for (int i = md; i < pos.size(); ++i)
		res += abs(pos[i] - c);
	while (tb && md < pos.size() && abs(pos[md] - b) <= abs(pos[md] - c)) {
		res -= abs(pos[md] - c);
		res += abs(pos[md] - b);
		md++, tb--;
	}
	return res;
}

void ter() {
	int tl = max(0, (int)pos.size() - nb - nc), tr = na;
	while (tr - tl > 2) {
		int tm1 = (tl * 2 + tr) / 3;
		int tm2 = (tl + tr * 2) / 3;
		long long res1 = check(tm1), res2 = check(tm2);
		if (res1 <= res2)
			tr = tm2;
		else
			tl = tm1;
	}
	long long res1 = check(tl), res2 = check(tr), res3 = check((tl + tr) / 2);
	cout << min(res1, min(res2, res3));
}

int main(){
	ios_base::sync_with_stdio(0);
	/*freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);*/
	cin >> a >> na >> b >> nb >> c >> nc;
	if (a > b)
		swap(a, b), (na, nb);
	if (b > c)
		swap(b, c), swap(nb, nc);
	if (a > b)
		swap(a, b), (na, nb);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int d;
		cin >> d;
		pos.push_back(d);
	}
	sort(pos.begin(), pos.end());
	ter();
	return 0;
}