// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

long long get_len(long long v) {
	long long len = 0;
	while (v) {
		v /= 10;
		len++;
	}
	return len;
}

int main(){
	ios_base::sync_with_stdio(0);
	//freopen("input.in", "r", stdin);
	//freopen("output.out", "w", stdout);
	long long n;
	cin >> n;
	vector<long long> cnt(10, 0);
	vector<long long> v;
	for (int i = 0; i < n; ++i) {
		long long val;
		cin >> val;
		cnt[get_len(val)]++;
		v.push_back(val);
	}
	long long res = 0;
	for (int i = 0; i < n; ++i) {
		long long len = get_len(v[i]);
		cnt[len]--;
		for (int j = 1; j < cnt.size(); ++j)
			res = (res + cnt[j] * (((long long) pow(10, j) * v[i]) % MOD)) % MOD;
		cnt[len]++;
		res = (res + v[i] * (n - 1)) % MOD;
	}
	cout << res;
    return 0;
}

