#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = (ll)(1e18);

int main() {
    #ifdef MY
        freopen("f.in", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    #endif //MY
    vector <pair <ll, ll> > d(3);
    for (ll i = 0; i < 3; ++i) {
        cin >> d[i].first >> d[i].second;
    }
    sort(d.begin(), d.end());
    ll n;
    cin >> n;
    vector <ll> x(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    vector <ll> p1(n, 0), p2(n, 0), p3(n, 0);
    for (ll i = 0; i < n; ++i) {
        p1[i] = abs(d[0].first - x[i]);
        p2[i] = abs(d[1].first - x[i]);
        p3[i] = abs(d[2].first - x[i]);
        if (i > 0) {
            p1[i] += p1[i - 1];
            p2[i] += p2[i - 1];
            p3[i] += p3[i - 1];
        }
    }
    ll ans = INF;
    for (ll i = -1; i < d[0].second; ++i) {
        ll cur = 0;
        if (i >= 0) cur += p1[i];
        ll nvl = min(p2[n - 1] - (i >= 0 ? p2[i] : 0), p3[n - 1] - (i >= 0 ? p3[i] : 0));
        if (n - i - 1 > d[1].second) {
            nvl = p3[n - 1] - (i >= 0 ? p3[i] : 0);
        } else if (n - i - 1 > d[2].second) {
            nvl = p2[n - 1] - (i >= 0 ? p2[i] : 0);
        } else {
            nvl = INF;
        }
        ll L = max(-1LL, n - d[2].second);
        ll R = min(n, i + d[1].second);
        if (L > R) {
            continue;
        }
        ll l = L;
        ll r = R;
        while (R - L > 2) {
            ll M1 = L + (R - L) / 3;
            ll M2 = R - (R - L) / 3;

            ll a1 = p2[M1] - (i >= 0 ? p2[i] : 0);
            ll b1 = p3[n - 1] - p3[M1];

            ll a2 = p2[M2] - (i >= 0 ? p2[i] : 0);
            ll b2 = p3[n - 1] - p3[M2];

            a1 = abs(a1);
            a2 = abs(a2);

            b1 = abs(b1);
            b2 = abs(b2);

            if (a1 + b1 < a2 + b2) {
                R = M2;
            } else {
                L = M1;
            }
        }

        vector <pair <ll, ll> > v = {
            make_pair(p2[L] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[L], L),
            make_pair(p2[L + 1] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[L + 1], L + 1),
            make_pair(p2[R] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[R], R),
        };

        v[0].first = abs(v[0].first);
        v[1].first = abs(v[1].first);
        v[2].first = abs(v[2].first);

        sort(v.begin(), v.end());

        if (v[0].second >= l && v[0].second <= r) {
            cur += min(v[0].first, nvl);
        } else if (v[1].second >= l && v[1].second <= r) {
            cur += min(v[1].first, nvl);
        } else if (v[2].second >= l && v[2].second <= r) {
            cur += min(v[2].first, nvl);
        } else {
            cur = nvl;
        }

        ans = min(ans, cur);
    }

    cout << ans;
    return 0;
}
