//#include <bits/stdc++.h>
//
//using namespace std;
//
//map <int, int> cnt;
//
//int main() {
//    #ifdef MY
//        freopen("f.in", "r", stdin);
//    #else
//        ios_base::sync_with_stdio(false);
//        cin.tie(nullptr);
//        cout.tie(nullptr);
//    #endif // MY
//    string s;
//    cin >> s;
//    int n = int(s.size());
//    vector <int> a(n);
//    for (int i = 0; i < n; ++i) {
//        a[i] = s[i] - '0';
//    }
//    int s1 = 0;
//    int s2 = 0;
//    for (int i = 0; i < n - 1; ++i) {
//        s1 += a[i];
//        s2 += a[n - 1 - i];
//        cnt[s1 - s2]++;
//    }
//    pair <int, int> nw = {0, 0};
//    for (int i = 0; i < n - 1; ++i) {
//        s1 -= a[i];
//        s2 -= a[n - 1 - i];
//        nw = {nw.first + a[i], nw.second + a[n - 1 - i]};
//        cnt[nw.first - nw.second]--;
//    }
//    return 0;
//}


#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = ll(1e9 + 7);

ll len(ll x) {
    ll res = 0;
    while (x > 0) {
        res++;
        x /= 10;
    }
    return res;
}

int main() {
    #ifdef MS
        freopen("f.in", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    #endif // MS
    ll n;
    cin >> n;
    vector <ll> pw(10, 1LL);
    for (ll i = 1; i < 10; ++i) {
        pw[i] = (pw[i - 1] * 10) % MOD;
    }
    vector <ll> a(10, ll(0)), b(n);
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
        a[len(b[i])]++;
    }
    ll res = 0;
    for (ll i = 0; i < n; ++i) {
        res = (res + b[i] * (n - 1)) % MOD;
        for (ll j = 0; j < 10; ++j) {
            ll x = 0;
            if (len(b[i]) == j) {
                x = -1;
            }
            res = (res + ((b[i] * pw[j]) % MOD) * (a[j] + x)) % MOD;
        }
    }
    cout << res;
    return 0;
}
