#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

const long long maxn = 4000001;

vector <long long> primes;

bool p[2*maxn];
long long ts[20], a, b, res = 0;

void pc(){
    ts[0] = 1;
    for (long long i = 1; i <= 18; i++){
        ts[i] = ts[i - 1] * 10;
    }
    for (long long i = 2; i < maxn; i++){
        p[i] = 1;
    }
    for (long long i = 2; i < maxn; i++){
        if (p[i]) {
            primes.push_back(i);
            for (long long j = i * i; j < maxn; j += i) {
                p[j] = 0;
            }
        }
    }
}

bool isprime(long long x){
    for (long long i = 0; i < primes.size(); i++){
        if (primes[i]*primes[i] > x){
            return true;
        }else{
            if (x % primes[i] == 0){
                return false;
            }
        }
    }
}

vector <long long> g[20];

int main() {
    pc();
    ios::sync_with_stdio(0);
    cin >> a >> b;
    g[0].push_back(2);
    g[0].push_back(3);
    g[0].push_back(5);
    g[0].push_back(7);
    for (long long i = 1; i <= 11; i++){
        for (long long j = 1; j <= 9; j++){
            for (long long k = 0; k < g[i - 1].size(); k++){
                long long t = j * ts[i] + g[i - 1][k];
                if (isprime(t)){
                    g[i].push_back(t);
                }
            }
        }
    }
    for (long long i = 0; i <= 11; i++){
        for (long long j = 0; j < g[i].size(); j++){
            if((g[i][j] >= a)&&(g[i][j] <= b)){
                res++;
            }
        }
    }
    cout << res;
    return 0;
}