#include<bits/stdc++.h>
#define F first
#define S second
#define pii pair<int,int>
using namespace std;

inline pair<string,string> split(const string &s)
{
    for(int i = 0; i < s.size(); i++)
    {
        if(s[i] == '=')
        {
            return {s.substr(0, i), s.substr(i + 1, s.size() - i - 1)};
        }
    }
    return {"", ""};
}

inline bool isstr(const string &s){
    for(int i = 0; i < s.size(); i++){
        if(s[i] >= 'a' && s[i] <= 'z') return 1;
    }
    return 0;
}

inline void solve()
{
    unordered_map<string, stack<string>> m;
    string s;
    while(cin>>s)
    {
        if(s == "{")
        {
            for(auto it : m)
            {
                if(it.second.size())m[it.first].push(it.second.top());
            }
        }
        else if(s == "}")
        {
            for(auto it : m)
            {
                if(!it.second.empty())m[it.first].pop();
            }
        }
        else
        {
            pair<string,string> q = split(s);
            if(isstr(q.second))
            {
                if(q.F != q.S)
                {
                    if(m[q.second].empty())
                    {
                       if(!m[q.F].empty()) m[q.F].pop();
                        m[q.F].push("0");
                    }
                    else
                    {
                        if(!m[q.F].empty()) m[q.F].pop();
                        m[q.F].push(m[q.second].top());
                    }
                }
                if(!m[q.F].empty())cout<<m[q.F].top()<<"\n";
                else cout<<"0\n";
            }
            else
            {
                if(!m[q.F].empty()) m[q.F].pop();
                m[q.F].push(q.second);
            }
        }
    }

}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
    return 0;
}

/*
a=b
b=123
var=b
b=-34
{
c=b
b=100000
d=b
{
a=b
e=var
}
}
b=b
*/
