#include<bits/stdc++.h>
#define F first
#define S second
#define pii pair<int,int>
using namespace std;

inline pair<string,string> split(const string &s)
{
    for(int i = 0; i < s.size(); i++)
    {
        if(s[i] == '=')
        {
            return {s.substr(0, i), s.substr(i + 1, s.size() - i - 1)};
        }
    }
    return {"", ""};
}

inline bool isstr(const string &s)
{
    for(int i = 0; i < s.size(); i++)
    {
        if(s[i] >= 'a' && s[i] <= 'z') return 1;
    }
    return 0;
}

inline void solve()
{
    unordered_map<string, stack<string>> m;
    unordered_map<string, stack<int>> last;
    string s;
    int bal = 1;
    while(cin>>s)
    {
        if(s == "{")
        {
            bal++;
        }
        else if(s == "}")
        {
            bal--;
        }
        else
        {
            pair<string,string> q = split(s);
            if(isstr(q.second))
            {
                if(q.F != q.S)
                {
                    while (last[q.F].size() && last[q.F].top() > bal)
                    {
                        last[q.F].pop();
                        m[q.F].pop();
                    }
                    if (last[q.F].size() == 0 || last[q.F].top() < bal)
                    {
                        if(m[q.F].size() == 0)
                        {
                            m[q.F].push("0");
                        }
                        else
                        {
                            m[q.F].push(m[q.F].top());
                        }
                        last[q.F].push(bal);
                    }
                    while (last[q.S].size() && last[q.S].top() > bal)
                    {
                        last[q.S].pop();
                        m[q.S].pop();
                    }
                    if (last[q.S].size() == 0 || last[q.S].top() < bal)
                    {
                        if(m[q.S].size() == 0)
                        {
                            m[q.S].push("0");
                        }
                        else
                        {
                            m[q.S].push(m[q.S].top());
                        }
                        last[q.S].push(bal);
                    }
                    m[q.F].pop();
                    m[q.F].push(m[q.S].top());
                }
                else
                {
                    while (last[q.F].size() && last[q.F].top() > bal)
                    {
                        last[q.F].pop();
                        m[q.F].pop();
                    }
                    if (last[q.F].size() == 0 || last[q.F].top() < bal)
                    {
                        if(m[q.F].size() == 0)
                        {
                            m[q.F].push("0");
                        }
                        else
                        {
                            m[q.F].push(m[q.F].top());
                        }
                        last[q.F].push(bal);
                    }
                }
                cout << m[q.F].top() << endl;
            }
            else
            {
                while (last[q.F].size() && last[q.F].top() > bal)
                {
                    last[q.F].pop();
                    m[q.F].pop();
                }
                m[q.F].push(q.S);
                last[q.F].push(bal);
            }
        }
    }

}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--)
    {
        solve();
    }
    return 0;
}

/*
a=b
b=123
var=b
b=-34
{
c=b
b=100000
d=b
{
a=b
e=var
}
}
b=b
*/
