#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>
#include<queue>
#include<deque>
#include<time.h>
#include<string>
#include<stack>

using namespace std;

/* ^(0,0)^ */

const long long maxn = 1e6 + 113;
set<long long> q;
vector<long long> po;
bool used[maxn];

bool prov(long long t)
{
	if (t < 2)
		return false;
	/*r (int i = 2; i * i < t; i++)
		if (t % i == 0)
			return false;
	return true;*/
	for (int i = 0; i < po.size(); i++)
	{
		if (po[i] * po[i] > t)
			return true;
		if (t % po[i] == 0)
			return false;
	}
	return true;
}

void perebor(long long a, long long t)
{
	if (t > 1e11)
		return;
	q.insert(a);
	for (long long i = 1; i <= 9; i++)
	{
		if (prov(a + t * i))
			perebor(a + t * i, t * 10);
	}
}

int main()
{
	srand(time(NULL));
	ios_base::sync_with_stdio();
	cin.tie(NULL);
	//cout.setf(ios::fixed);
	//cout.precision(1);
	used[1] = 1;
	for (long long i = 2; i <= 5e5; i++)
	{
		if (!used[i])
		{
			for (long long t = i * i; t <= 5e5; t += i)
				used[t] = 1;
		}
	}
	for (long long i = 2; i <= 5e5; i++)
		if (!used[i])
			po.push_back(i);
	perebor(0, 1);
	long long ans = 0;
	long long a, b;
	cin >> a >> b;
	for (auto it : q)
	{
		if (it >= a && it <= b)
			ans++;
	}
	cout << ans;
}