#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <deque>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <cmath>

#define ad push_back
#define mp make_pair
#define all(v) (v).begin(),(v).end()


using ll = long long;
using ld = long double;

using namespace std;
const int N = 1000 * 1000 + 7;
const ll mod = 1000 * 10 * 1000 + 7;
const ll linf = mod*mod;

int a[N];
vector<int> v;
ll solve_for1(int L ,int R, pair<int, int> mas) {
	if (R < L)return 0;
	ll ans = 0;
	for (int i = L; i <= R;++i) {
		int to = v[i];
		mas.second--; ans += abs(mas.first - to);
	}
	if (mas.second < 0)return linf;
	return ans;
}
ll solve_for2(int L,int R, pair<int,int> m1,pair<int,int> m2) {
	if (R < L)return 0ll;
	ll  ans = 0;
	while (L < v.size() && m1.first >= v[L]&&m1.second>0) {
		m1.second--;
		ans += m1.first - v[L];
		L++;
	}
	if (L == v.size())return ans;
	if (m1.second == 0) {
		return ans + solve_for1(L, R, m2);
	}
	while (R >= L&&m2.first <= v[R] && m2.second > 0) {
		m2.second--;
		ans += v[R] - m2.first;
		R--;
	}
	if (R == L - 1)return ans;
	if (m2.second == 0) {
		return ans + solve_for1(L, R, m1);
	}
	int l=L, r=R;
	while (r- l > 3) {
		int ml = l + (r - l) / 3;
		int mr = r - (r - l) / 3;
		if (solve_for1(L, ml, m1) + solve_for1(ml + 1, R, m2) > solve_for1(L, mr, m1) + solve_for1(mr+1, R, m2)) {
			l= ml;
		}
		else r = mr;
	}
	ll f = linf;
	for (int i = l; i <= r; ++i) {
		f = min(f, solve_for1(L, i, m1) + solve_for1(i + 1, R, m2));
	}
	return f + ans;
}
ll solve_for3(int L,int R,pair<int,int> m1,pair<int,int> m2,pair<int,int> m3) {

	ll  ans = 0;
	while (L < v.size() && m1.first >= v[L] && m1.second>0) {
		m1.second--;
		ans += m1.first - v[L];
		L++;
	}
	if (L == v.size())return ans;
	if (m1.second == 0) {
		return ans + solve_for2(L, R, m2,m3);
	}
	while (R >= L&&m3.first <= v[R] && m3.second > 0) {
		m3.second--;
		ans += v[R] - m3.first;
		R--;
	}
	if (R == L - 1)return ans;
	if (m3.second == 0) {
		return ans + solve_for2(L, R, m1,m2);
	}
	int l = L, r = R;
	int mid = L;
	while (l <= r) {
		int m = (l + r) / 2;
		if (v[m] >= m1.first) {
			mid = m;
			r = m - 1;
		}
		else l = m + 1;
	}
	l = mid;
	r = R;

	while (r - l > 3) {
		int ml = l + (r - l) / 3;
		int mr = r - (r - l) / 3;
		if (solve_for2(L, ml, m1,m2) + solve_for1(ml + 1, R, m3) > solve_for2(L, mr, m1,m2) + solve_for1(mr+1, R, m3)) {
			l = ml;
		}
		else r = mr;
	}
	ll f = linf;
	for (int i = l-1; i <= r; ++i) {
		f = min(f, solve_for2(L, i, m1,m2) + solve_for1(i + 1, R, m3));
	}
	return f + ans;
	
}
int main()
{
	ios_base::sync_with_stdio(false);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	vector<pair<int, int>> mas;
	for (int i = 0; i < 3; ++i) {
		pair<int, int> q;
		scanf("%d%d", &q.first, &q.second);
		mas.ad(q);
	}
	sort(all(mas));
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int u;
		scanf("%d", &u);
		v.ad(u);
	}
	sort(all(v));
	cout << solve_for3(0,n-1,mas[0],mas[1],mas[2])<<endl;
	
	
	return 0;
}
