#include<iostream>
#include<string>
#include<vector>
using namespace std;
vector<pair<string,vector<int>>> vars;
int deep;
pair<string,string> getVars(string e)
{
	int n = e.length();
	string s1 = "", s2 = "";
	bool b = false;
	for (int i = 0; i < n; i++)
	{
		if (e[i] == '=')
		{
			b = true;
			continue;
		}
		if (b)
		{
			s2.push_back(e[i]);
		}
		else
		{
			s1.push_back(e[i]);
		}
	}
	return make_pair(s1, s2);
}
int parse(string s)
{
	int n = s.length();
	int a = 0,p=1;
	for (int i = 0; i < n; i++)
	{
		if (s[n-i-1] != '-')
		{
			a += (s[n - i - 1] - '0')*p;
			p *= 10;
		}
		else
		{
			a *= -1;
			break;
		}
	}
	return a;
}
pair<int, int> varToVar(string e)
{
	string s1 = "", s2 = "";
	int n = e.length();
	bool b = false;
	for (int i = 0; i < n; i++)
	{
		if (e[i] == '=')
		{
			b = true;
			continue;
		}
		if (b)
		{
			s2.push_back(e[i]);
		}
		else
		{
			s1.push_back(e[i]);
		}
	}
	bool b1 = false, b2 = false;
	pair<int, int> p;
	p.first = -1;
	p.second = -1;
	for (int i = 0; i < vars.size(); i++)
	{
		if (!b1)
		{
			if (vars[i].first == s1)
			{
				p.first = i;
				b1 = true;
			}
		}
		if (!b2)
		{
			if (vars[i].first == s2)
			{
				p.second = i;
				b2 = true;
			}
		}
		if (b1&&b2)break;
	}
	return p;
}
pair<int, int> numberToVar(string e)
{
	string s1 = "", s2 = "";
	int n = e.length();
	bool b = false;
	for (int i = 0; i < n; i++)
	{
		if (e[i] == '=')
		{
			b = true;
			continue;
		}
		if (b)
		{
			s2.push_back(e[i]);
		}
		else
		{
			s1.push_back(e[i]);
		}
	}
	int v = parse(s2);
	pair<int,int> p;
	p.first = -1;
	bool b1 = false;
	for (int i = 0; i < vars.size(); i++)
	{
		if (!b1)
		{
			if (vars[i].first == s1)
			{
				p.first = i;
				b1 = true;
			}
		}
		else
		{
			break;
		}
	}
	p.second = v;
	return p;
}
int main()
{
	string s = "";
	while (cin >> s)
	{
		if (s[0] == '{')
		{
			deep++;
			for (int i = 0; i < vars.size(); i++)
			{
				vars[i].second.push_back(vars[i].second.back());
			}
		}
		else if (s[0] == '}')
		{
			deep--;
			for (int i = 0; i < vars.size(); i++)
			{
				if(!vars[i].second.empty())
				vars[i].second.pop_back();
			}
		}
		else
		{
			pair<string, string> v = getVars(s);
			if (s.back() >= '0' && s.back() <= '9')
			{
				pair<int, int> p = numberToVar(s);
				if (p.first == -1)
				{
					vector<int> values;
					values.push_back(p.second);
					vars.push_back(make_pair(v.first, values));
				}
				else
				{
					vars[p.first].second.pop_back();
					vars[p.first].second.push_back(p.second);
				}
			}
			else
			{
				pair<int, int> p = varToVar(s);
				if (p.first == -1)
				{
					vector<int> values;
					if (p.second == -1)
					{
						values.push_back(0);
					}
					else
					{
						values.push_back(vars[p.second].second.back());
					}
					vars.push_back(make_pair(v.first, values));
					cout << values.back() << endl;
				}
				else
				{
					int val = 0;
					if (p.second != -1)
					{
						val = vars[p.second].second.back();
					}
					vars[p.first].second.pop_back();
					vars[p.first].second.push_back(val);
					cout << val << endl;
				}
			}
		}
	}
}