#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 2e5 + 5;

ll dist[MAXN];
vector<pii> graph[MAXN];

vector<int> graph2[MAXN];

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n;
    scanf("%d", &n);

    assert(n <= 100000);

    vector<tuple<int, int, int>> edges;

    for (int i = 0; i < n - 1; ++i) {
        int u, v, l;
        scanf("%d%d%d", &u, &v, &l);
        --u; --v;
        edges.puba(make_tuple(u, v, l));
        graph[u].puba({v, l});
        graph[v].puba({u, l});
    }
    
    int m;
    scanf("%d", &m);

    fill(dist, dist + n, INFL);
    set<pair<ll, int>> st;

    for (int i = 0; i < m; ++i) {
        int num;
        scanf("%d", &num);
        --num;
        dist[num] = 0;
        st.insert({0, num});
    }

    while (szof(st)) {
        int v = st.begin()->ss;
        st.erase(st.begin());
        for (pii to : graph[v]) {
            if (dist[to.ff] > dist[v] + to.ss) {
                st.erase({dist[to.ff], to.ff});
                dist[to.ff] = dist[v] + to.ss;
                st.insert({dist[to.ff], to.ff});
            }
        }
    }

    /*
    for (int i = 0; i < n; ++i) {
        cerr << i + 1 << " " << dist[i] << endl;
    }
    */

    vector<pair<ll, int>> order;

    for (int i = 0; i < n; ++i) {
        order.puba({dist[i] * 2, i});
    }

    int cnt = n;
    for (auto e : edges) {
        int u, v, l;
        tie(u, v, l) = e;
        if (abs(dist[u] - dist[v]) < l) {
            ll pos = max(0ll, dist[v] - dist[u]) * 2 + (l - abs(dist[v] - dist[u]));
            assert(dist[u] * 2 + pos == dist[v] * 2 + (l * 2 - pos));
            graph2[cnt].puba(u);
            graph2[cnt].puba(v);
            graph2[v].puba(cnt);
            graph2[u].puba(cnt);
            order.puba({dist[u] * 2 + pos, cnt});
            ++cnt;
        } else {
            graph2[u].puba(v);
            graph2[v].puba(u);
        }
    }

    sort(bend(order));

    int cur = 1;
    int ans = 0;
    vector<bool> dead(cnt);
    ll prev = -1;

    for (auto p : order) {
        //cerr << p.ff << " " << p.ss << endl;
        if (prev != p.ff) {
            ans = max(ans, cur);
            prev = p.ff;
        }
        --cur;
        dead[p.ss] = 1;

        for (int to : graph2[p.ss]) {
            if (!dead[to]) {
                ++cur;
            }
        }
        //cerr << cur << endl;
    }

    cout << ans << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}